dojo.provide('ibm_ilog.graphlayout.AbstractGraphLayoutModel');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

//dojo.require("ibm_ilog.graphlayout.GraphLayout");
dojo.require("ibm_ilog.graphlayout.internalutil.LinkStyles");

ibm_ilog.graphlayout.ReshapeLinkMode = {
    IGNORE: 0,
    MOVE: 1,
    FIX: 2,
    CLIP: 3,
    MOVE_AND_CLIP: 4
};

ibm_ilog.graphlayout.ReshapeLinkStyle = {
    IGNORE: ibm_ilog.graphlayout.internalutil.LinkStyles.NO_RESHAPE_STYLE,
    STRAIGHT: ibm_ilog.graphlayout.internalutil.LinkStyles.STRAIGHT_LINE_STYLE,
    ORTHOGONAL: ibm_ilog.graphlayout.internalutil.LinkStyles.ORTHOGONAL_STYLE,
    POLYLINE: ibm_ilog.graphlayout.internalutil.LinkStyles.POLYLINE_STYLE,
    DIRECT: ibm_ilog.graphlayout.internalutil.LinkStyles.DIRECT_STYLE
};

dojo.declare('ibm_ilog.graphlayout.AbstractGraphLayoutModel', null, {
    _statics: {
        _uniqueIdCounter: -1,
        _rootModelPropertyName: "__RootModel"
    },
    _attachedLayouts: null,
    _nodeOrLinkProperties: null,
    _properties: null,
    _rootModel: null,
    _isDisposed: null,
    _subgraphModelPropertyName: null,

    constructor: function() {
        this._isDisposed = false;
        var id = this._statics._uniqueIdCounter++;
        this.initPropertyNames(id);
    },
    initPropertyNames: function(id) {
        this._subgraphModelPropertyName = this.getParameterName("__SubgraphModel", id);
    },
    getParameterName: function(name, id) {
        var n = name + id;
        return n;
    },
    dispose: function() {
        if (!this._isDisposed) {
            this.disposeChildren();
            this.disposeThis();
        }
    },
    disposeThis: function() {
        if (this._isDisposed) {
            return;
        }
        this._isDisposed = true;
        this.detachLayouts();
        this.cleanSubmodelProperty();
        this._nodeOrLinkProperties = null;
        this._properties = null;
        this._rootModel = null;
    },
    cleanSubmodelProperty: function() {
        var rootModel = this.getRoot();
        if (rootModel !== null) {
            var parentModel = getParent();
            if (parentModel !== null) {
                var subgraphs = parentModel.getSubgraphs();
                var subModel;
                dojo.forEach(subgraphs, function(subgraph) {
                    subModel = rootModel.getStoredGraphModel(subgraph);
                    if (subModel === this) {
                        rootModel.removeStoredGraphModel(subgraph);
                    }
                }, this);
            }
        }
    },
    detachLayouts: function() {
        if (this._attachedLayouts === null) {
            return;
        }
        var layouts = this._attachedLayouts;
        var n = layouts.length;
        for (var i = 0; i < n; i++) {
            var layout = layouts[i];
            if (layout.getGraphModel() === this) {
                layout.detach();
            }
        }
    },
    disposeChildren: function() {
        if (this._isDisposed) {
            return;
        }

        var rootModel = this.getRoot() !== null ? this.getRoot() : this;
        var subgraphs = this.getSubgraphs();
        var subGraphModel;
        dojo.forEach(subgraphs, function(subgraph) {
            subGraphModel = rootModel.getStoredGraphModel(subgraph);
            if (subGraphModel !== null) {
                subGraphModel.dispose();
            }
            rootModel.removeStoredGraphModel(subgraph);
        });
    },
    isDisposed: function() { return this._isDisposed; },
    onAttach: function(layout) {
        if (this._attachedLayouts === null) {
            this._attachedLayouts = [];
        }
        if (dojo.indexOf(this._attachedLayouts, layout) < 0) {
            this._attachedLayouts.push(layout);
        }
    },
    onDetach: function(layout) {
        if (this._attachedLayouts === null) {
            return;
        }
		var index = dojo.indexOf(this._attachedLayouts, layout);
		if(index >= 0)
			this._attachedLayouts.splice(index, 1);
        if (this._attachedLayouts.length === 0) {
            this._attachedLayouts = null;
        }
    },
    getParent: function() { },
    getRoot: function() { return this._rootModel; },
    setRootModel: function(rootModel) { this._rootModel = rootModel; },
    storeGraphModel: function(subgraph, graphModel) {
        if (graphModel === this) {
            throw { name: 'ArgumentException', message: "The root model cannot be reused for subgraphs" };
        }
        this.setParameter(subgraph, this._subgraphModelPropertyName, graphModel);
        if (graphModel !== null) {
            graphModel.setRootModel(this);
        }
    },
    removeStoredGraphModel: function(subgraph) {
        this.setParameter(subgraph, this._subgraphModelPropertyName, null);
    },
    getStoredGraphModel: function(subgraph) {
        return this.getParameter(subgraph, this._subgraphModelPropertyName);
    },
    getGraphModel: function(subgraph) {
        if (subgraph === null) {
            throw { name: 'ArgumentException', message: "subgraph cannot be null" };
        }
        if (this.isDisposed()) {
            throw { name: 'Exception', message: "Called on disposed model: " + this };
        }
        var rootModel = this.getRoot();
        if (rootModel !== null) {
            if (rootModel.isDisposed()) {
                throw { name: 'Exception', message: "root model of " + this + " is disposed" };
            }
            return rootModel.getGraphModel(subgraph);
        }
        var graphModel = this.getStoredGraphModel(subgraph) || null;
        if (graphModel === null) {
            this.setParameter(subgraph, this._statics._rootModelPropertyName, this);
            graphModel = this.createGraphModel(subgraph);
            this.setParameter(subgraph, this._statics._rootModelPropertyName, null);
            if (graphModel === null) {
                throw { name: 'Exception', message: "createGraphModel returned null on " + this +
                          " for subgraph: " + subgraph
                };
            }
            if (graphModel.isDisposed()) {
                throw { name: 'Exception', message: "createGraphModel returned a disposed model: " +
                          graphModel + " on " + this +
                          " for subgraph: " + subgraph
                };
            }
			var parentGraphModel = graphModel.getParent();
            if (parentGraphModel !== null && !parentGraphModel.isNode(subgraph)) {
                throw { name: 'ArgumentException', message: "The subgraph must be a node in the parent graph model" };
            }
            this.storeGraphModel(subgraph, graphModel);
        } else if (graphModel.isDisposed()) {
            throw { name: 'Exception', message: "The graph model " + graphModel + " stored for " +
                            subgraph + " on " + this + " is disposed"
            };
        }
        return graphModel;
    },
    createGraphModel: function(subgraph) { },
    getNodes: function() { },
    getLinks: function() { },
    getSubgraphs: function() { return []; },
    getIntergraphLinks: function() { return []; },
    getLinksFrom: function(node) { },
    getLinksTo: function(node) { },
    getNodesCount: function() { return this.getNodes().length; },
    getLinksCount: function() { return this.getLinks().length; },
    getIntergraphLinksCount: function() { return this.getIntergraphLinks().length; },
    getSubgraphsCount: function() { return this.getSubgraphs().length; },
    getLinksFromCount: function(node) { return this.getLinksFrom(node).length; },
    getLinksToCount: function(node) { return this.getLinksTo(node).length; },
    getFrom: function(link) { },
    getTo: function(link) { },
    isNode: function(o) { },
    isLink: function(o) { },
    isIntergraphLink: function(o) { return false; },
    isSubgraph: function(o) { return false; },
    isLayoutNeeded: function(layout) { return true; },
    beforeLayout: function(layout) { },
    afterLayout: function() { },
	
    setParameter: function(nodeOrLink, key, val) {
        if (arguments.length == 3) {
            if (val) {
                nodeOrLink[key] = val;
            } else {
                delete nodeOrLink[key];
            }
        } else {
			val = key;
			key = nodeOrLink;
            if (val) {
                this[key] = val;
            } else {
                delete this[key];
            }
        }
    },
    getParameter: function(nodeOrLink, key) {
        if (arguments.length == 2) {
            return nodeOrLink[key];
        } else {
			key = nodeOrLink;
            return this[key];
        }
    },
	
    contentsChanged: function(sender, args) { },

    fireEvent: function(nodeOrLink, eventType, updating) {
        var evt;
        if (arguments.length > 1) {
            if (updating) {
                this._eventTypesDuringAdjSession |= eventType;
            }
            if (updating) {
                eventType |= ibm_ilog.graphlayout.GraphModelContentsChangedEventAction.Updating;
            }
            // just to be sure
            eventType &= ~ibm_ilog.graphlayout.GraphModelContentsChangedEventAction.EndUpdate;
            evt = new ibm_ilog.graphlayout.GraphModelContentsChangedEventArgs(this, eventType, nodeOrLink);
        } else {
            evt = nodeOrLink; //1st arg
        }
        this.contentsChanged(this, evt);
    },
    beginUpdate: function() {
        var eventType = ibm_ilog.graphlayout.GraphModelContentsChangedEventAction.BeginUpdate;
        var evt = new ibm_ilog.graphlayout.GraphModelContentsChangedEventArgs(this, eventType, null);
        this.fireEvent(evt);
    },
    endUpdate: function() {
        var eventType = ibm_ilog.graphlayout.GraphModelContentsChangedEventAction.EndUpdate |
                      this._eventTypesDuringAdjSession;

        eventType &= ~ibm_ilog.graphlayout.GraphModelContentsChangedEventAction.Updating;

        var evt = new ibm_ilog.graphlayout.GraphModelContentsChangedEventArgs(this, eventType, null);
        this._eventTypesDuringAdjSession = 0;
        this.fireEvent(evt);
    },

    moveNode: function(node, x, y) { },
    boundingBox: function(nodeOrLink) { },
    getLinkPoints: function(link) { },
	getLinkPointAt: function(link, index) { return this.getLinkPoints()[index]; },
    reshapeLink:function(link, style, fromPoint, fromPointMode,
                         points, startIndex, length,
                         toPoint, toPointMode) { },
    hasMoveableConnectionPoint: function(link, origin) { return true; },
    hasPinnedConnectionPoint: function(link, origin) { return false; },
    getLinkWidth: function(link) { return 1; },
    
	setContentsAdjusting : function() {},
	
	saveAndEnableViewCoordinates: function(rootModel){},
	restoreAndDisableViewCoordinates: function(){},
	
	getTransform: function(subModel) { return null; }
});
