/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.dsv.editor.behavior.EcoreModel");

/**
 * Wraps an EPackage model with predefined queries.
 * 
 * @author Marc Gobeil
 */
dojo.declare("rmpw.dsv.editor.behavior.EcoreModel", null, {
	/**
	 * options:
	 * 		ePackage: required, the ePackage to wrap
	 */
	constructor: function(options) {
		dojo.mixin(this, options);
		
		// index eClassifiers by name
		var eClassIndex = this._eClassIndex = {};
		var eClassifiers = this.ePackage.eClassifiers;
		for(var i = 0, eClass; eClass = eClassifiers[i]; i++) {
			eClassIndex[eClass.name] = eClass;
		}
	},
	
	getClassByName: function(name) {
		return this._eClassIndex[name];
	},
	
	/**
	 * TODO (MG): commented parts are how this should be implemented, but cross package
	 * references aren't resolved properly.
	 */
	getSubClassesOf: function(baseClass) {
//		if(dojo.isString(baseClass)) {
//			baseClass = this._eClassIndex[baseClass];
//		}
		
		return dojo.filter(this.ePackage.eClassifiers, function(eClassifier) {
			if(eClassifier.eAllSuperTypes) {
				return dojo.some(eClassifier.eAllSuperTypes, function(eSuperType) {
					// return eSuperType == baseClass;
					return eSuperType.name == baseClass;
				});
			}
		});
	}
});