dojo.provide('ibm_ilog.graphlayout.ILayoutProvider');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.ILayoutProvider', null, 
{
  // summary:
  //		An interface used to specify the layout instance to be used for
  //		laying out a given graph. 
  // description:
  //		An interface used to specify the layout instance to be used for
  //		laying out a given graph. 
  //		<p>
  //		This is an advanced API. In Dojo Diagrammer, you specify the layout
  //		to use for a specific Subgraph by calling
  //		<code>ibm&#95;diagram.Subgraph.setNodeLayout(layout)</code> or
  //		<code>ibm&#95;diagram.Subgraph.setLinkLayout(layout)</code>.    
  //		</p>
  
  getGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance to be used for laying out
    //		'graphModel'. 
    // description:
    //		Returns the layout instance to be used for laying out
    //		<code>graphModel</code>. 
    //		The layout instance that is returned must be attached to
    //		<code>graphModel</code> via the method <code>
    //		ibm&#95;ilog.graphlayout.GraphLayout.attach()</code> .  
    //		<p>
    //		Note that this method must return a different layout instance for
    //		each subgraph. The same layout instance should not be returned for
    //		two different subgraphs of the same graph. Also, the layout instance
    //		returned for a subgraph should not be the same as the one returned
    //		for the topmost graph.   
    //		</p>
    //		<p>
    //		This method is called during the recursive layout of a nested graph
    //		. If the method returns <code>null</code>, this means that no layout
    //		is needed for <code>graphModel</code>.    
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model (eventually the graph model that
    //		encapsulates the topmost grapher).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is need for 'graphModel'.
    
  }
  
});
