dojo.provide('ibm_ilog.graphlayout.ISubgraphCorrection');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.ISubgraphCorrection', null, 
{
  // summary:
  //		An interface used to define corrections of a subgraph after the
  //		layout of the subgraph was performed.
  
  correct : function(subgraph, layout, boundingBox, redraw)
  {
    // summary:
    //		Allows you to correct the subgraph after the nodes and links of the 
    //		subgraph were laid out. 
    // description:
    //		Allows you to correct the subgraph after the nodes and links of the 
    //		subgraph were laid out. 
    //		This is called by the Recursive Layout (see <code>
    //		RecursiveLayout</code>) immediately after the layout of the subgraph
    //		has finished. Usually, a correction of the position of the subgraph
    //		can be done; therefore the former bounding box of the subgraph is
    //		passed.  
    //		<p>
    //		The former bounding box is calculated by the parent graph model of
    //		the graph model attached to the input layout. Depending on the
    //		coordinates mode of that graph model, the bounding box is either
    //		given in view coordinates or in manager coordinates.  
    //		</p>
    //		<p>
    //		 
    //		</p>
    // subgraph: Object
    //		The subgraph that has been laid out.
    //		layout: 
    //		       ibm_ilog.graphlayout.GraphLayout
    //		The layout that has been performed on the subgraph.
    // boundingBox: Rectangle
    //		The former bounding box of the subgraph at the point
    //		in time before the layout.
    // redraw: Boolean
    //		The redraw flag passed to the layout.
    
  }
  
});
