dojo.provide('ibm_ilog.graphlayout.RecursiveLayoutProvider');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.DefaultLayoutProvider');

dojo.declare('ibm_ilog.graphlayout.RecursiveLayoutProvider', ibm_ilog.graphlayout.DefaultLayoutProvider, 
{
  // summary:
  //		The internal layout provider used by the Recursive Layout in internal
  //		provider mode. 
  // description:
  //		The internal layout provider used by the Recursive Layout in internal
  //		provider mode. 
  //		<p>
  //		The provider behaves like the <code>
  //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider</code> except that <code>
  //		RecursiveLayoutProvider.getGraphLayout()</code> returns
  //		<code>null</code> for a graph model that has no preferred layout. It
  //		<em>does not clone</em> the layout instance of the closest parent
  //		graph for which a layout has been set. This allows you to specify
  //		<code>null</code> as the  preferred layout for those subgraphs that
  //		should not be laid out at all.  
  //		</p>
  //		<p>
  //		If you allocate an instance of <code>RecursiveLayoutProvider</code>
  //		explicitly, you must call the method <code>
  //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider.detachLayouts()</code>
  //		when you no  longer need the layout provider instance; otherwise,
  //		some objects may not  be garbage collected. However <code>
  //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider.detachLayouts()</code> is
  //		automatically called for the internal layout provider of the
  //		Recursive Layout when the Recursive Layout is detached.   
  //		</p>
  
  constructor : function()
  {
  },
  
  getGraphLayout : function(graphModel)
  {
    // summary:
    //		Returns the layout instance to be used to lay out
    //		'graphModel'. 
    // description:
    //		Returns the layout instance to be used to lay out
    //		<code>graphModel</code>. 
    //		<p>
    //		It returns the preferred layout specified using <code>
    //		ibm&#95;ilog.graphlayout.DefaultLayoutProvider.setPreferredLayout()</code>.
    //		If no preferred layout was specified, the method returns
    //		<code>null</code>.    
    //		</p>
    // graphModel: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model (the graph model that encapsulates the
    //		topmost grapher , or a subgraph).
    // returns:
    //		The layout instance to be used for 'graphModel', or
    //		'null' if no layout is required for
    //		'graphModel'.
    
    return this.getPreferredLayout(graphModel); // ibm_ilog.graphlayout.GraphLayout
  }

}
);
