/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

var djConfig = { 
		parseOnLoad:false, 
		useGfxLayout:true,
		skipIeDomLoaded:true
}; 

var window = {
		attachEvent: function() {}, 
		document: document,
		addEventListener: function() {}}; 

var navigator = {
		userAgent: 'rhino', 
		appVersion: '1.7', 
		language: 'english'
};

var rhino_timeouts = {};
var rhino_timeoutID = 0;
var setTimeout = function( callback, time ) {
	var timeoutID = rhino_timeoutID + '';
	rhino_timeouts[timeoutID] = callback;
	rhino_timeoutID++;
	return timeoutID;
};

var clearTimeout = function( timeoutID ) {
	delete rhino_timeouts[timeoutID];
};

var processTimeouts = function() {
	// process in order of timeout ids
	for (var i=0; i<=rhino_timeoutID; i++) {
		var callback = rhino_timeouts[i + ''];
		if (callback) {
			try {
				callback();
			}
			catch (e) {
				console.log("ERROR: " + e.message);
			}
		}
	}
	
	rhino_timeouts = {};
	rhino_timeoutID = 0;
};