/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.diagram.actions.ShowView");

dojo.require("dojo.i18n");
dojo.require("rmps.app.ui.internal.pages.design.DesignUtil");
dojo.requireLocalization("rmps.diagram.actions", "Messages");
var messages = dojo.i18n.getLocalization("rmps.diagram.actions", "Messages");

dojo.declare("rmps.diagram.actions.ShowView", rmpw.diagrams.edit.actions.Action, {
	
	constructor: function() {
		this.text = messages.preview;
	},
	
	setZoneData: function( zonedata ){
		this.zonedata = zonedata;
		this.zonedata.opened = false;
	},
	
	run: function(args) {
		
		this.renderMapping = this.host.renderMapping;
		
		if( this.zonedata.hyperlink != null ){
			
			window.open(this.zonedata.hyperlink, "_blank");
			
		}else if( this.zonedata.id != null ){
 			var link = rmps.app.ui.internal.pages.design.DesignUtil.getEditResourceUri( this.zonedata.id );
    		if (this.zonedata.hasElement) {
    			window.location.href = link;
	    	} else {
	       		// if view had no element open property dialog instead-- otherwise nothing happens
				var popup = rmps.ui.properties.PropertiesPopup.show( { resourceUri: this.zonedata.id, linkHref: link } );  	
				this.renderMapping.root.policies.focusScope.disable();
				this.focusConnection = dojo.connect( popup, "hide", this, "enableFocus" );
				this.zonedata.opened = true;
				this.surfaceConnection = dojo.connect( this.renderMapping.__editMapping.viewer.diagram.__editMapping.viewer.surface._parent, "onmousedown", popup, "hide" );
    		}
		}	
	}
});

})();
