dojo.provide('ibm_ilog.diagram.adorners.AdornerHandle');
dojo.require('ibm_ilog.diagram.adorners.TemplatedOverlay');


(function() {

	ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.adorners.AdornerHandle',ibm_ilog.diagram.adorners.TemplatedOverlay,{
		
		initialize: function(adorner,template) {
			this._adorner = adorner;
			this._template = template;
			this.applyTemplate(this._template);
		},
		getAdorner: function(){
			return this._adorner;
		},
		getViewport: function() {
			return this._adorner.getViewport();
		},
		
		add: function(toShow){
			// Summary:
			//		if IE browser, restore the saved Styles
			this.inherited(arguments); 
			if (ibm_ilog.diagram.isVml) {
	             this._restoreStyles(toShow);
	         }
		},
		
		remove: function(toHide){
			// Summary:
			//		if IE browser, saves the Styles before removing the elements from its parent
			//		Workaround for IE: removing a shape clears all its styles.
			if (ibm_ilog.diagram.isVml) {
	                this._saveStyles(toHide);
	         }
			 this.inherited(arguments);
		},
		
		_saveStyles: function(group) {
	        // summary:
	        //		Workaround for IE: removing a shape clears all its styles.
	        // tags:
	        //		private
	        dojox.gfx.utils.forEach(group, function(shape) {
	            if (shape.setFill) {
	                shape.oldFill = shape.getFill();
	            }
	            if (shape.setStroke) {
	                shape.oldStroke = shape.getStroke();
	            }
	            if (shape.setFont) {
	                shape.oldFont = shape.getFont();
	            }
	            if (shape.setFont) {
	                shape.oldFont = shape.getFont();
	            }
	            if (shape.setShape) {
	                shape.oldShape = shape.getShape();
	            }
	        }, null);
	    },
	    
	    _restoreStyles: function(group) {
	        // summary:
	        //		Workaround for IE: removing a shape clears all its styles.
	        // tags:
	        //		private
	        dojox.gfx.utils.forEach(group, function(shape) {
	            if (shape.oldFill) {
	                shape.setFill(shape.oldFill);
	            }
	            if (shape.oldStroke) {
	                shape.setStroke(shape.oldStroke);
	            }
	            if (shape.oldFont) {
	                shape.setFont(shape.oldFont);
	            }
	            if (shape.oldShape) {
	                shape.setShape(shape.oldShape);
	            }
	        }, null);
	    }
		
	}));

})();
