dojo.provide('ibm_ilog.diagram.adorners.AdornerWithHandles');
dojo.require('ibm_ilog.diagram.adorners.Adorner');

(function () {

var sup = ibm_ilog.diagram.adorners.Adorner.prototype;

var a = ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.adorners.AdornerWithHandles', [ibm_ilog.diagram.adorners.Adorner], {

	//   
	//	_handles:
	//		The AdornerHandles created for the Adorner
	//
	_handles: null,
	
	initialize: function () {
		
		this._handles = new dojox.collections.ArrayList();
		sup.initialize.apply(this,arguments);
	},

	activate: function () {
		//
		// 	summary:
		//		activates all the adorner handles
		//
		this._handles.forEach(function (e) {
			e.activate();
		});
	},

	deactivate: function () {
		//
		// 	summary:
		//		deactivates all the adorner handles
		//
		this._handles.forEach(function (e) {
			e.deactivate();
		});
	},

	_activateHandle: function (attachPointName) {
		if (this[attachPointName] !== undefined) {
			this[attachPointName].activate();
		}
	},

	_deactivateHandle: function (attachPointName) {
		if (this[attachPointName] !== undefined) {
			this[attachPointName].deactivate();
		}
	},

	_createHandle: function (clazz, attachPointName) {
		if (this[attachPointName]) {
			var template = this._templatePool.item(this[attachPointName].template || clazz.templateId);
			var handle = this[attachPointName].createObject(clazz);
			handle.initialize(this, template);
			this[attachPointName] = handle;
			this._handles.add(handle);
			return handle;
		} else {
			return null;
		}
	},

__eod:undefined }));

})();