dojo.provide('ibm_ilog.diagram.adorners.AnnotationAdorner');

dojo.require('ibm_ilog.diagram.adorners.Adorner');
dojo.require('ibm_ilog.diagram.adorners.MoveAnnotationInteractor');

dojo.require('ibm_ilog.diagram.templates.templates');

(function() {

	var g = ibm_ilog.diagram.util.Geometry, Rect = g.Rect, EmptyRect = g.EmptyRect, Size = g.Size, PointZero = g.PointZero, Point = g.Point;
	var gu = ibm_ilog.diagram.util.GraphUtil;

ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.adorners.AnnotationTargetAdorner', [ibm_ilog.diagram.adorners.Adorner], {

	_link: null,
	
	setLink: function(link) {
		this._link = link;
	},
	
	_onChange: function() {
		if(this._link) {
			this._link.revalidateLinkShape(); // immediate
			this._link.invalidateLinkShape(); // .. and failproof
		}
	},

__eod: undefined}));


var sup = ibm_ilog.diagram.adorners.Adorner.prototype;

var a = ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.adorners.AnnotationAdorner', [ibm_ilog.diagram.adorners.Adorner], {
	//
	//	summary:
	//		An Adorner which displays node annotations
	//
	
	//
	//	annotationChangedEvent:
	//		The event to watch for associated with the annotation changing its value. 
	//
	annotationChangedEvent: "setAnnotation", 
	
	//
	//	annotationGetter:
	//		The method to invoke in the adorned entity to get the annotation. This is used in 
	//		the default implementation of refreshAnnotation. 
	//
	annotationGetter: "getAnnotation",
	
	
	_moveInteractor: null,
	
	initialize: function() {
		this.inherited(arguments);
		this._moveInteractor = new ibm_ilog.diagram.adorners.MoveAnnotationInteractor();
		this._moveInteractor.initialize(this._viewport,this);
		this._moveInteractor.setManager(this._diagram._interactors);
		
	},
	
	_reconnectNotifications: function() {
		//
		//	Add an additional connection to watch for "annotation changed" events.
		//
		ibm_ilog.diagram.adorners.Adorner.prototype._reconnectNotifications.apply(this,arguments);
		var e = this._adorned;
		if (e) {
			this.refreshAnnotation();
			this._changeConnections.push(dojo.connect(e,this.annotationChangedEvent,this,"refreshAnnotation"));
		}
	},
	
	refreshAnnotation: function(){
		//
		//	summary:
		//		Update receiver with a new annotation
		//	description:
		//		Current implementation relies on the template referencing 
		//		the "annotation" bindable property of the receiver.
		//		Can be overriden by subclasses to produce specific 
		//		ways of	rendering the annotation like word wrap, etc.
		//
		this.setAnnotation(this._adorned[this.annotationGetter]());
	},

	activate: function () {
		this._moveInteractor.activate();
	},

	deactivate: function () {
		this._moveInteractor.deactivate();
	},
	
	_link: null,
	_target: null,

	_updateLayout: function () {
		sup._updateLayout.apply(this,arguments);
	},
	
	setLink: function(link,target) {
		this._target = target;
		this._link = link;
	},
	
	getLink: function() {
		return this._link;
	},
	
	getTarget: function() {
		return this._target;
	},
	
	setAdorned: function(adorned) {
		this.inherited(arguments);
		if(this._target) {
			this._target.setAdorned(adorned);
		}
	},
	
	getBaseShape: function() {
		return this.baseShape;
	},
	
	destroy: function() {
		sup.destroy.apply(this,arguments);
	},
	
	_onChanged: function() {
		if(this._link) {
			this._link.revalidateLinkShape(); // immediate
			this._link.invalidateLinkShape(); // .. and failproof
		}
	},
	
__eod: undefined }));

ibm_ilog.diagram.templating.declareBindableProperty(a, "annotation", "");

})();
