dojo.provide('ibm_ilog.diagram.adorners.HighlightedHandle');

dojo.require('ibm_ilog.diagram.adorners.AdornerHandle');
dojo.require('ibm_ilog.diagram.util.HandleSet');

(function() {

	var gfxCon = ibm_ilog.diagram.util.HandleSet.gfxConnector;
	var gfxDis = ibm_ilog.diagram.util.HandleSet.gfxDisconnector;
	
	ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.adorners.HighlightedHandle',[ibm_ilog.diagram.adorners.AdornerHandle,ibm_ilog.diagram.util.HandleSet],{
		
		_interactors: null,
		
		_state: "",
		
		_hovered: false,
		
		_active: false,
		
		constructor: function(){
			this._interactors = [];
		},
		
		initialize: function(adorner,template) {
			this._adorner = adorner;
			this._template = template;
			this.applyTemplate(this._template);
			
			this.remove(this.stNormal);
			this.remove(this.stHighlighted);
			this.remove(this.stActive);
			
			this._active = false;
			this._hovered = false;
			
			this.refreshState();
		},

		interactionBegun: function(interactor) {
			this._active = true;
			this.refreshState();
		},

		interactionEnded: function(interactor) {
			this._active = false;
			this.refreshState();
		},

		changeState: function(stId) {
			if(this._state !== stId) {
				if(this[this._state])
					this.remove(this[this._state]);
				//console.log(stId)
				this._state = stId;
				if(this[this._state])
					this.add(this[this._state]);
			}
		},
		
		addInteractor: function(interactor){
			this._interactors.push(interactor);
			interactor.setManager(this._adorner._diagram._interactors);
		},

		refreshState: function() {
			if(this._active) {
				this.changeState("stActive");
			} else {
				if(this._hovered) {
					this.changeState("stHighlighted");
				} else {
					this.changeState("stNormal");
				}
			}
		},

		onMouseOver: function(){
			this._hovered = true;
			this.refreshState();
		},
		
		onMouseOut: function(){
			this._hovered = false;
			this.refreshState();
		},		
		
		activate:function() {
			this._active = false;
			this._hovered = false;
			this.changeState("stNormal");
			dojo.forEach(this._interactors,function(item){item.activate();});
			this._connect("hoverStart",this,"onmouseover",this,"onMouseOver",gfxCon,gfxDis);
			this._connect("hoverEnd",this,"onmouseout",this,"onMouseOut",gfxCon,gfxDis);
		},
		
		deactivate:function() {
			dojo.forEach(this._interactors,function(item){item.deactivate();});
			this.changeState("");
			this._disconnect("hoverStart");
			this._disconnect("hoverEnd");
		}
	}));
	
	/* This must be added in each class that implements this class
	 * 
	 * ibm_ilog.diagram.adorners.HighlightedHandle.templateId = "TemplateName";
	 */


})();
