dojo.provide('ibm_ilog.diagram.adorners.MoveAnnotationInteractor');

dojo.require('ibm_ilog.diagram.interactors.DragInteractor');

dojo.require('ibm_ilog.diagram.util.Geometry');

(function () {
	var g = ibm_ilog.diagram.util.Geometry;
	var m = dojox.gfx.matrix;

dojo.declare("ibm_ilog.diagram.adorners.MoveAnnotationInteractor", [ibm_ilog.diagram.interactors.DragInteractor], {

	initialize: function ( viewport, annotation ) {
		//
		//	summary:
		//		Initializes the interactor to work with the given handle
		//
		this._annotation = annotation;
		this._viewport = viewport;
		this._initialize();
		return this;
	},
	
	_getInitialEventSource: function () {
		return this._annotation;
	},

	_refreshTransform: function () {
		this._transform = this._annotation._adorned._getRealMatrix().inverse();
	},

	activate: function () {
		this.inherited(arguments);
	},

	_dragPreStart: function () {
		this._refreshTransform();
		this._connect("updateTransforms", this._viewport, "onViewRectChanged", this, "_refreshTransform");

		this.inherited(arguments);
	},

	_dragEnd: function () {
		this._disconnect("updateTransforms");
		var dragged = this.hasDragged, action, D;
		this.inherited(arguments);
	},

	_dragMove: function () {
		this.inherited(arguments);
		var t = this._annotation.getTransform();
		t = m.multiply(t,m.translate(this._delta))
		this._annotation.setTransform(t);
	}

});

})();