/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.sketch.behavior.TextDialog");

dojo.require("dijit.Dialog");

dojo.declare("rmpw.sketch.behavior.TextDialog", dijit.Dialog, {
	
	templateString: "<div class='dijitDialog' tabindex='-1' waiRole='dialog' waiState='labelledby-${id}_title'>" +
					"<div dojoAttachPoint='titleBar' style=\"height:0;visibility:'hidden'\">" +
					"<span dojoAttachPoint='titleNode' class='dijitDialogTitle' id='${id}_title'></span>" +
					"<span dojoAttachPoint='closeButtonNode' class='dijitDialogCloseIcon' dojoAttachEvent='onclick: onCancel' title='${buttonCancel}'>" +
					"<span dojoAttachPoint='closeText' class='closeText' title='${buttonCancel}'>x</span>" +
					"</span>" +
					"</div>" +
					"<div dojoAttachPoint='containerNode' class='dijitDialogPaneContent'></div>" +
					"</div>",
						
	anchorPoint: null,
	
	_size: function(){
		
	},
	
	postCreate: function(){
		dojo.style(this.domNode, {
			display: "none",
			position:"absolute"
		});
		this.anchorPoint.appendChild(this.domNode);

		this.inherited(arguments);

		this.connect(this, "onExecute", "hide");
		this.connect(this, "onCancel", "hide");
		this._modalconnects = [];
	},
	
	setPosition: function( leftPosition, topPosition, width ){

		if( width ){
			dojo.style(this.domNode,{
				position:"absolute",
				left: leftPosition,
				top: topPosition, 
				width: width
			});
		}else{
			dojo.style(this.domNode,{
				position:"absolute",
				left: leftPosition,
				top: topPosition
			});
		}
	},
	
	layout: function(){

	},
	
	_position: function(){
		this.setPosition( this.leftPosition, this.topPosition );
	},
	
	show: function( leftPosition, topPosition ){
		
		if(!this.open){
		
			dijit._dialogStack.push(this);
			
			this.leftPosition = leftPosition;
			this.topPosition = topPosition;
			
			return this.inherited( arguments );
		}
	}
	
});