dojo.provide('ibm_ilog.graphlayout.circular.clayout.AbstractGraph');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.circular.clayout.AbstractNode');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.LayoutUtil');

dojo.declare('ibm_ilog.graphlayout.circular.clayout.AbstractGraph', ibm_ilog.graphlayout.circular.clayout.AbstractNode, 
{
  // summary:
  //		An abstract graph. 
  // description:
  //		An abstract graph. 
  //		
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _nodes: null,
  _links: null,
  _voidIter: null,

  pickInfo : function(graph)
  {
    // summary:
    //		Reads some information from another graph and writes it in this one.
    // tags:
    //		private
    
    this._nodes = graph.getNodesVector();
    this._links = graph.getLinksVector();
  },

  addNode : function(node)
  {
    // summary:
    //		Adds a node to the graph.  
    // obj:
    //		the node.
    
    ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement.assertCondition(!node.hasParent(this), "node is already in the abstract graph", false);
    if (this._nodes == null) {
      this._nodes = new Array();
    }
    this._nodes.push(node);
    node.addParent(this);
  },

  addLink : function(link)
  {
    // summary:
    //		Adds a link to the graph.  
    // obj:
    //		the link.
    
    ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement.assertCondition(!link.hasParent(this), "link is already in the abstract graph", false);
    ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement.assertCondition(this._nodes != null, "origin and destination must be in the abstract graph", false);

    ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement.assertCondition(link.getFrom().hasParent(this), "origin of link must be in the abstract graph", false);

    ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement.assertCondition(link.getTo().hasParent(this), "destination of link must be in the abstract graph", false);
    if (this._links == null) {
      this._links = new Array();
    }
    this._links.push(link);
    link.addParent(this);
    link.getFrom().addFromLink(link);
    link.getTo().addToLink(link);
  },

  checkNode : function(node)
  {
    // summary:
    //		Verifies if the node is in the graph.  
    // node: ibm_ilog.graphlayout.circular.clayout.AbstractNode
    //		Graph node
    // tags:
    //		private
    
    ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement.assertCondition(node != null, "node is null", false);
    ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement.assertCondition(this._nodes != null && node.hasParent(this), "node is not a node of this abstract graph", false);
  },

  getNodes : function()
  {
    // summary:
    //		Returns an enumeration of all the nodes.
    
    if (this._nodes == null)
    {
      if (this._voidIter == null) {
        this._voidIter = ibm_ilog.graphlayout.internalutil.LayoutUtil.getVoidIterator();
      }
      return this._voidIter; // ibm_ilog.graphlayout.IIterator
    }
    else {
      return  new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._nodes); // ibm_ilog.graphlayout.IIterator
    }
  },

  getNodesVector : function()
  {
    // summary:
    //		For internal usage only.
    // tags:
    //		private
    
    return this._nodes; // Array
  },

  getLinksVector : function()
  {
    return this._links; // Array
  },

  getLinksFrom : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links originating from a node.  
    // node: ibm_ilog.graphlayout.circular.clayout.AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksFrom(); // ibm_ilog.graphlayout.IIterator
  },

  getLinks : function(node)
  {
    // summary:
    //		Returns an enumeration of all the links originating or going from/to
    //		a node.  
    // node: ibm_ilog.graphlayout.circular.clayout.AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinks(); // ibm_ilog.graphlayout.IIterator
  },

  getLinksCount : function(node)
  {
    // summary:
    //		Returns the number of links originating or going from/to a node.  
    // node: ibm_ilog.graphlayout.circular.clayout.AbstractNode
    //		the node.
    
    this.checkNode(node);
    return node.nodeGetLinksCount(); // int
  },

  getOpposite : function(link, node)
  {
    // summary:
    //		Returns the opposite node on link.
    
    return link.getOpposite(node); // ibm_ilog.graphlayout.circular.clayout.AbstractNode
  },

  getFrom : function(link)
  {
    // summary:
    //		Returns the origin object of link.
    
    return link.getFrom(); // ibm_ilog.graphlayout.circular.clayout.AbstractNode
  },

  getTo : function(link)
  {
    // summary:
    //		Returns the destination object of link.
    
    return link.getTo(); // ibm_ilog.graphlayout.circular.clayout.AbstractNode
  },

  isLinkBetween : function(node1, node2)
  {
    // summary:
    //		Tests whether a link exists between two nodes.
    
    this.checkNode(node1);
    this.checkNode(node2);
    var link;
    var links = this.getLinksFrom(node1);

    while (links.hasNext())
    {
      link = links.next();
      if (link.getTo() == node2) {
        return true; // Boolean
      }
    }

    links = this.getLinksFrom(node2);

    while (links.hasNext())
    {
      link = links.next();
      if (link.getTo() == node1) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  }

}
);
