dojo.provide('ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.LayoutUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');
dojo.require('ibm_ilog.graphlayout.GraphLayout');

dojo.declare('ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement', null, 
{
  // summary:
  //		An abstract graph element (node or link). 
  // description:
  //		An abstract graph element (node or link). 
  //		This is the base class of abstract graph nodes and links.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _parents: null,

  getParents : function()
  {
    // summary:
    //		Returns an enumeration of the abstract graphs to which this element
    //		was add as a node or a link.
    
    if (this._parents == null) {
      return ibm_ilog.graphlayout.internalutil.LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
    else {
      return  new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._parents); // ibm_ilog.graphlayout.IIterator
    }
  },

  hasParent : function(graph)
  {
    // summary:
    //		Returns 'true' if the element has 'parent' as
    //		a parent graph; returns 'false' otherwise.
    
    var parents = this.getParents();

    while (parents.hasNext())
    {
      var parent = parents.next();
      if (parent == graph) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  addParent : function(graph)
  {
    // summary:
    //		Adds 'graph' as a parent of this element. 
    // description:
    //		Adds <code>graph</code> as a parent of this element. 
    //		This method is automatically called when the element is added to an
    //		abstract graph using <code>AbstractGraph.addNode</code> and
    //		<code>AbstractGraph.addLink</code>. The method does nothing if the
    //		element has already graph as a parent.
    // tags:
    //		private
    
    if (this._parents == null)
    {
      this._parents = new Array();
      this._parents.push(graph);
    }
    else
    {
      if (!(dojo.indexOf(this._parents, graph)>=0)) {
        this._parents.push(graph);
      }
    }
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement,
{

  assertCondition : function(cond, msg, runtimeExc)
  {
    if (cond == false)
    {
      if (runtimeExc) {
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6150E", [msg ]);
      }
      else {
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6150E", [msg ]);
      }
    }
  }

}
);

