dojo.provide('ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.circular.clayout.AbstractNode');
dojo.require('ibm_ilog.graphlayout.circular.CircularLayout');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.LayoutUtil');

dojo.declare('ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode', ibm_ilog.graphlayout.circular.clayout.AbstractNode, 
{
  // summary:
  //		An abstract graph node which encapsulates a node of the original
  //		graph. 
  // description:
  //		An abstract graph node which encapsulates a node of the original
  //		graph. 
  //		To be used for encapsulating nodes of an GraphModel.   
  // tags:
  //		private
  
  _graphicObject: null,
  _index : null,

  _drawn : null,
  _sonContactNode: null,
  _sonClusters: null,

  _parentContactNode: null,

  constructor : function(graphicObject, index )
  {
    this._index = ibm_ilog.graphlayout.circular.CircularLayout.NO_INDEX;
    this._drawn = false;
    ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement.assertCondition(graphicObject != null, "graphic object null", false);
    this._graphicObject = graphicObject;
    this._index = index;
  },
  
  move : function(x, y, graphModel, redraw)
  {
    // summary:
    //		
    // tags:
    //		private
    
    var node = this.getGraphicObject();
    var bbox = ibm_ilog.graphlayout.internalutil.GraphModelUtil.getObjectBounds(graphModel, node);
    var newX = x - bbox.width * 0.5;
    var newY = y - bbox.height * 0.5;
    ibm_ilog.graphlayout.circular.clayout.AbstractGraphElement.assertCondition(ibm_ilog.graphlayout.internalutil.LayoutUtil.isValidNumber(newX, newY),
        "invalid (probably too big) coordinates have been computed for the nodes", true);
    graphModel.moveNode(node, newX, newY);
    this._drawn = true;
  },

  addSonCluster : function(sonCluster)
  {
    if (this._sonClusters == null) {
      this._sonClusters = new Array();
    }
    this._sonClusters.push(sonCluster);
  },

  getSonClusters : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._sonClusters; // Array
  },

  setParent : function(parentCluster, parentContactNode, connexion)
  {
    this._parentContactNode = parentContactNode;
  },

  setDrawn : function(option)
  {
    this._drawn = option;
  },

  isDrawn : function()
  {
    return this._drawn; // Boolean
  },

  getIndex : function()
  {
    // summary:
    //		Returns the index of the node.
    
    return this._index; // int
  },

  getGraphicObject : function()
  {
    // summary:
    //		Returns the graphic object encapsulated by this object.
    
    return this._graphicObject; // Object
  }

}
);
