dojo.provide('ibm_ilog.graphlayout.circular.clayout.CLANode');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.circular.clayout.CLNode');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');
dojo.require('ibm_ilog.graphlayout.GraphLayout');
dojo.require('ibm_ilog.graphlayout.IIterator');

dojo.declare('ibm_ilog.graphlayout.circular.clayout.CLANode', ibm_ilog.graphlayout.circular.clayout.CLNode, 
{
  // summary:
  //		The node in a cluster, used when autoclustering and autocrossing
  //		reduction. 
  // description:
  //		The node in a cluster, used when autoclustering and autocrossing
  //		reduction. 
  //		
  // tags:
  //		private
  
  _index: null,
  _specIndex: null,
  _linkToStarCenter: null,

  _prioQueueIndex: null,
  _placedNeighbors: null,
  _unplacedNeighbors: null,

  _orderNeighbor1: null,
  _orderNeighbor2: null,
  _realNeighbors: null,
  _artiNeighbors: null,

  _dfsNumber: null,
  _isCutVertex: null,

  _inoutMask: null,

  constructor : function(original, model)
  {
    this._specIndex = -1;
    this._linkToStarCenter = false;
  },
  
  setIndex : function(i)
  {
    this._index = i;
  },

  getIndex : function()
  {
    return this._index; // int
  },

  setSpecIndex : function(i)
  {
    this._specIndex = i;
  },

  getSpecIndex : function()
  {
    return this._specIndex; // int
  },

  markInOutDirection : function(incoming)
  {
    // summary:
    //		Mark whether the node has incoming or outgoing intercluster links. 
    // description:
    //		Mark whether the node has incoming or outgoing intercluster links. 
    //		Whether the link is incoming or outgoing depends on the tree
    //		ordering which cluster is child or parent cluster when laying them
    //		out as tree.
    // tags:
    //		private
    
    var mask = ((incoming ? ibm_ilog.graphlayout.circular.clayout.CLANode.IN_MASK : ibm_ilog.graphlayout.circular.clayout.CLANode.OUT_MASK));
    this._inoutMask |= mask;
  },

  isInNode : function()
  {
    return (this._inoutMask & ibm_ilog.graphlayout.circular.clayout.CLANode.IN_MASK) != 0; // Boolean
  },

  isOutNode : function()
  {
    return (this._inoutMask & ibm_ilog.graphlayout.circular.clayout.CLANode.OUT_MASK) != 0; // Boolean
  },

  markLinkToStarCenter : function()
  {
    // summary:
    //		Mark that this node has a link to the star center of the same
    //		cluster. 
    // description:
    //		Mark that this node has a link to the star center of the same
    //		cluster. 
    //		We do not store these links explicitely, only mark the nodes and
    //		treat these marked nodes special in the crossing reduction.
    // tags:
    //		private
    
    this._linkToStarCenter = true;
  },

  hasLinkToStarCenter : function()
  {
    return this._linkToStarCenter; // Boolean
  },

  getIntraLinksFrom : function()
  {
    return new CLANodeAnonClass_1(this); // ibm_ilog.graphlayout.IIterator
  },

  getIntraLinksTo : function()
  {
    return new CLANodeAnonClass_2(this); // ibm_ilog.graphlayout.IIterator
  },

  setPrioQueueIndex : function(i)
  {
    this._prioQueueIndex = i;
  },

  getPrioQueueIndex : function()
  {
    return this._prioQueueIndex; // int
  },

  setPlacedNeighbors : function(i)
  {
    this._placedNeighbors = i;
  },

  incrPlacedNeighbors : function()
  {
    this._placedNeighbors++;
  },

  getPlacedNeighbors : function()
  {
    return this._placedNeighbors; // int
  },

  setUnplacedNeighbors : function(i)
  {
    this._unplacedNeighbors = i;
  },

  decrUnplacedNeighbors : function()
  {
    this._unplacedNeighbors--;
  },

  getUnplacedNeighbors : function()
  {
    return this._unplacedNeighbors; // int
  },

  getNumOrderingNeighbors : function()
  {
    if (this._orderNeighbor1 == null) {
      return 0; // int
    }
    if (this._orderNeighbor2 == null) {
      return 1; // int
    }
    return 2; // int
  },

  clearOuterPlanarData : function()
  {
    this._orderNeighbor1 = null;
    this._orderNeighbor2 = null;
    this._realNeighbors = null;
    this._artiNeighbors = null;
  },

  getOtherOrderingNeighbor : function(n)
  {
    if (this._orderNeighbor1 == n) {
      return this._orderNeighbor2; // ibm_ilog.graphlayout.circular.clayout.CLANode
    }
    return this._orderNeighbor1; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  addRealNeighbor : function(n)
  {
    if (this._realNeighbors == null) {
      this._realNeighbors = new Array();
    }
    this._realNeighbors.push(n);
  },

  getNumRealNeighbors : function()
  {
    if (this._realNeighbors == null) {
      return 0; // int
    }
    return this._realNeighbors.length; // int
  },

  getRealNeighbor : function(i)
  {
    return this._realNeighbors[i]; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  addArtificialNeighbor : function(n)
  {
    if (this._artiNeighbors == null) {
      this._artiNeighbors = new Array();
    }
    this._artiNeighbors.push(n);
  },

  getNumArtificialNeighbors : function()
  {
    if (this._artiNeighbors == null) {
      return 0; // int
    }
    return this._artiNeighbors.length; // int
  },

  getArtificialNeighbor : function(i)
  {
    return this._artiNeighbors[i]; // ibm_ilog.graphlayout.circular.clayout.CLANode
  },

  getDegree : function()
  {
    return this.getNumRealNeighbors() + this.getNumArtificialNeighbors(); // int
  },

  getDFSNumber : function()
  {
    // summary:
    //		The dfs traversal number.
    // tags:
    //		private
    
    return this._dfsNumber; // int
  },

  setDFSNumber : function(n)
  {
    this._dfsNumber = n;
  },

  isCutVertex : function()
  {
    // summary:
    //		Whether the node is a cut vertex.
    // tags:
    //		private
    
    return this._isCutVertex; // Boolean
  },

  setCutVertex : function(b)
  {
    this._isCutVertex = b;
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.circular.clayout.CLANode,
{
  IN_MASK : null,
  OUT_MASK : null,

  setOrderingNeighbors : function(n1, n2)
  {
    if (n1._orderNeighbor1 == null) {
      n1._orderNeighbor1 = n2;
    }
    else if (n1._orderNeighbor2 == null) {
      n1._orderNeighbor2 = n2;
    }
    else {
      return false; // Boolean
    }
    if (n2._orderNeighbor1 == null) {
      n2._orderNeighbor1 = n1;
    }
    else if (n2._orderNeighbor2 == null) {
      n2._orderNeighbor2 = n1;
    }
    else {
      return false; // Boolean
    }
    return true; // Boolean
  },

  addRealEdge : function(n1, n2)
  {
    n1.addRealNeighbor(n2);
    n2.addRealNeighbor(n1);
  },

  addArtificialEdge : function(n1, n2)
  {
    n1.addArtificialNeighbor(n2);
    n2.addArtificialNeighbor(n1);
  },

  removeEdge : function(n1, n2)
  {
    if (n1._realNeighbors != null) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.removeArrayObject(n1._realNeighbors, n2);
    }
    if (n1._artiNeighbors != null) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.removeArrayObject(n1._artiNeighbors, n2);
    }
    if (n2._realNeighbors != null) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.removeArrayObject(n2._realNeighbors, n1);
    }
    if (n2._artiNeighbors != null) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.removeArrayObject(n2._artiNeighbors, n1);
    }
  },

  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.circular.clayout.CLANode;
    if(ibm_ilog.graphlayout.circular.clayout.CLNode._fields_init)
      ibm_ilog.graphlayout.circular.clayout.CLNode._fields_init(c);
    
    c.IN_MASK = 1;
    c.OUT_MASK = 2;
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.circular.clayout.CLANode.IntraLinkFilterIterator', ibm_ilog.graphlayout.IIterator, 
{
  __outerThis: null,
  _e: null,
  _link: null,

  constructor : function(input__outerThis)
  {
    this.__outerThis = input__outerThis;
    this._e = this.__outerThis.getIntraLinks();
    this._link = this.moveToValid();
  },
  
  hasNext : function()
  {
    // summary:
    // tags:
    //		private
    
    return this._link != null; // Boolean
  },

  next : function()
  {
    // summary:
    // tags:
    //		private
    
    var l = this._link;
    this._link = this.moveToValid();
    return l; // Object
  },

  accept : function(link)
  {
    return true; // Boolean
  },

  moveToValid : function()
  {
    var l;

    while (this._e.hasNext())
    {
      l = this._e.next();
      if (this.accept(l)) {
        return l; // ibm_ilog.graphlayout.circular.clayout.CLLink
      }
    }

    return null; // ibm_ilog.graphlayout.circular.clayout.CLLink
  },

  remove : function()
  {
    // summary:
    // tags:
    //		private
    
    ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowUnsupportedOpExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6150E", ["remove not supported" ]);
  }

}
);
/**
 * @private
 */
dojo.declare('CLANodeAnonClass_1', ibm_ilog.graphlayout.circular.clayout.CLANode.IntraLinkFilterIterator,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  accept : function(link)
  {
    return (link.getSource() == this.__outerThis); // Boolean
  }

});

/**
 * @private
 */
dojo.declare('CLANodeAnonClass_2', ibm_ilog.graphlayout.circular.clayout.CLANode.IntraLinkFilterIterator,
{
  // tags:
  //		private
  
  __outerThis : null,

  constructor : function(input__outerThis )
  {
    
    this.__outerThis = input__outerThis;
  },

  accept : function(link)
  {
    return (link.getTarget() == this.__outerThis); // Boolean
  }

});

(function(){ ibm_ilog.graphlayout.circular.clayout.CLANode._fields_init(); })();
