dojo.provide('ibm_ilog.graphlayout.circular.clayout.ClusterIdCollection');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.circular.CircularLayout');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.HashTable');
dojo.require('ibm_ilog.graphlayout.internalutil.LayoutUtil');

dojo.declare('ibm_ilog.graphlayout.circular.clayout.ClusterIdCollection', null, 
{
  // summary:
  //		A collection of int values representing cluster ids.
  // tags:
  //		private
  
  _ids: null,

  _initialCapacity : null,

  constructor : function (a0, a1)
  {
    if(arguments.length == 1)
      this._constructor_overload_ibm_ilog_graphlayout_circular_clayout_ClusterIdCollection_1(a0);
    else if(arguments.length == 2)
      this._constructor_overload_ibm_ilog_graphlayout_circular_clayout_ClusterIdCollection_2(a0, a1);
  },
  
  _constructor_overload_ibm_ilog_graphlayout_circular_clayout_ClusterIdCollection_1 : function(id)
  {
    this._initialCapacity = 5;
    this.setCluster(id);
  },
  
  _constructor_overload_ibm_ilog_graphlayout_circular_clayout_ClusterIdCollection_2 : function(id, index )
  {
    this._initialCapacity = 5;
    this.setClusterIndex(id, index);
  },
  
  add : function(id)
  {
    // summary:
    //		Adds a new cluster id. 
    // description:
    //		Adds a new cluster id. 
    //		Does nothing if the id is already stored in the collection.
    
    if (this._ids == null)
    {
      this._ids = new ibm_ilog.graphlayout.internalutil.HashTable();
      this._ids.add(id, id);
    }
    else if (!this._ids.containsKey(id)) {
      this._ids.add(id, id);
    }
  },

  addClusterIndex : function(id, index)
  {
    // summary:
    //		Adds a new cluster id, with its corresponding index. 
    // description:
    //		Adds a new cluster id, with its corresponding index. 
    //		Does nothing if the id is already stored in the collection.
    
    if (this._ids == null)
    {
      this._ids = new ibm_ilog.graphlayout.internalutil.HashTable();
      this._ids.add(id, (index));
    }
    else if (!this._ids.containsKey(id)) {
      this._ids.add(id, (index));
    }
  },

  setCluster : function(id)
  {
    // summary:
    //		Sets a new cluster id as the unique element of the collection.
    
    if (this._ids == null) {
      this._ids = new ibm_ilog.graphlayout.internalutil.HashTable();
    }
    else {
      this._ids.clear();
    }
    this._ids.add(id, id);
  },

  setClusterIndex : function(id, index)
  {
    // summary:
    //		Sets a new cluster id as the unique element of the collection.
    
    if (this._ids == null) {
      this._ids = new ibm_ilog.graphlayout.internalutil.HashTable();
    }
    else {
      this._ids.clear();
    }
    this._ids.add(id, (index));
  },

  removeCluster : function(id)
  {
    // summary:
    //		Removes a cluster id and the index which is associated with him.  
    // returns:
    //		'true' if id was contained in the collection;
    //		'false' otherwise
    
    if (this._ids == null) {
      return false; // Boolean
    }
    return (this._ids.remove(id) != null); // Boolean
  },

  getClusterIds : function()
  {
    // summary:
    //		Returns an enumeration of the cluster ids contained in this
    //		collection.
    
    return (this._ids == null ? ibm_ilog.graphlayout.internalutil.LayoutUtil.getVoidEnumeration() : new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._ids.getKeyList())); // ibm_ilog.graphlayout.IIterator
  },

  getIndex : function(id)
  {
    // summary:
    //		Returns the index associated with  the clusterId if any,
    //		'CircularLayout.NO_INDEX' otherwise.
    
    if (this._ids == null) {
      return ibm_ilog.graphlayout.circular.CircularLayout.NO_INDEX; // int
    }
    var value = this._ids.item(id);
    if (!(value instanceof Number)) {
      return ibm_ilog.graphlayout.circular.CircularLayout.NO_INDEX; // int
    }
    return  (value); // int
  },

  size : function()
  {
    // summary:
    //		Returns the number of clusterIds in this collection.
    
    return (this._ids == null ? 0 : this._ids.count); // int
  },

  contains : function(clusterId)
  {
    // summary:
    //		Returns 'true' if 'clusterId' is in this
    //		collection, 'false' otherwise.
    
    return (this._ids == null ? false : this._ids.containsKey(clusterId)); // Boolean
  }

}
);
