dojo.provide('ibm_ilog.graphlayout.circular.clayout.ClustersConnexion');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.circular.clayout.AbstractLink');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');
dojo.require('ibm_ilog.graphlayout.GraphLayout');

dojo.declare('ibm_ilog.graphlayout.circular.clayout.ClustersConnexion', ibm_ilog.graphlayout.circular.clayout.AbstractLink, 
{
  // summary:
  //		A link between clusters in a graph of clusters. 
  // description:
  //		A link between clusters in a graph of clusters. 
  //		Stores the graphic objects of the grapher attached to the layout
  //		instance which forms the connexion between two clusters. <br>At this
  //		moment, three types of connexion are supported: <br>1. Void
  //		connexion: a Graphic node belongs to both clusters (no path) <br>2.
  //		Single link connexion: there is a LinkImage link which connects a
  //		node of one cluster with a node of the other. <br>3. simple path
  //		connexion: there is a path of nodes and links between the clusters.  
  //		
  // tags:
  //		private
  
  _path: null,

  _type: null,
  _fromContactNode: null,
  _toContactNode: null,

  constructor : function (a0, a1, a2, a3, a4)
  {
    if(arguments.length == 2)
      this._constructor_overload_ibm_ilog_graphlayout_circular_clayout_ClustersConnexion_2(a0, a1);
    else if(arguments.length == 4)
      this._constructor_overload_ibm_ilog_graphlayout_circular_clayout_ClustersConnexion_4(a0, a1, a2, a3);
    else if(arguments.length == 5)
      this._constructor_overload_ibm_ilog_graphlayout_circular_clayout_ClustersConnexion_5(a0, a1, a2, a3, a4);
  },
  
  _constructor_overload_ibm_ilog_graphlayout_circular_clayout_ClustersConnexion_2 : function(fromCluster, toCluster)
  {
  },
  
  _constructor_overload_ibm_ilog_graphlayout_circular_clayout_ClustersConnexion_4 : function(fromCluster, toCluster, fromContactNode, toContactNode)
  {
    this._constructor_overload_ibm_ilog_graphlayout_circular_clayout_ClustersConnexion_2(fromCluster, toCluster);
    this._fromContactNode = fromContactNode;
    this._toContactNode = toContactNode;
    this._type = ibm_ilog.graphlayout.circular.clayout.ClustersConnexion.VOID;
  },
  
  _constructor_overload_ibm_ilog_graphlayout_circular_clayout_ClustersConnexion_5 : function(fromCluster, toCluster, fromContactNode , toContactNode , link )
  {
    this._fromContactNode = fromContactNode;
    this._toContactNode = toContactNode;

    if (link != null)
    {
      this._path = new Array();
      this._path.push(link);
      this._type = ibm_ilog.graphlayout.circular.clayout.ClustersConnexion.SINGLE_LINK;
    }
    else
    {
      this._type = ibm_ilog.graphlayout.circular.clayout.ClustersConnexion.VOID;
    }
  },
  
  pickInfo : function(link, fromCluster, graph)
  {
    // summary:
    //		Picks up some information from another ClustersConnexion.
    
    if (fromCluster == graph.getFrom(link))
    {
      this._fromContactNode = link.getFromContactNode();
      this._toContactNode = link.getToContactNode();
    }
    else if (fromCluster == graph.getTo(link))
    {
      this._fromContactNode = link.getToContactNode();
      this._toContactNode = link.getFromContactNode();
    }
    else {
      ibm_ilog.graphlayout.circular.clayout.ClustersConnexion.assertCondition(false, "fromCluster is not an extremity of this link", false);
    }
    this.setType(link.getType());
    this.setPath(link.getPath());
  },

  setType : function(type)
  {
    this._type = type;
  },

  getType : function()
  {
    // summary:
    //		Returns the type of the connexion.
    
    return this._type; // int
  },

  getFromContactNode : function()
  {
    // summary:
    //		Returns the contact node on the fromCluster.
    
    return this._fromContactNode; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
  },

  getToContactNode : function()
  {
    // summary:
    //		Returns the contact node on the toCluster.
    
    return this._toContactNode; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
  },

  getContactNode : function(cluster)
  {
    // summary:
    //		Returns the contact node on the cluster.
    
    if (cluster == this.getFrom()) {
      return this._fromContactNode; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
    }
    else if (cluster == this.getTo()) {
      return this._toContactNode; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
    }
    else {
      ibm_ilog.graphlayout.circular.clayout.ClustersConnexion.assertCondition(false, "cluster is not an extremity of this cluster connexion", false);
    }
    return null; // ibm_ilog.graphlayout.circular.clayout.AbstractGraphicNode
  },

  setPath : function(path)
  {
    this._path = path;
  },

  getPath : function()
  {
    return this._path; // Array
  },

  getLength : function(offset)
  {
    // summary:
    //		Returns the length of the connexion.
    
    switch (this.getType())
    {
      case ibm_ilog.graphlayout.circular.clayout.ClustersConnexion.VOID:
        return 0; // Number
      case ibm_ilog.graphlayout.circular.clayout.ClustersConnexion.SINGLE_LINK:
        return offset; // Number
      case ibm_ilog.graphlayout.circular.clayout.ClustersConnexion.SIMPLE_PATH:
        ibm_ilog.graphlayout.circular.clayout.ClustersConnexion.assertCondition(false, "IlvClustersConnexion: simple path connexion not yet supported", true);
      default:
        return 0; // Number
    }
  },

  getBoundingLength : function(offset)
  {
    // summary:
    //		Returns the length of the connexion, taking into account the
    //		bounding box of objects.
    // tags:
    //		private
    
    switch (this.getType())
    {
      case ibm_ilog.graphlayout.circular.clayout.ClustersConnexion.VOID:
        return this.getLength(offset); // Number
      case ibm_ilog.graphlayout.circular.clayout.ClustersConnexion.SINGLE_LINK:
        return this.getLength(offset); // Number
      case ibm_ilog.graphlayout.circular.clayout.ClustersConnexion.SIMPLE_PATH:
        ibm_ilog.graphlayout.circular.clayout.ClustersConnexion.assertCondition(false, "IlvClustersConnexion: simple path connexion not yet supported", true);
      default:
        return this.getLength(offset); // Number
    }
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.circular.clayout.ClustersConnexion,
{
  VOID : null,
  SINGLE_LINK : null,
  SIMPLE_PATH : null,

  assertCondition : function(cond, msg, runtimeExc)
  {
    if (cond == false)
    {
      if (runtimeExc) {
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6150E", [msg ]);
      }
      else {
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6150E", [msg ]);
      }
    }
  },

  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.circular.clayout.ClustersConnexion;
    if(ibm_ilog.graphlayout.circular.clayout.AbstractLink._fields_init)
      ibm_ilog.graphlayout.circular.clayout.AbstractLink._fields_init(c);
    
    c.VOID = 0;
    c.SINGLE_LINK = 1;
    c.SIMPLE_PATH = 2;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.circular.clayout.ClustersConnexion._fields_init(); })();
