dojo.provide('ibm_ilog.graphlayout.circular.galg.DefaultSimpleTraversableGraphModel');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel');
dojo.require('ibm_ilog.graphlayout.circular.galg.SimpleTraversableGraphModel');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.circular.galg.DefaultSimpleTraversableGraphModel', ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel, 
{
  // summary:
  //		The default implementation of
  //		'SimpleTraversableGraphModel'.  
  // @private
  // tags:
  //		private
  
  constructor : function()
  {
    
  this._mergeMultiLinks = true;},

  _mergeMultiLinks : null,

  setMergeMultiLinks : function(merge)
  {
    // summary:
    //		Sets whether multilinks between the same pair of nodes must be
    //		merged into one link. 
    // description:
    //		Sets whether multilinks between the same pair of nodes must be
    //		merged into one link. 
    //		Must be set before adding any links.
    // tags:
    //		private
    
    this._mergeMultiLinks = merge;
  },

  isMergeMultiLinks : function()
  {
    // summary:
    //		Returns whether multilinks between the same pair of nodes must be
    //		merged into one link.
    // tags:
    //		private
    
    return this._mergeMultiLinks; // Boolean
  },

  mergeLinks : function(newLink, replacementLink)
  {
    // summary:
    //		Merges the info of the new link into the replacement link, if
    //		multiple links are not allowed.  
    // newLink:
    //		ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Link
    //		The new link which is not yet in the model.
    // replacementLink:
    //		ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Link
    //		The replacement link which is already in the
    //		model and has the same source and target nodes.
    // tags:
    //		private
    
    this._originalMap.add(newLink.original, replacementLink);
  },

  addLinkImpl : function(link, source, target)
  {
    // summary:
    //		Adds the link internally.  
    // link: ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Link
    //		The link.
    // source:
    //		ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Node
    //		The source node.
    // target:
    //		ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Node
    //		The target node.
    // returns:
    //		true if successful.
    // tags:
    //		private
    
    var s = source;
    var t = target;

    if (this.isMergeMultiLinks())
    {
      var replacementLink = null;
      var links = s.fromLinks;
      if (links == null || (t.toLinks != null && t.toLinks.length < links.length)) {
        links = t.toLinks;
      }
      if (links != null)
      {
        var n = links.length;

        for (var i = 0; i < n; i++)
        {
          var alink = links[i];

          if (alink.source == s && alink.target == t)
          {
            replacementLink = alink;
            break;
          }
        }
      }

      if (replacementLink != null)
      {
        this.mergeLinks(link, replacementLink);
        return true; // Boolean
      }
    }

    var result = this.inherited("addLinkImpl", arguments, [link, s, t]);
    if (s.fromLinks == null) {
      s.fromLinks = new Array();
    }
    if (t.toLinks == null) {
      t.toLinks = new Array();
    }
    s.fromLinks.push(link);
    t.toLinks.push(link);
    return result; // Boolean
  },

  createNode : function()
  {
    // summary:
    //		Creates a new node.
    // tags:
    //		private
    
    return new ibm_ilog.graphlayout.circular.galg.DefaultSimpleTraversableGraphModel.Node(); // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Node
  },

  createLink : function()
  {
    // summary:
    //		Creates a new link.
    // tags:
    //		private
    
    return new ibm_ilog.graphlayout.circular.galg.DefaultSimpleTraversableGraphModel.Link(); // ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Link
  },

  getLinksFrom : function(node)
  {
    // summary:
    //		Returns the outgoing links of a node. 
    // description:
    //		Returns the outgoing links of a node. 
    //		The input must be a node, i.e. it must be contained in the nodes
    //		obtained from <code> DefaultSimpleGraphModel.getNodes()</code>. The
    //		result must be an iteration of links that have the input node as
    //		source.  
    // tags:
    //		private
    
    var l = (node).fromLinks;
    return (l == null ? ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel._emptyIterator :  new ibm_ilog.graphlayout.internalutil.ArrayIterator(l)); // ibm_ilog.graphlayout.IIterator
  },

  getLinksTo : function(node)
  {
    // summary:
    //		Returns the incoming links of a node. 
    // description:
    //		Returns the incoming links of a node. 
    //		The input must be a node, i.e. it must be contained in the nodes
    //		obtained from <code> DefaultSimpleGraphModel.getNodes()</code>. The
    //		result must be an iteration of links that have the input node as
    //		target.  
    // tags:
    //		private
    
    var l = (node).toLinks;
    return (l == null ? ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel._emptyIterator :  new ibm_ilog.graphlayout.internalutil.ArrayIterator(l)); // ibm_ilog.graphlayout.IIterator
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.circular.galg.DefaultSimpleTraversableGraphModel,
{
}
);

dojo.declare('ibm_ilog.graphlayout.circular.galg.DefaultSimpleTraversableGraphModel.Node', ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Node, 
{

  constructor : function()
  {
    
  },

  fromLinks: null,

  toLinks: null
}
);
dojo.declare('ibm_ilog.graphlayout.circular.galg.DefaultSimpleTraversableGraphModel.Link', ibm_ilog.graphlayout.circular.galg.DefaultSimpleGraphModel.Link, 
{
  // summary:
  //		
  // @private
  
  constructor : function()
  {
    
  }

}
);
