/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.common.command.AddType");

dojo.require("rmpw.common.command.Command");

/**
 * Adds a type to an object.
 * 
 * @author Marc Gobeil
 */
dojo.declare("rmpw.common.command.AddType", rmpw.common.command.Command, {
	id: "rmpw.common.command.AddType",

	updateChangeSet: function(changeSet, args) {
		var obj = args.obj;
		var typeToAdd = args.type;
		var existingTypes = obj.rdf_type; 
		// only add if there are no existing types, or there are, but the one we're adding is not already in the list
		if(!existingTypes || !dojo.some(existingTypes, function(type) { return type.rdf_about == typeToAdd; })) {
			var change = changeSet.createChange(obj);
			change.push('rdf_type', { rdf_about: typeToAdd });
		}
		return true;
	}
});