/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.common.command.DeleteElement");

dojo.require("rmpw.common.command.Command");

/**
 * Command that deletes an element
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.common.command.DeleteElement", rmpw.common.command.Command, {
	id: "rmpw.common.command.DeleteElement",
	
	updateChangeSet: function(changeSet, args) {
		var semanticChange = changeSet.createChange(args.ownerElement);
		semanticChange.removeArray(args.ownerChildrenProperty, args.elementToDelete);
		
		return true;
	},
	
	setOwnerChildrenProperty: function(ownerChildrenProperty) {
		this._options.ownerChildrenProperty = ownerChildrenProperty;
	},
	
	getOutput: function() {
		return {};
	}
});