/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.sketch.commands.shapes.CreateActor");

dojo.require("rmpw.common.command.Command");

dojo.declare("rmpw.sketch.commands.shapes.CreateActor", rmpw.common.command.Command, {
	id: "rmpw.sketch.commands.shapes.CreateActor",
	icon: null,
	description: "CreateActor",
	
	updateChangeSet: function(changeSet, args) {
	
		var head = {
			eClass: "EllipseType",
			cx: 12 + args.x,
			cy: 10 + args.y,
			fill: "rgb(255, 255, 255)",
			fillOpacity: "1",
			rx: 10,
			ry: 10,
			stroke: "rgb(80, 152, 224)",
			strokeOpacity: "1",
			strokeWidth: "4"
		};
		
		var trunk = {
	        eClass: "LineType",
	        fill: "none",
	        fillOpacity: "0",
	        stroke: "rgb(80, 152, 224)",
	        strokeOpacity: "1",
	        strokeWidth: "4",
	        x1: 12 + args.x,
	        x2: 12 + args.x,
	        y1: 20 + args.y,
	        y2: 30 + args.y
	    };
		
		var arms = {
		    eClass: "LineType",
		    fill: "none",
		    fillOpacity: "0",
		    stroke: "rgb(80, 152, 224)",
		    strokeOpacity: "1",
		    strokeWidth: "4",
		    x1: args.x,
		    x2: 24 + args.x,
		    y1: 24 + args.y,
		    y2: 24 + args.y
		};
		
		var leftleg = {
	        eClass: "LineType",
	        fill: "none",
	        fillOpacity: "0",
	        stroke: "rgb(80, 152, 224)",
	        strokeOpacity: "1",
	        strokeWidth: "4",
	        x1: 12 + args.x,
	        x2: 2 + args.x,
	        y1: 30 + args.y,
	        y2: 50 + args.y
	     };
		
		var rightleg = {
	        eClass: "LineType",
	        fill: "none",
	        fillOpacity: "0",
	        stroke: "rgb(80, 152, 224)",
	        strokeOpacity: "1",
	        strokeWidth: "4",
	        x1: 12 + args.x,
	        x2: 22 + args.x,
	        y1: 30 + args.y,
	        y2: 50 + args.y
	    };
		
		var actor = {
			eClass: "GType",
			elementId: "Actor",
			ellipse: [ head ],
			line: [ trunk, arms, rightleg, leftleg ]
	    };
		
		var change = changeSet.createChange(args.svgParent);
		change.push("g", actor);

		return true;
	}
});