/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.sketch.commands.shapes.CreateCloud");

dojo.require("rmpw.common.command.Command");

dojo.declare("rmpw.sketch.commands.shapes.CreateCloud", rmpw.common.command.Command, {
	id: "rmpw.sketch.commands.shapes.CreateCloud",
	icon: null,
	description: "CreateCloud",
	
	data: "M 40,4 C 37,3 33,4 30,7 C 29,5 27,4 25,3 C 20,2 14,5 13,11 C 13,11 12,11 12,12 C 7,11 3,14 1,19 C 0,24 3,29 7,31 C 7,32 7,32 6,33 C 5,38 8,44 14,45 C 16,46 19,46 21,44 C 23,47 25,49 28,50 C 32,51 37,49 39,46 C 40,46 41,47 42,47 C 48,49 53,46 55,40 C 56,37 55,35 54,32 C 55,31 56,29 57,28 C 58,22 55,16 49,15 C 49,15 48,15 48,15 C 48,10 45,5 40,4 z",

	updateChangeSet: function(changeSet, args) {
		var svgUtil = new rmpw.sketch.serializer.SVGUtil();		
		var newpath = svgUtil.repositionPath( this.data, args.x, args.y );

		var path = {
			eClass: "PathType",
			d: newpath, 
			style: "stroke-width:2;fill:rgb(255,140,0);stroke:rgb(255,140,0);fill-opacity:1"
		};
		
		var pathGroup = {
			eClass: "GType",
			elementId:"Cloud",
			path: [ path ]
	    };
		
		var change = changeSet.createChange(args.svgParent);
		change.push("g", pathGroup);

		return true;
	}
});