/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.sketch.commands.shapes.CreateRectangle");

dojo.require("rmpw.common.command.Command");
dojo.require("rmpw.sketch.commands.shapes.TextArguments");

dojo.declare("rmpw.sketch.commands.shapes.CreateRectangle", rmpw.common.command.Command, {
	id: "rmpw.sketch.commands.shapes.CreateRectangle",
	icon: null,
	description: "CreateShape",
	
	updateChangeSet: function(changeSet, args) {
		var rect = {
			eClass: "RectType",
// Warning: don't set these, diagram wants a transform on it instead
			x: args.x,
			y: args.y,
			width: args.width,
			height: args.height,
			stroke: args.linecolor,
			strokeOpacity: args.strokeopacity,
		    strokeWidth: args.linewidth,
		    fill: args.fill,
		    fillOpacity: args.fillopacity,
		    strokeDasharray: args.strokedash
			// style: "stroke-width:4;stroke:#5098E0;fill-opacity:0"
		};
		
		var text = new rmpw.sketch.commands.shapes.TextArguments(args);		
		dojo.mixin( rect, text.arguments() );
		
		var rectGroup = {
			eClass: "GType",
			elementId: "Rectangle",
			rect: [ rect ]
	    };
		
		var change = changeSet.createChange(args.svgParent);
		change.push("g", rectGroup);

		return true;
	}
});