dojo.provide('ibm_ilog.diagram.editor.adorners.ConnectionTargetAdorner');

dojo.require('ibm_ilog.diagram.templates.editor_templates');
dojo.require('ibm_ilog.diagram.adorners.AdornerWithHandles');
dojo.require('ibm_ilog.diagram.editor.adorners.ConnectionTargetHandle');

(function() {
	var R = ibm_ilog.diagram.util.ErrorReporter;
	var g = ibm_ilog.diagram.util.Geometry, Rect = g.Rect, EmptyRect = g.EmptyRect, Size = g.Size, PointZero = g.PointZero, Point = g.Point;
	var gu = ibm_ilog.diagram.util.GraphUtil;
    
	ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.ConnectionTargetAdorner',[ibm_ilog.diagram.adorners.AdornerWithHandles],{

    	initialize: function() {
    		this.inherited(arguments);

    		this._createHandle(ibm_ilog.diagram.editor.adorners.ConnectionTargetHandle,"hndT").setup(Point(0.5,0));
    		this._createHandle(ibm_ilog.diagram.editor.adorners.ConnectionTargetHandle,"hndR").setup(Point(1,0.5));
    		this._createHandle(ibm_ilog.diagram.editor.adorners.ConnectionTargetHandle,"hndB").setup(Point(0.5,1));
    		this._createHandle(ibm_ilog.diagram.editor.adorners.ConnectionTargetHandle,"hndL").setup(Point(0,0.5));
    	},
    
    	setConnectionInteractor: function(connectionInteractor){
    		this["hndT"].setConnectionInteractor(connectionInteractor);
    		this["hndR"].setConnectionInteractor(connectionInteractor);
    		this["hndB"].setConnectionInteractor(connectionInteractor);
    		this["hndL"].setConnectionInteractor(connectionInteractor);
    	},
    	
    	activate: function() {
    		this._activateHandle("hndT");
    		this._activateHandle("hndR");
    		this._activateHandle("hndB");
    		this._activateHandle("hndL");
    	},
    	
    	deactivate: function() {
    		this._deactivateHandle("hndT");
    		this._deactivateHandle("hndR");
    		this._deactivateHandle("hndB");
    		this._deactivateHandle("hndL");
    	}

    }));

})();
