dojo.provide('ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAddHandle');

dojo.require('ibm_ilog.diagram.templates.editor_templates');
dojo.require('ibm_ilog.diagram.adorners.HighlightedHandle');
dojo.require('ibm_ilog.diagram.editor.interactors.AddIntermediatePointHandlerInteractor');

(function() {

	ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAddHandle',[ibm_ilog.diagram.adorners.HighlightedHandle],{
		// Summary:
		//		this class is the handle that manage the link intermediate points. 
		//		Contains the instance of LinkIntermediatePointsHandleInteractor that enables to remove and edit these points.
		
		//
		//	_location: handle position
		//
		_isAddHandle : true,
		_index: null,
		setUp: function(index) {
		// Summary:
		//		sets the handle Intermediate point index
			
			this._index = index;
			this.addInteractor(new ibm_ilog.diagram.editor.interactors.AddIntermediatePointHandlerInteractor().initialize(this));
			return this;
		},
		getIndex: function(){
			// Summary:
			//		returns the index of the adorned link intermediate point
			return this._index;
		},
		changeBindings:function(intermediatePoints){
			// Summary:
			//		modify the handle internal bindings
			var p1 = intermediatePoints[this._index];
			var p2 = intermediatePoints[this._index+1];
			var point = {x: ((p2.x-p1.x)/2+p1.x), y:((p2.y-p1.y)/2+p1.y)};
			this.startDTLBatch();
			this.setAddPointPosX(point.x);
			this.setAddPointPosY(point.y);
			this.endDTLBatch();
		}
	}));

	ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAddHandle.templateId = "LinkIntermediatePointsAddHandle";
	ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAddHandle, "addPointPosX", -99999);
	ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsAddHandle, "addPointPosY", -99999);

})();
