dojo.provide('ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsHandle');

dojo.require('ibm_ilog.diagram.templates.editor_templates');
dojo.require('ibm_ilog.diagram.adorners.HighlightedHandle');
dojo.require('ibm_ilog.diagram.editor.interactors.LinkIntermediatePointsHandleInteractor');

(function() {

	ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsHandle',[ibm_ilog.diagram.adorners.HighlightedHandle],{
		// Summary:
		//		this class is the handle that manage the link intermediate points. 
		//		Contains the instance of LinkIntermediatePointsHandleInteractor that enables to remove and edit these points.
		
		//
		//	_location: handle position
		//
		_index: null,
		setUp: function(index) {
		// Summary:
		//		sets the handle Intermediate point index
			
			this._index = index;
			this.addInteractor(new ibm_ilog.diagram.editor.interactors.LinkIntermediatePointsHandleInteractor().initialize(this));
			return this;
		},
		getIndex: function(){
			// Summary:
			//		returns the index of the adorned link intermediate point
			return this._index;
		},
		changeBindings:function(intermediatePoints){
			// Summary:
			//		modify the handle internal bindings
			var point = intermediatePoints[this._index];
			this.startDTLBatch();
			this.setIntPointPosX(point.x);
			this.setIntPointPosY(point.y);
			this.endDTLBatch();
		}
	}));

	ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsHandle.templateId = "LinkIntermediatePointsHandle";
	ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsHandle, "intPointPosX", -99999);
	ibm_ilog.diagram.templating.declareBindableProperty(ibm_ilog.diagram.editor.adorners.LinkIntermediatePointsHandle, "intPointPosY", -99999);

})();
