dojo.provide('ibm_ilog.diagram.editor.adorners.ResizeAdorner');

dojo.require('ibm_ilog.diagram.templates.editor_templates');
dojo.require('ibm_ilog.diagram.adorners.Adorner');
dojo.require('ibm_ilog.diagram.editor.adorners.ResizeHandle');

(function() {

	var g = ibm_ilog.diagram.util.Geometry,	Rect = g.Rect,	EmptyRect = g.EmptyRect,	Size = g.Size,	PointZero = g.PointZero,	Point = g.Point;
	var gu = ibm_ilog.diagram.util.GraphUtil;

ibm_ilog.diagram.gfxDeclaration(dojo.declare('ibm_ilog.diagram.editor.adorners.ResizeAdorner', [ibm_ilog.diagram.adorners.AdornerWithHandles], {
	//
	//	summary:
	//		An adorner with handles to resize the adorned.
	//	description:
	//		This Adorner creates 4 ResizeHandles, one at each corner of the 
	//		adorned bouding box.
	//		Each ResizeHandle allows to grab that corner of the bounding box 
	//		and resize the adornee by moving that corner.
	//
	initialize: function () {
		this.inherited(arguments);

		this._createResizeHandle("hndTL", Point(0, 0));
		this._createResizeHandle("hndTR", Point(1, 0));
		this._createResizeHandle("hndBL", Point(0, 1));
		this._createResizeHandle("hndBR", Point(1, 1));
	},

	_createResizeHandle: function (attachPoint, p) {
		var h = this._createHandle(ibm_ilog.diagram.editor.adorners.ResizeHandle, attachPoint);
		if (h) {
			h.setup(p);
		}
	}

}));

})();
