dojo.provide('ibm_ilog.diagram.editor.interactors.AddIntermediatePointHandlerInteractor');

dojo.require('ibm_ilog.diagram.interactors.Interactor');
dojo.require('ibm_ilog.diagram.util.Geometry');
dojo.require('ibm_ilog.diagram.editor.EditingUtils');
dojo.require('ibm_ilog.diagram.Link');

(function(){
	var g = ibm_ilog.diagram.util.Geometry;
	var m = dojox.gfx.matrix;

dojo.declare("ibm_ilog.diagram.editor.interactors.AddIntermediatePointHandlerInteractor", [ibm_ilog.diagram.interactors.Interactor], {
	// summary:
	//		this interactor is created in the LinkIntermediatePointAdorner and have the functionality 
	//		to add intermediate points to the adorned link
	
	
	//	_handle: /*LinkIntermediatePointsHandle*/
	_handle: null,
	_viewport: null,
	
	_declareStates: function () {
		this._declareState("idle", ["add"]);
		//this._declareState("active", ["end"]);
	},

	getDefaultConnections: function () {
		// summary:
		//		returns the default event mapping
		
		return {
			add: {
				src: this._getInitialEventSource(),
				srcEvt: "onmousedown",
				connectTo: "_addIntermediatePoint",
				filter: this._buildInputFilter({shift:false,button:0}),
				gfxConnect:true
			}
		};
	},
	
	initialize: function( /* LinkIntermediatePointsHandle */ handle ) {
    	// Summary:
		//		sets the LinkIntermediatePointsHandle
    	this._handle = handle;
		this._viewport = handle.getViewport();
		this._initialize();
		return this;
	},
	
	_getInitialEventSource: function() {
		return this._handle;
	},
	
	_addIntermediatePoint: function(e) {
		// summary:
		//		Add the intermediate point to the adorned link
		var A = this._handle.getAdorner();
		var D = A.getDiagram();
		var link = A.getAdorned();
		var index = this._handle.getIndex();
		var point = this._getPoint(link,index);
		ibm_ilog.diagram.editor.EditingUtils.addItermediatePoint(D,link,point,index);
		A.rebindAdorned();
		dojo.stopEvent(e);
	},
	
	_getPoint: function(link,index){
		var iPoints = link._pathPoints;
		var p1 = iPoints[index];
		var p2 = iPoints[index+1];
		var point = {x:((p2.x-p1.x)/2+p1.x), y:((p2.y-p1.y)/2+p1.y)};
		return point;
	}
});

})();