dojo.provide('ibm_ilog.diagram.editor.interactors.ConnectionTargetHandleInteractor');

dojo.require('ibm_ilog.diagram.editor.adorners.ConnectionTargetAdorner');
dojo.require('ibm_ilog.diagram.interactors.Interactor');
dojo.require('ibm_ilog.diagram.util.Geometry');
dojo.require('ibm_ilog.diagram.util.GraphUtil');

(function () {
	var g = ibm_ilog.diagram.util.Geometry;
	var gu = ibm_ilog.diagram.util.GraphUtil;

dojo.declare("ibm_ilog.diagram.editor.interactors.ConnectionTargetHandleInteractor", [ibm_ilog.diagram.interactors.Interactor], {

	_handle: null,
	_viewport: null,

	initialize: function ( /* ibm_ilog.diagram.editor.ConnectionHandle */ connectionHandle) {
		this._handle = connectionHandle;
		this._viewport = connectionHandle.getViewport();
		this._initialize();
		return this;
	},

	_declareStates: function () {
		this._declareState("idle", ["onMouseRealease"]);
	},

	getDefaultConnections: function () {
		//
		//	summary:
		//		returns the default event mapping
		//
		return {
			onMouseRealease: {
				src: this._getInitialEventSource(),
				srcEvt: "onmouseup",
				connectTo: "_setTarget",
				gfxConnect: true
			}
		};
	},
	
	_getInitialEventSource: function () {
		return this._handle;
	},

	_setTarget: function (ge, e) {
		this._handle.getConnectionInteractor().setPortPosition(this._handle.getPortPosition());
	}
});

})();