dojo.provide('ibm_ilog.diagram.editor.interactors.InlineEditorKeyInteractor');

dojo.require('ibm_ilog.diagram.interactors.KeyboardInteractorManager');
dojo.require('ibm_ilog.diagram.interactors.Interactor');

dojo.declare("ibm_ilog.diagram.editor.interactors.InlineEditorKeyInteractor", [ibm_ilog.diagram.interactors.Interactor], {
	//summary:
	//		This Interactor edit the first editable label through the keyboard interaction.
	//		This Interactor have 1 connection: editInlineText.
	
	_diagram: null,
	initialize: function (diagram) {
	// summary:
    //		initialize the new instance.
    // diagram: ibm_ilog.diagram.widget.Diagram
    //		the associated diagram.			
		this._diagram = diagram;
		return this._initialize();
	},
	editInlineText: function(e){
		// summary:
		//		opens the inline editor of the first editable label of the focused graph element
		var ge = this._diagram.getFocusedElement();
		if(ge && !ge._isIBMDiagramLink){	
			var es = this._diagram.getEditables(ge);
			if(es && es.length) {
				this._diagram.openEditableInlineEditor(es[0]);
			}
		}
	},
	getKeyInteractorId: function(){
		// summary:
	    //		returns the Interactor Id
		
		return ibm_ilog.diagram.editor.interactors.InlineEditorKeyInteractor.KeyInteractorId;
	},
	getDefaultConnections: function () {
		// summary:
		//		returns the default event mapping
		
		return {
			editInlineText: {
				hotKey: dojo.keys.F2,
				connectTo: "editInlineText"
			}
		};
	},
	
	__eod: undefined
});

ibm_ilog.diagram.editor.interactors.InlineEditorKeyInteractor.KeyInteractorId = "InlineEditor";