dojo.provide('ibm_ilog.diagram.editor.interactors.UndoManagerKeyInteractor');

dojo.require('ibm_ilog.diagram.interactors.KeyboardInteractorManager');
dojo.require('ibm_ilog.diagram.interactors.Interactor');

dojo.declare("ibm_ilog.diagram.editor.interactors.UndoManagerKeyInteractor", [ibm_ilog.diagram.interactors.Interactor], {
	//summary:
	//		This Interactor manages the UndoManager through the keyboard interaction.
	//		This Interactor have 2 connections: undo, redo.
	
	_diagram: null,
	initialize: function (diagram) {
	// summary:
    //		initialize the new instance.
    // diagram: ibm_ilog.diagram.widget.Diagram
    //		the associated diagram.		
		this._diagram = diagram;
		return this._initialize();
	},
	undo: function(e){
		// summary:
	    //		this methods calls the UndoManager undoAction function.
		this._diagram.getUndoManager().undoAction();
	},
	redo: function(e){
		// summary:
	    //		this methods calls the UndoManager redoAction function.
		this._diagram.getUndoManager().redoAction();
	},
	getKeyInteractorId: function(){
		// summary:
	    //		returns the Interactor Id
		return ibm_ilog.diagram.editor.interactors.UndoManagerKeyInteractor.KeyInteractorId;
	},
	getDefaultConnections: function () {
		// summary:
		//		returns the default event mapping
		
		return {
			redo: {
				hotKey: 89,//  letter Y
				connectTo: "redo",
				filter: this._buildInputFilter({ctrl:true,shift:false,alt:false})
			}, undo: {
				hotKey: 90,//  letter Z
				connectTo: "undo",
				filter: this._buildInputFilter({ctrl:true,shift:false,alt:false})
			}
		};
	}
});

ibm_ilog.diagram.editor.interactors.UndoManagerKeyInteractor.KeyInteractorId = "UndoManager";