dojo.provide('ibm_ilog.diagram.editor.undo.GroupAction');

dojo.require('ibm_ilog.diagram.editor.undo.UserCustomizedAction');
dojo.require('ibm_ilog.diagram.util.ErrorReporter');
dojo.require('ibm_ilog.diagram.editor.undo.UndoActionList');
dojo.require("ibm_ilog.diagram.editor.EditingUtils");

(function(){
	var R = ibm_ilog.diagram.util.ErrorReporter;
	var eu = ibm_ilog.diagram.editor.EditingUtils;
	dojo.declare("ibm_ilog.diagram.editor.undo.GroupAction", [ibm_ilog.diagram.editor.undo.UserCustomizedAction], {
		//	
		// summary:
		//		this action undo/redo any Group action.
		//		This action must be modified for the user if any user defined action is done on a Group action.
		//
		
	_elements: null,
	_subgraph: null,
	_subgraphName: null,
	constructor:function(){
		//	
		// summary:
		//		creates a new instance, setting the corresponding label
		this._label = ibm_ilog.diagram.editor.undo.UndoActionList.Group;
	},
	setElements: function(elements){
		//	
		// summary:
		//		sets the elements list to be group
		this._elements = [];
		dojo.forEach(elements,function(ge){this._elements.push(ge.getId());},this);
	},
	getElements: function(){
		//	
		// summary:
		//		gets the elements list to be group
		return this._elements;
	},
	setSubgraph: function(subgraph){
		//	
		// summary:
		//		sets the subgraph where to group
		this._subgraph = subgraph.getId();
	},
	getSubgraph: function(){
		//	
		// summary:
		//		gets the subgraph where to group
		return this._subgraph;
	},
	redoFunction: function(){
		var elements = this._getNewList();
		var D = this.getUndoManager().getDiagram();
		var result = eu.groupElements(D,elements,this._subgraphName);
		this.getUndoManager().registerGraphElementReplacement(this._subgraph,result.subgraph.getId());
		this._subgraph = result.subgraph.getId();
	},
	undoFunction: function(){
		var newElements = this._getNewList();
		var D = this.getUndoManager().getDiagram();
		var sg = this.getUndoManager().getRegisteredGraphElement(this._subgraph);
		eu.groupReparent(D,newElements,sg.getParent(),sg);
		this._subgraphName = sg.getLabel();
		sg.getParent().remove(sg); 
		sg.dispose();
	},
	_getNewList: function(){
		var newElements = [];
		var elements = this.getElements();
		dojo.forEach(elements, dojo.hitch(this, function(item){
			var newItem = this.getUndoManager().getRegisteredGraphElement(item);
			newElements.push(newItem);
		}));
		return newElements;
	}
	});
	
})();