dojo.provide('ibm_ilog.diagram.editor.undo.InvertLinkAction');

dojo.require('ibm_ilog.diagram.editor.undo.Action');
dojo.require('ibm_ilog.diagram.util.ErrorReporter');
dojo.require('ibm_ilog.diagram.editor.undo.UndoActionList');
dojo.require('ibm_ilog.diagram.editor.EditingUtils');


(function(){
	var R = ibm_ilog.diagram.util.ErrorReporter;
	
	dojo.declare("ibm_ilog.diagram.editor.undo.InvertLinkAction", [ibm_ilog.diagram.editor.undo.Action], {
		//
		//	summary:
		//		this action undo / redo a reparenting action.
		_modifiedElementId: null,
	
	constructor:function(){
		//	
		// summary:
		//		creates a new instance, setting the corresponding label
		this._label = ibm_ilog.diagram.editor.undo.UndoActionList.InvertLink;
		this.initialize(dojo.hitch(this,this._changeFunction),dojo.hitch(this,this._changeFunction));
	},
	setModifiedElementId: function(modifiedElementId){
		//	
		// summary:
		//		sets the modified element Id
		this._modifiedElementId= modifiedElementId;
	},
	_changeFunction: function(){
		var modifiedElement = this.getUndoManager().getRegisteredGraphElement(this._modifiedElementId);
		ibm_ilog.diagram.editor.EditingUtils.invertLink(modifiedElement);
	}
	});
	
})();