dojo.provide('ibm_ilog.diagram.editor.undo.PasteNodeAction');

dojo.require('ibm_ilog.diagram.editor.undo.UserCustomizedAction');
dojo.require('ibm_ilog.diagram.editor.undo.UndoActionList');

dojo.declare("ibm_ilog.diagram.editor.undo.PasteNodeAction", [ibm_ilog.diagram.editor.undo.UserCustomizedAction], {
	elementId: null,
	parentId: null,
	template: null,
	transformation: null,
	label: null,
	isSubgraph: null,
	collapsed:false,
	constructor:function(){
		this.setLabel(ibm_ilog.diagram.editor.undo.UndoActionList.Paste);
		this.initialize(dojo.hitch(this,this._undoFunction),dojo.hitch(this,this._redoFunction));
	},
	_undoFunction: function(){
		var ge = this.getUndoManager().getRegisteredGraphElement(this.elementId);
		ge.getParent().remove(ge);
		ge.dispose();
	},
	_redoFunction: function(){
		var container = this.getUndoManager().getRegisteredParent(this.parentId);
		var ge;
		if(this.isSubgraph){
			ge = this.getUndoManager().getDiagram().createSubgraph(this.template,null,container);
		    ge.setCollapsed(this.collapsed);
		}else{
			ge = this.getUndoManager().getDiagram().createNode(this.template,null,container);
		}
	    ge.setTransform(this.transformation);
	    ge.setLabel(this.label);
	    this.getUndoManager().registerGraphElementReplacement(this.elementId,ge.getId());
	}
});