dojo.provide('ibm_ilog.diagram.editor.undo.ReorderAction');

dojo.require('ibm_ilog.diagram.editor.undo.Action');
dojo.require('ibm_ilog.diagram.util.ErrorReporter');
dojo.require('ibm_ilog.diagram.editor.undo.UndoActionList');
dojo.require('ibm_ilog.diagram.editor.EditingUtils');


(function(){
	var R = ibm_ilog.diagram.util.ErrorReporter;
	
	dojo.declare("ibm_ilog.diagram.editor.undo.ReorderAction", [ibm_ilog.diagram.editor.undo.Action], {
		//
		//	summary:
		//		this action undo / redo a reordering action.
		_newElementList: null,
		_oldElementList: null,
	
	constructor:function(){
		//	
		// summary:
		//		creates a new instance, setting the corresponding label
		this._label = ibm_ilog.diagram.editor.undo.UndoActionList.Reorder;
		this.initialize(dojo.hitch(this,this._undoFunction),dojo.hitch(this,this._redoFunction));
	},
	setNewElementList: function(elementList){
		//	
		// summary:
		//		sets the new element list
		this._newElementList = [];
		dojo.forEach(elementList,function(ge){this._newElementList.push(ge.getId());},this);
	},
	setOldElementList: function(elementList){
		//	
		// summary:
		//		sets the old element list
		this._oldElementList = [];
		dojo.forEach(elementList,function(ge){this._oldElementList.push(ge.getId());},this);
	},
	_undoFunction: function(){
		var elements = this._getList(this._oldElementList);
		ibm_ilog.diagram.editor.EditingUtils.setChildrenOrder(elements);
	},
	_redoFunction: function(){
		var elements = this._getList(this._newElementList);
		ibm_ilog.diagram.editor.EditingUtils.setChildrenOrder(elements);
	},
	_getList: function(elements){
		var newElements = [];
		dojo.forEach(elements, dojo.hitch(this, function(item){
			var newItem = this.getUndoManager().getRegisteredGraphElement(item);
			newElements.push(newItem);
		}));
		return newElements;
	}
	});
	
})();