dojo.provide('ibm_ilog.diagram.editor.undo.ReparentingAction');

dojo.require('ibm_ilog.diagram.editor.undo.Action');
dojo.require('ibm_ilog.diagram.util.ErrorReporter');
dojo.require('ibm_ilog.diagram.editor.undo.UndoActionList');


(function(){
	var R = ibm_ilog.diagram.util.ErrorReporter;
	
	dojo.declare("ibm_ilog.diagram.editor.undo.ReparentingAction", [ibm_ilog.diagram.editor.undo.Action], {
		//
		//	summary:
		//		this action undo / redo a reparenting action.
		_newParentId: null,
		_oldParentId: null,
		_modifiedElementId: null,
	
	constructor:function(){
		//	
		// summary:
		//		creates a new instance, setting the corresponding label
		this._label = ibm_ilog.diagram.editor.undo.UndoActionList.ReParent;
		this.initialize(dojo.hitch(this,this._undoFunction),dojo.hitch(this,this._redoFunction));
	},
	setNewParentId: function(newParentId){
		//	
		// summary:
		//		sets the new parent Id
		this._newParentId = newParentId;
	},
	setOldParentId: function(oldParentId){
		//	
		// summary:
		//		sets the old parent Id
		this._oldParentId= oldParentId;
	},
	setModifiedElementId: function(modifiedElementId){
		//	
		// summary:
		//		sets the modified element Id
		this._modifiedElementId= modifiedElementId;
	},
	_undoFunction: function(){
		var modifiedElement = this.getUndoManager().getRegisteredGraphElement(this._modifiedElementId);
		var oldParent = this.getUndoManager().getRegisteredParent(this._oldParentId);
		oldParent.add(modifiedElement);
	},
	_redoFunction: function(){
		var modifiedElement = this.getUndoManager().getRegisteredGraphElement(this._modifiedElementId);
		var newParent = this.getUndoManager().getRegisteredParent(this._newParentId);
		newParent.add(modifiedElement);
	}
	});
	
})();