dojo.provide('ibm_ilog.graphlayout.forcedirected.FMMAlgorithm');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.basic.BasicLinkStyleLayout');
dojo.require('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout');
dojo.require('ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo');
dojo.require('ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo');
dojo.require('ibm_ilog.graphlayout.forcedirected.RegularizationAlgo');
dojo.require('ibm_ilog.graphlayout.forcedirected.SolarSystemNode');
dojo.require('ibm_ilog.graphlayout.forcedirected.ULEAlgorithm');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphAdapter');
dojo.require('ibm_ilog.graphlayout.internalutil.IFixedNode');
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.ReshapeLinkUtil');
dojo.require('ibm_ilog.graphlayout.GraphLayoutReport');

dojo.declare('ibm_ilog.graphlayout.forcedirected.FMMAlgorithm', null, 
{
  // summary:
  //		This class is the main internal class for the FMMM (Fast Multilevel
  //		Method) algorithm. 
  // description:
  //		This class is the main internal class for the FMMM (Fast Multilevel
  //		Method) algorithm. 
  //		
  // tags:
  //		private
  
  _factorOfElapsedTimeForRefinement: null,
  _factorOfTotalAllowedTimeForRefinement: null,
  _maxRepeatForConvergence: null,

  _globalStartTime: null,

  _ule: null,

  _auxUle: null,

  constructor : function(layout)
  {
    // summary:
    //		The auxiliary instance of ULE that is used by FMMM.
    
    this._ule = layout;
  },
  
  detach : function()
  {
    if (this._auxUle != null) {
      this._auxUle.detach();
    }
  },

  doLayout : function(graphModel, redraw)
  {
    // summary:
    //		Executes the layout.
    
    if (this._ule.getLinkStyle() == ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.STRAIGHT_LINE_STYLE) {
      ibm_ilog.graphlayout.internalutil.GraphModelUtil.deleteIntermediatePointsOnLinks(graphModel, this._ule);
    }
    this._globalStartTime = new Date().getTime();
    this._factorOfElapsedTimeForRefinement = this._ule.getMaxPercentageOfElapsedTimeForRefinement() / 100;
    this._factorOfTotalAllowedTimeForRefinement = this._ule.getMaxPercentageOfTotalAllowedTimeForRefinement() / 100;
    this._maxRepeatForConvergence = this._ule.getMaxRepeatForConvergence();
    var globalAllowedTime = this._ule.getAllowedTime();
    this._auxUle = null;

    var graphs = new Array();
    var models = new Array();
    var multilevelPartioner = new ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo();
    multilevelPartioner.run(graphModel, graphs, models);
    var nGraphs = graphs.length;

    if (nGraphs >= 1)
    {
      var model;
      var parentGraph;
      var parentModel;
      var childGraph = null;
      var nGraphsMinusOne = nGraphs - 1;

      var graph;
      var regularization = new ibm_ilog.graphlayout.forcedirected.RegularizationAlgo();

      for (var i = nGraphsMinusOne; i >= 0; i--)
      {
        graph = graphs[i];
        model = models[i];

        if (i < nGraphsMinusOne)
        {
          childGraph = graphs[i + 1];
        }

        this.doLayoutImpl(model, childGraph, nGraphs, i, globalAllowedTime, false, i == nGraphsMinusOne, redraw);

        if (i >= 1)
        {
          parentGraph = graphs[i - 1];
          parentModel = models[i - 1];
          var nodes = parentGraph.getNodes();

          while (nodes.hasNext())
          {
            var node = nodes.next();
            var solarSystemNode = ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.getSolarSystemNode(node);

            var bbox = graph.boundingBox(solarSystemNode);

            parentGraph.move(node, bbox.x, bbox.y);
          }

          var regModel = parentModel;

          if (regModel instanceof ibm_ilog.graphlayout.forcedirected.FMMAlgorithm.TopLevelAbstractGraphAdapter)
          {
            (regModel).setMoveInOriginalModel(false);
          }

          regularization.regularize(regModel, new FMMAlgorithmAnonClass_1(regModel));
        }
      }
    }

    this.doLayoutImpl(models[0], null, nGraphs, -1, globalAllowedTime, true, false, redraw);

    var layoutReport = this._ule.getLayoutReport();

    layoutReport.setCode(ibm_ilog.graphlayout.GraphLayoutReport.LAYOUT_DONE);
    layoutReport.setNumberOfIterations(this._ule.getAllowedNumberOfIterations());
  },

  doLayoutImpl : function(graphModel, childGraph, nLevels, level, globalAllowedTime, isRefinementStep, isSmallestGraph, redraw)
  {
    // summary:
    //		Executes the force-directed layout of the provided model using the
    //		provided number of iterations.
    // tags:
    //		private
    
    if (this._auxUle == null)
    {
      this._auxUle = new ibm_ilog.graphlayout.forcedirected.MultipoleULELayout(this._ule);
      this._auxUle.setRespectNodeSizes(true);

      this._auxUle.setPreserveFixedNodes(this._ule.isPreserveFixedNodes());
      this._auxUle.setAdditionalNodeRepulsionWeight(0.2);
      this._auxUle.setPreferredLinksLength(2 * this._ule.getPreferredLinksLength());

      this._auxUle.setMaxAllowedMovePerIteration(this._ule.getMaxAllowedMovePerIteration());

      this._auxUle.setLinkStyle(ibm_ilog.graphlayout.basic.BasicLinkStyleLayout.NO_RESHAPE_STYLE);
      this._auxUle.setLinkLengthWeight(0.1);

      this._auxUle.setForceFitToLayoutRegion(this._ule.isForceFitToLayoutRegion());
      this._auxUle.setLayoutOfConnectedComponentsEnabled(this._ule.isLayoutOfConnectedComponentsEnabled());

      var layoutOfConnComp = this._ule.getLayoutOfConnectedComponents();
      if (layoutOfConnComp != null) {
        this._auxUle.setLayoutOfConnectedComponents(layoutOfConnComp.copy());
      }
    }

    if (this._auxUle.getGraphModel() != graphModel)
    {
      var modelChecking = ibm_ilog.graphlayout.internalutil.GraphModelData.getData(graphModel).internalGraphModelChecking;

      ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel, false);

      this._auxUle.setGraphModel(graphModel);

      ibm_ilog.graphlayout.internalutil.GraphModelData.setInternalGraphModelChecking(graphModel,
        modelChecking);
    }

    if (level <= 0)
    {
      this._auxUle.setPreferredLinksLength(this._ule.getPreferredLinksLength());
      this._auxUle.setRespectNodeSizes(this._ule.isRespectNodeSizes());
      this._auxUle.setAdditionalNodeRepulsionWeight(this._ule.getAdditionalNodeRepulsionWeight());
    }

    this._auxUle.setULEMode(isRefinementStep);

    this._auxUle.setLayoutMode(
        ((!isSmallestGraph || isRefinementStep)
          ? ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.INCREMENTAL_MODE
          : ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.NON_INCREMENTAL_MODE));

    if (isRefinementStep && graphModel instanceof ibm_ilog.graphlayout.forcedirected.FMMAlgorithm.TopLevelAbstractGraphAdapter)
    {
      (graphModel).setMoveInOriginalModel(true);
      var threshold = this._ule.getConvergenceThreshold();

      if (nLevels <= 2) {
        threshold *= 0.5;
      }
      this._auxUle.setConvergenceThreshold(threshold);
      this._auxUle.setLinkLengthWeight(this._ule.getLinkLengthWeight());
      this._auxUle.setLinkStyle(this._ule.getLinkStyle());
    }

    this._auxUle.getULEAlgorithm().setPreprocessingMode(
        (isSmallestGraph ? ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.HIERARCHICAL_PREPROCESSING : ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.NO_PREPROCESSING));
    var isIncremental = this._auxUle.getLayoutMode() == ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout.INCREMENTAL_MODE;

    if (isIncremental)
    {
      var counter = 0;

      var maxRepeat = (isRefinementStep ? 1 : this._maxRepeatForConvergence);

      while ((counter < maxRepeat) && (counter == 0 || !this._ule.isLayoutTimeElapsedPackage()))
      {
        if (isRefinementStep)
        {
          var durationSpentSoFar = new Date().getTime() - this._globalStartTime;

          var allowedTime = (nLevels > 1 ? Math.min(this._factorOfElapsedTimeForRefinement * durationSpentSoFar, this._factorOfTotalAllowedTimeForRefinement * globalAllowedTime) : globalAllowedTime);

          this._auxUle.setAllowedTime(allowedTime);
        }
        else
        {
          this._auxUle.setAllowedTime(this._ule.getRemainingAllowedTime());
        }

        this._auxUle.performLayout(childGraph, isSmallestGraph, redraw);
        counter++;

        if (isRefinementStep && !isSmallestGraph && nLevels > 2) {
          break;
        }
      }
    }
    else
    {
      this._auxUle.setAllowedTime(this._ule.getRemainingAllowedTime());

      this._auxUle.performLayout(childGraph, isSmallestGraph, redraw);
    }

    this._ule.callLayoutStepPerformedIfNeeded();
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.forcedirected.FMMAlgorithm,
{
}
);

/**
 * @private
 */
dojo.declare('FMMAlgorithmAnonClass_1', ibm_ilog.graphlayout.internalutil.IFixedNode,
{
  // tags:
  //		private
  
  __regModel : null,

  constructor : function(input__regModel)
  {
    
    this.__regModel = input__regModel;
  },

  isFixed : function(node)
  {
    if (node instanceof ibm_ilog.graphlayout.forcedirected.SolarSystemNode)
    {
      var sn = node;
      if (sn.getType() == ibm_ilog.graphlayout.forcedirected.SolarSystemNode.SUN_NODE) {
        return true; // Boolean
      }
    }

    return ibm_ilog.graphlayout.internalutil.GraphModelUtil.getNodeDegree(this.__regModel, node) < 2; // Boolean
  }

});

dojo.declare('ibm_ilog.graphlayout.forcedirected.FMMAlgorithm.TopLevelAbstractGraphAdapter', ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphAdapter, 
{
  _graphModel: null,
  _moveInOriginalModel : null,

  constructor : function(graph, graphModel)
  {
    this._moveInOriginalModel = false;
    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6012E");
    }

    this._graphModel = graphModel;
  },
  
  moveNode : function(node, x, y, redraw)
  {
    // summary:
    //		Changes the position of the specified node.  
    // node: Object
    //		the node.
    // x: Number
    //		the new x position.
    // y: Number
    //		the new y position.
    // redraw: Boolean
    //		is true the object is redrawn.
    // tags:
    //		private
    
    if (this._moveInOriginalModel)
    {
      var origObj = (node).getOriginalObject();
      this._graphModel.moveNode(origObj, x, y);
    }
    else
    {
      this.inherited("moveNode", arguments, [node, x, y]);
    }
  },

  setMoveInOriginalModel : function(flag)
  {
    // summary:
    //		Sets whether the move of nodes is done in the original GraphModel or
    //		in the AbstractGraph. 
    // description:
    //		Sets whether the move of nodes is done in the original GraphModel or
    //		in the AbstractGraph. 
    //		The default is false.
    // tags:
    //		private
    
    this._moveInOriginalModel = flag;
  },

  isMoveInOriginalModel : function()
  {
    // summary:
    //		Sets whether the move of nodes is done in the original GraphModel or
    //		in the AbstractGraph. 
    // description:
    //		Sets whether the move of nodes is done in the original GraphModel or
    //		in the AbstractGraph. 
    //		The default is false.
    // tags:
    //		private
    
    return this._moveInOriginalModel; // Boolean
  }

}
);
