dojo.provide('ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.forcedirected.FMMAlgorithm');
dojo.require('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout');
dojo.require('ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo');
dojo.require('ibm_ilog.graphlayout.forcedirected.SolarSystemNode');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph');
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphAdapter');
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractLink');
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');

dojo.declare('ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo', null, 
{
  // summary:
  //		Partitions the graph for the FMM algo.  
  // tags:
  //		private
  
  constructor : function()
  {
  },
  
  run : function(graphModel, graphs, models)
  {
    // summary:
    //		Creates the multilevel partitioning of the graph described by the
    //		given model. 
    // description:
    //		Creates the multilevel partitioning of the graph described by the
    //		given model. 
    //		The method fills the lists <code>graphs</code> and
    //		<code>models</code>.
    
    var graph = new ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraph(graphModel);
    graphs.push(graph);

    models.push(new ibm_ilog.graphlayout.forcedirected.FMMAlgorithm.TopLevelAbstractGraphAdapter(graph, graphModel));
    var coarseningAlgo = new ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo();
    this.fill(graph, graphModel);

    while (graph.getNodesCount() > 10)
    {
      graph = coarseningAlgo.createCoarserGraph(graph, graphModel);
      if (graph.getNodesCount() < 3 || graph.getLinksCount() < 3) {
        break;
      }
      graphs.push(graph);
      models.push(new ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractGraphAdapter(graph));
    }
  },

  fill : function(graph, graphModel)
  {
    // summary:
    //		Creates an abstract graph from a given graph model. 
    // description:
    //		Creates an abstract graph from a given graph model. 
    //		The following links are filtered out: - Self-links. - Multilinks
    //		(only one link between the same pair of nodes).
    // tags:
    //		private
    
    var nodes = new ibm_ilog.graphlayout.internalutil.ArrayIterator(graphModel.getNodes());

    while (nodes.hasNext())
    {
      var node = nodes.next();
      var abstractNode = new ibm_ilog.graphlayout.forcedirected.SolarSystemNode(node, ibm_ilog.graphlayout.internalutil.GraphModelUtil.getObjectBounds(graphModel,
              node));
      graphModel.setParameter(node, ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo.ABSTRACT_NODE, abstractNode);
      graph.addNode(abstractNode);
    }

    var links = new ibm_ilog.graphlayout.internalutil.ArrayIterator(graphModel.getLinks());

    while (links.hasNext())
    {
      var link = links.next();
      var from = graphModel.getFrom(link);
      var toobj = graphModel.getTo(link);

      if (from != toobj)
      {
        var abstractFrom = graphModel.getParameter(from, ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo.ABSTRACT_NODE);
        var abstractTo = graphModel.getParameter(toobj, ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo.ABSTRACT_NODE);

        if (abstractFrom == abstractTo)
        {
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6761E");
        }

        if (!graph.isLinkBetween(abstractFrom, abstractTo))
        {
          var abstractLink = new ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractLink(abstractFrom, abstractTo);

          graph.addLink(abstractLink);
          abstractLink.setUserData(link);
          abstractLink.setOriginalObject(link);
        }
      }
    }

    nodes = new ibm_ilog.graphlayout.internalutil.ArrayIterator(graphModel.getNodes());

    while (nodes.hasNext())
    {
      var no = nodes.next();
      graphModel.setParameter(no, ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo.ABSTRACT_NODE, null);
    }
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo,
{
  ABSTRACT_NODE : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo;
    
    c.ABSTRACT_NODE = "__abstractNode";
  }
  
}
);

(function(){ ibm_ilog.graphlayout.forcedirected.MultilevelGraphPartitioningAlgo._fields_init(); })();
