dojo.provide('ibm_ilog.graphlayout.forcedirected.MultipoleULELayout');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout');
dojo.require('ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo');
dojo.require('ibm_ilog.graphlayout.forcedirected.ULEAlgorithm');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractLink');
dojo.require('ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode');
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.forcedirected.MultipoleULELayout', ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, 
{
  // summary:
  //		Multiple ULE layout. 
  // description:
  //		Multiple ULE layout. 
  //		
  // tags:
  //		private
  
  _originalUle: null,

  _childGraph: null,

  _algo: null,

  constructor : function(originalUle)
  {
    if (originalUle == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout, "graphlayout.expert.message.6762E");
    }

    this._originalUle = originalUle;
  },
  
  createULEAlgorithm : function()
  {
    this._algo = new ibm_ilog.graphlayout.forcedirected.MultipoleULEAlgorithm(this);
    return this._algo; // ibm_ilog.graphlayout.forcedirected.ULEAlgorithm
  },

  setULEMode : function(s)
  {
    this._algo._uleMode = s;
  },

  isFixed : function(nodeOrLink)
  {
    // summary:
    
    if (nodeOrLink instanceof ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractNode) {
      nodeOrLink = (nodeOrLink).getOriginalObject();
    }
    return this._originalUle.isFixed(nodeOrLink); // Boolean
  },

  getPreferredLength : function(link)
  {
    // summary:
    
    if (link instanceof ibm_ilog.graphlayout.internalutil.genericgrapher.AbstractLink)
    {
      link = (link).getOriginalObject();

      if (link == null)
      {
        return ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._defaultPreferredIndividualLinksLength; // Number
      }
    }

    return this._originalUle.getPreferredLength(link); // Number
  },

  performLayout : function(childGraph, isSmallestGraph, redraw)
  {
    // summary:
    
    this._childGraph = childGraph;

    return this.inherited("performLayout", arguments, [true]); // ibm_ilog.graphlayout.GraphLayoutReport
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.forcedirected.MultipoleULELayout,
{
  DEPTH : null,

  RESCALE_FACTOR : null,

  ITERATE_OVER_NODES : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.forcedirected.MultipoleULELayout;
    if(ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._fields_init)
      ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._fields_init(c);
    
    c.DEPTH = 1;
    c.RESCALE_FACTOR = 1.5;
    c.ITERATE_OVER_NODES = false;
  }
  
}
);

ibm_ilog.graphlayout.forcedirected.MultipoleULELayout._getGlobalProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._getGlobalProperties();
};

ibm_ilog.graphlayout.forcedirected.MultipoleULELayout._getNodeProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._getNodeProperties();
};

ibm_ilog.graphlayout.forcedirected.MultipoleULELayout._getLinkProperties = function()
{
  // tags:
  //		private
  return ibm_ilog.graphlayout.forcedirected.ForceDirectedLayout._getLinkProperties();
};

dojo.declare('ibm_ilog.graphlayout.forcedirected.MultipoleULEAlgorithm', ibm_ilog.graphlayout.forcedirected.ULEAlgorithm, 
{
  _nodeList: null,
  _vectDx: null,
  _vectDy: null,

  _uleMode : null,

  constructor : function(layout)
  {
    this._uleMode = false;
  },
  
  detach : function()
  {
    this._vectDx = null;
    this._vectDy = null;
    this.inherited("detach", arguments, []);
  },

  initializeDataStructures : function()
  {
    this.inherited("initializeDataStructures", arguments, []);

    if (!this._uleMode)
    {
      var nNodes = this._topologicalData.getNumberOfNodes();

      if (this._vectDx == null || nNodes != this._vectDx.length)
      {
        this._vectDx = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nNodes, 0);
        this._vectDy = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nNodes, 0);
      }
      else
      {
        for (var i = 0; i < nNodes; i++)
        {
          this._vectDx[i] = 0;
          this._vectDy[i] = 0;
        }
      }
    }
  },

  init : function()
  {
    this.inherited("init", arguments, []);

    if (!this._uleMode)
    {
      var multipoleUle = this.getOriginalUle();
      var childGraph = multipoleUle._childGraph;
      if (childGraph != null) {
        this.initGraph(childGraph);
      }
    }
  },

  clean : function()
  {
    this.inherited("clean", arguments, []);
    this._nodeList = null;
  },

  getPreprocessingMode : function()
  {
    return ibm_ilog.graphlayout.forcedirected.ULEAlgorithm.HIERARCHICAL_PREPROCESSING; // int
  },

  doLayout : function(redraw)
  {
    if (!this._uleMode) {
      this._positionData.rescale(ibm_ilog.graphlayout.forcedirected.MultipoleULELayout.RESCALE_FACTOR);
    }
    try
    {
      this.inherited("doLayout", arguments, [redraw]);
    }
    finally
    {
      this._uleMode = false;
    }
  },

  initGraph : function(childGraph)
  {
    // summary:
    //		
    // tags:
    //		private
    
    var nNodes = childGraph.getNodesCount();
    var nLinks = childGraph.getLinksCount();
    var nNodesInOrigGraph = this._ule.getGraphModel().getNodesCount();

    if (nLinks < 3 || nNodes < 3)
    {
      this._nodeList = null;
      return;
    }

    var list = null;

    if (ibm_ilog.graphlayout.forcedirected.MultipoleULELayout.ITERATE_OVER_NODES)
    {
      this._nodeList = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nNodes, null);
      var nodeCounter = 0;
      var nodes = childGraph.getNodes();
      var neigh;
      var neighBis;

      while (nodes.hasNext())
      {
        var node = nodes.next();
        list = new Array();
        this._nodeList[nodeCounter++] = list;

        var nodeneighbs = childGraph.getNeighbors(node);

        while (nodeneighbs.hasNext())
        {
          neigh = nodeneighbs.next();

          if (neigh != node)
          {
            this.fill(list, neigh);

            if (ibm_ilog.graphlayout.forcedirected.MultipoleULELayout.DEPTH == 2)
            {
              var neighbsBis = childGraph.getNeighbors(neigh);

              while (neighbsBis.hasNext())
              {
                neighBis = neighbsBis.next();
                if (neighBis != node && neighBis != neigh) {
                  this.fill(list, neighBis);
                }
              }
            }
          }
        }

        if (list.length > (nNodesInOrigGraph * 0.3))
        {
          this._nodeList = null;
          return;
        }
      }
    }
    else
    {
      this._nodeList = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nLinks, null);
      var linkCounter = 0;
      var links = childGraph.getLinks();

      while (links.hasNext())
      {
        var link = links.next();
        list = new Array();
        this._nodeList[linkCounter++] = list;

        if (ibm_ilog.graphlayout.forcedirected.MultipoleULELayout.DEPTH == 1)
        {
          this.fill(list, childGraph.getFrom(link));
          this.fill(list, childGraph.getTo(link));
        }
        else
        {
          var fromNode = childGraph.getFrom(link);
          var toNode = childGraph.getTo(link);
          this.fill(list, fromNode);
          this.fill(list, toNode);
          var neighbs = childGraph.getNeighbors(fromNode);
          var neighb = null;

          while (neighbs.hasNext())
          {
            neighb = neighbs.next();
            if (neighb != toNode) {
              this.fill(list, neighb);
            }
          }

          neighbs = childGraph.getNeighbors(toNode);

          while (neighbs.hasNext())
          {
            neighb = neighbs.next();
            if (neighb != fromNode) {
              this.fill(list, neighb);
            }
          }
        }

        if (list.length > (nNodesInOrigGraph * 0.3))
        {
          this._nodeList = null;
          return;
        }
      }
    }
  },

  fill : function(list, node)
  {
    var solarSystemNode = node.getTargetObject();

    var id = this._layoutData.getIntIdentifier(solarSystemNode);
    list.push((id));
    var planets = ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.getPlanets(solarSystemNode);

    var pNode;
    var mNode;

    if (planets != null)
    {
      var _for_each_array_1 = planets;
      for (var _for_each_index_1 = 0; _for_each_index_1 < _for_each_array_1.length; _for_each_index_1++)
      {
        var opNode = _for_each_array_1[_for_each_index_1];
        pNode = opNode;
        id = this._layoutData.getIntIdentifier(pNode);
        list.push((id));
        var moons = ibm_ilog.graphlayout.forcedirected.GraphCoarseningAlgo.getMoons(pNode);

        if (moons != null)
        {
          var _for_each_array_2 = moons;
          for (var _for_each_index_2 = 0; _for_each_index_2 < _for_each_array_2.length; _for_each_index_2++)
          {
            var omNode = _for_each_array_2[_for_each_index_2];
            mNode = omNode;
            id = this._layoutData.getIntIdentifier(mNode);
            list.push((id));
          }
        }
      }
    }
  },

  computeNodeForces : function(minNodeDist, additionalNodeRepulsionWeight, convergenceThreshold, respectNodeSizes, random)
  {
    if (this._nodeList == null || this._uleMode)
    {
      this.inherited("computeNodeForces", arguments, [minNodeDist, additionalNodeRepulsionWeight, convergenceThreshold, respectNodeSizes, random]);
      return;
    }

    var vx = 0;
    var vy = 0;
    var dx = 0;
    var dy = 0;
    var dx1 = 0;
    var dy1 = 0;
    var f;
    var len;
    var sqrtLen;
    var minDistWeight = additionalNodeRepulsionWeight / 3;
    var desiredMinDist = minNodeDist;
    var randomValueRange = convergenceThreshold * 2;
    var nTotalNodes = this._topologicalData.getNumberOfNodes();
    var nodeId1;

    for (nodeId1 = 0; nodeId1 < nTotalNodes; nodeId1++)
    {
      this._vectDx[nodeId1] = 0;
      this._vectDy[nodeId1] = 0;
    }

    var vectNodesPositionX = this._positionData.getVectNodesPositionX();
    var vectNodesPositionY = this._positionData.getVectNodesPositionY();
    var n = this._nodeList.length;

    for (var i = 0; i < n; i++)
    {
      var list = this._nodeList[i];
      var nNodes = (list != null ? list.length : 0);

      for (var j = 0; j < nNodes; j++)
      {
        nodeId1 =  (list[j]);

        dx = this._vectDx[nodeId1];
        dy = this._vectDy[nodeId1];

        for (var k = 0; k < nNodes; k++)
        {
          var nodeId2 =  (list[k]);
          if (nodeId1 == nodeId2) {
            continue;
          }
          vx = vectNodesPositionX[nodeId1] - vectNodesPositionX[nodeId2];
          vy = vectNodesPositionY[nodeId1] - vectNodesPositionY[nodeId2];
          len = vx * vx + vy * vy;

          if (minDistWeight > 0)
          {
            sqrtLen = Math.sqrt(len);
            sqrtLen = ((sqrtLen == 0) ? 0.0001 : sqrtLen);
            if (respectNodeSizes) {
              desiredMinDist = minNodeDist + this._vectHalfNodeDiag[nodeId1] + this._vectHalfNodeDiag[nodeId2];
            }
            if (sqrtLen < desiredMinDist)
            {
              f = (minDistWeight * ((desiredMinDist - sqrtLen) / sqrtLen));
              dx1 = f * vx;
              dy1 = f * vy;
              this._vectNodesDx[nodeId1] += dx1;
              this._vectNodesDy[nodeId1] += dy1;
              this._vectNodesDx[nodeId2] -= dx1;
              this._vectNodesDy[nodeId2] -= dy1;
            }
          }

          if (len <= ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT)
          {
            dx += this.getRandomValue(randomValueRange, random);
            dy += this.getRandomValue(randomValueRange, random);
            dx += vx / 3;
            dy += vy / 3;
          }
          else
          {
            dx += vx / len;
            dy += vy / len;
          }

          this._vectDx[nodeId1] = dx;
          this._vectDy[nodeId1] = dy;
        }
      }
    }

    for (nodeId1 = 0; nodeId1 < nTotalNodes; nodeId1++)
    {
      dx = this._vectDx[nodeId1];
      dy = this._vectDy[nodeId1];
      var dlen = dx * dx + dy * dy;

      if (dlen <= ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT)
      {
        this._vectNodesDx[nodeId1] += this.getRandomValue(randomValueRange, random);
        this._vectNodesDy[nodeId1] += this.getRandomValue(randomValueRange, random);
      }
      else
      {
        dlen = Math.sqrt(dlen) / 2;

        if (dlen > ibm_ilog.graphlayout.internalutil.TranslateUtil.NEAR_ZERO_FLOAT)
        {
          this._vectNodesDx[nodeId1] += dx / dlen;
          this._vectNodesDy[nodeId1] += dy / dlen;
        }
      }
    }

    this._ule.callLayoutStepPerformedIfNeeded();
  }

}
);

(function(){ ibm_ilog.graphlayout.forcedirected.MultipoleULELayout._fields_init(); })();
