dojo.provide('ibm_ilog.diagram.graphlayout._base');

// Explanation for the following requires:
// The classes below are used directly by the ibm_ilog.diagram.graphlayout.LayoutRunner class
// when graph layouts are attached to a Graph instance. But, we do not want to load
// them if graph layout is not used at all in a Dojo Diagrammer application.
// So, we do not explicitly require these classes from LayoutRunner.js.
// Instead, we require them from a common class in the ibm_graphlayout module, TranslateUtil,
// and we rely on the fact that an application will have to dojo.require()
// some of the ibm_graphlayout classes, at least to create the GraphLayout instance.
// Since all ibm_graphlayout classes require TranslateUtil, this will in turn load
// the classes below, and LayoutRunner will be able to do its work.
// We protect this requires with a "requireIf", so that when ibm_graphlayout is used
// independently from ibm_diagram (for example, in a Web Worker), the classes will not be loaded.

dojo.require('ibm_ilog.diagram.graphlayout.Animation');
dojo.require('ibm_ilog.diagram.graphlayout._LayoutProvider');
dojo.require('ibm_ilog.graphlayout.RecursiveMultipleLayout');
dojo.require('ibm_ilog.diagram.graphlayout.GraphAdapter');
