dojo.provide('ibm_ilog.graphlayout.hierarchical.BuildRelPosNetsAlgorithm');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.hierarchical.makeacyclic.Algorithm');
dojo.require('ibm_ilog.graphlayout.hierarchical.relpositioning.HRPColoring');
dojo.require('ibm_ilog.graphlayout.hierarchical.relpositioning.HRPOrdering');
dojo.require('ibm_ilog.graphlayout.hierarchical.relpositioning.HRPTransform');
dojo.require('ibm_ilog.graphlayout.hierarchical.HConstraintSort');
dojo.require('ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm');
dojo.require('ibm_ilog.graphlayout.hierarchical.HNode');
dojo.require('ibm_ilog.graphlayout.hierarchical.HNodeSort');
dojo.require('ibm_ilog.graphlayout.hierarchical.HPercentages');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalExtremityConstraint');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalLayout');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalRelativePositionConstraint');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalSideBySideConstraint');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.BuildRelPosNetsAlgorithm', ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm, 
{
  // summary:
  //		BuildRelPosNetsAlgorithm builds the constraint networks for the
  //		relative node positions for each level. 
  // description:
  //		BuildRelPosNetsAlgorithm builds the constraint networks for the
  //		relative node positions for each level. 
  //		Each level has its individual constraint network. The constraint
  //		network is made acyclic such that it is easy and fast to solve during
  //		crossing reduction.  
  //		<p>
  //		The constraints are not yet solved here. The network is only
  //		constructed! The real solving is done later during the crossing
  //		reduction.  
  //		</p>
  //		<p>
  //		 
  //		</p>
  // tags:
  //		private
  
  _constraintManager: null,
  _coloringAlg : null,
  _orderingAlg : null,
  _transformAlg : null,
  _sortAlg : null,
  _incrementalLayout: null,
  _handleDummyNodesIncremental : null,

  constructor : function(graph, constraintManager)
  {
    this._coloringAlg = new ibm_ilog.graphlayout.hierarchical.relpositioning.HRPColoring(null);
    this._orderingAlg = new ibm_ilog.graphlayout.hierarchical.relpositioning.HRPOrdering(null);
    this._transformAlg = new ibm_ilog.graphlayout.hierarchical.relpositioning.HRPTransform(null);
    this._sortAlg = new ibm_ilog.graphlayout.hierarchical.HNodeSort();
    this._handleDummyNodesIncremental = true;
    this.init(graph);
    var numNodes = graph.getNumberOfNodes();
    this._constraintManager = constraintManager;
    this._incrementalLayout = graph.isIncrementalMode() && !graph.isCrossingReductionDuringIncremental();
    this._handleDummyNodesIncremental = this._incrementalLayout && !graph.isLongLinkCrossingReductionDuringIncremental();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
    this._constraintManager = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    this.getPercController().startStep(this.getPercentages().steps[ibm_ilog.graphlayout.hierarchical.HPercentages.STEP_BUILD_RELPOS_NETS], 5, false);

    this.handleEastWestExtremityConstraints();
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();

    this.handleSideBySideConstraints();
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();

    this.handleRelativePositionConstraints();
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();

    if (this._incrementalLayout) {
      this.handleIncremental();
    }
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();

    var iter = this.getGraph().getLevels();
    var constraintNetwork;

    while (iter.hasNext())
    {
      constraintNetwork = iter.next().getConstraintNetwork();
      if (constraintNetwork != null) {
        this.makeAcyclic(constraintNetwork);
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleEastWestExtremityConstraints : function()
  {
    // summary:
    //		Handle all east or west extremity constraints. 
    // description:
    //		Handle all east or west extremity constraints. 
    //		We store the nodes in the corresponding levels, for laster usage.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var node;
    var e = this._constraintManager.getConstraints();
    var constraint;

    while (e.hasNext())
    {
      constraint = e.next();

      if (constraint.isValidForLayout() && constraint instanceof ibm_ilog.graphlayout.hierarchical.HierarchicalExtremityConstraint)
      {
        var c = constraint;

        if (c.getSide() == ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.EAST)
        {
          node = graph.getNode(c.getNode());
          if (!this.isIncremental(node)) {
            node.getLevel().setEastExtremeNode(node);
          }
        }
        else if (c.getSide() == ibm_ilog.graphlayout.hierarchical.HierarchicalLayout.WEST)
        {
          node = graph.getNode(c.getNode());
          if (!this.isIncremental(node)) {
            node.getLevel().setWestExtremeNode(node);
          }
        }
      }
    }

    var iter = graph.getLevels();
    var level;

    while (iter.hasNext())
    {
      level = iter.next();
      if (level.getEastExtremeNode() != null || level.getWestExtremeNode() != null) {
        level.getOrAllocateConstraintNetwork();
      }
    }

    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleSideBySideConstraints : function()
  {
    // summary:
    //		Handle all side by side constraints.
    // tags:
    //		private
    
    var ctable = this.collectConstraints(ibm_ilog.graphlayout.hierarchical.HierarchicalSideBySideConstraint);

    for (var i = 0; i < ctable.length; i++)
      this.handleSideBySideConstraint(ctable[i]);
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleSideBySideConstraint : function(constraint)
  {
    // summary:
    //		Handle one side by side constraint.  
    // constraint:
    //		ibm_ilog.graphlayout.hierarchical.HierarchicalSideBySideConstraint
    //		The constraint to be handled.
    // tags:
    //		private
    
    var hnodes = this.getHNodeVector(constraint.getGroup());

    var nodesPerLevels = this.getDistributionByLevelImpl(hnodes);

    for (var i = 0; i < nodesPerLevels.length; i++)
    {
      if (nodesPerLevels[i].length > 1)
      {
        var node = nodesPerLevels[i][0];
        var level = node.getLevel();
        var constraintNetwork = level.getOrAllocateConstraintNetwork();

        var v = this.getHRPNodeVector(nodesPerLevels[i]);

        this._coloringAlg.init(constraintNetwork);

        if (this._coloringAlg.run(v) == true)
        {
          this._transformAlg.init(constraintNetwork);
          this._transformAlg.run(v);
        }
      }
    }
  },

  handleRelativePositionConstraints : function()
  {
    // summary:
    //		Handle all relative position constraints.
    // tags:
    //		private
    
    var ctable = this.collectConstraints(ibm_ilog.graphlayout.hierarchical.HierarchicalRelativePositionConstraint);

    for (var i = 0; i < ctable.length; i++)
      this.handleRelativePositionConstraint(ctable[i]);
    this.getPercController().addPoints(1);
    this.layoutStepPerformed();
  },

  handleRelativePositionConstraint : function (a0, a1, a2, a3)
  {
    // summary:
    //		Handle one relative position constraints.  
    // constraint:
    //		ibm_ilog.graphlayout.hierarchical.HierarchicalRelativePositionConstraint
    //		The constraint to be handled.
    // tags:
    //		private
    
    if(arguments.length == 1)
      return this.handleRelativePositionConstraint_overload_1(a0);
    else if(arguments.length == 4)
      return this.handleRelativePositionConstraint_overload_4(a0, a1, a2, a3);
  },
  
  handleRelativePositionConstraint_overload_1 : function(constraint)
                                                                    
  {
    var ldist = this.getDistributionByLevel(constraint.getLowerSubject());
    var hdist = this.getDistributionByLevel(constraint.getHigherSubject());
    var level;
    var prio = constraint.getPriority();

    for (var i = 0; i < ldist.length; i++)
    {
      if (ldist[i].length > 0)
      {
        level = (ldist[i][0]).getLevel();

        for (var j = 0; j < hdist.length; j++)
        {
          if (hdist[j].length > 0)
          {
            if ((hdist[j][0]).getLevel() == level) {
              this.handleRelativePositionConstraint(level, ldist[i], hdist[j], prio);
            }
          }
        }
      }
    }
  },

  handleRelativePositionConstraint_overload_4 : function(level, lowerNodes, higherNodes, priority)
  {
    // summary:
    //		Handle one relative position constraint at one level. 
    // description:
    //		Handle one relative position constraint at one level. 
    //		The input vectors are the nodes of type HNode that belong to the
    //		same level.  
    // level: ibm_ilog.graphlayout.hierarchical.HLevel
    //		The level all input nodes belong to.
    // lowerNodes: Array
    //		The nodes of type <tt>HNode</tt> to be placed at the
    //		lower position.
    // higherNodes: Array
    //		The nodes of type <tt>HNode</tt> to be placed at the
    //		higher position.
    // priority: Number
    //		The priority of the constraint.
    // tags:
    //		private
    
    var constraintNetwork = level.getOrAllocateConstraintNetwork();
    var v0 = this.getHRPNodeVector(lowerNodes);
    var v1 = this.getHRPNodeVector(higherNodes);
    this._orderingAlg.init(constraintNetwork);
    this._orderingAlg.run(priority, v0, v1);
  },

  isIncremental : function(node)
  {
    // summary:
    //		Returns 'true' if the node is fixed by incremental
    //		layout.
    // tags:
    //		private
    
    if (!this._incrementalLayout) {
      return false; // Boolean
    }
    if (node.isMarkedForIncremental()) {
      return false; // Boolean
    }
    if (node.isDummyNode() && !this._handleDummyNodesIncremental) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  collectConstraints : function(constrclass)
  {
    // summary:
    //		Collect the constraints of a certain type and return the array of
    //		those constraints sorted by decreasing priorities.
    // tags:
    //		private
    
    var i = 0;
    var e = this._constraintManager.getConstraints();
    var constraint;

    while (e.hasNext())
    {
      constraint = e.next();
      if (constraint.isValidForLayout() && (constraint  instanceof constrclass)) {
        i++;
      }
    }

    var ctable = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(i, null);

    i = 0;
    e = this._constraintManager.getConstraints();

    while (e.hasNext())
    {
      constraint = e.next();
      if (constraint.isValidForLayout() && (constraint  instanceof constrclass)) {
        ctable[i++] = constraint;
      }
    }

    new ibm_ilog.graphlayout.hierarchical.HConstraintSort().sort(ctable);
    return ctable; // Array
  },

  getDistributionByLevel : function(nodeOrGroup)
  {
    // summary:
    //		Translate an object that is either a node or a node group into a
    //		distribution according to levels. 
    // description:
    //		Translate an object that is either a node or a node group into a
    //		distribution according to levels. 
    //		The result is an array of vectors, each array entry contains the
    //		nodes of one level.
    // tags:
    //		private
    
    var nodesPerLevels;

    if (nodeOrGroup instanceof ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup)
    {
      nodesPerLevels = this.getDistributionByLevelImpl(this.getHNodeVector(nodeOrGroup));
    }
    else
    {
      var node = this.getGraph().getNode(nodeOrGroup);

      if (this.isIncremental(node)) {
        nodesPerLevels = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(0, null);
      }
      else
      {
        nodesPerLevels = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(1, null);
        nodesPerLevels[0] = new Array();
        nodesPerLevels[0].push(node);
      }
    }

    return nodesPerLevels; // Array
  },

  getDistributionByLevelImpl : function(nodes)
  {
    // summary:
    //		Order the vector of input nodes according their levels. 
    // description:
    //		Order the vector of input nodes according their levels. 
    //		The result is an array of vectors, each array entry contains the
    //		nodes of one level.   
    // tags:
    //		private
    
    var e;
    var node;
    var level;

    e =  new ibm_ilog.graphlayout.internalutil.ArrayIterator(nodes);

    while (e.hasNext())
    {
      node = e.next();
      node.setMarker(0);
      node.getLevel().setReferenceIndex(-1);
    }

    var numLevels = 0;
    e =  new ibm_ilog.graphlayout.internalutil.ArrayIterator(nodes);

    while (e.hasNext())
    {
      node = e.next();
      level = node.getLevel();
      if (level.getReferenceIndex() == -1) {
        level.setReferenceIndex(numLevels++);
      }
    }

    var nodesPerLevels = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(numLevels, null);

    for (var i = 0; i < numLevels; i++)
      nodesPerLevels[i] = new Array();

    e =  new ibm_ilog.graphlayout.internalutil.ArrayIterator(nodes);

    while (e.hasNext())
    {
      node = e.next();

      if (node.getMarker() == 0)
      {
        nodesPerLevels[node.getLevel().getReferenceIndex()].push(node);
        node.setMarker(1);
      }
    }

    return nodesPerLevels; // Array
  },

  getHNodeVector : function(g)
  {
    // summary:
    //		Translate a group objects into a vector of corresponding HNodes.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var node;
    var v = new Array();
    var e = g.elements();

    while (e.hasNext())
    {
      node = graph.getNode(e.next());
      if (!this.isIncremental(node)) {
        v.push(node);
      }
    }

    return v; // Array
  },

  getHRPNodeVector : function(nodeVector)
  {
    // summary:
    //		Translate a vector of HNodes into a vector of corresponding
    //		HRPNodes.
    // tags:
    //		private
    
    var graph = this.getGraph();
    var v = new Array();
    var e =  new ibm_ilog.graphlayout.internalutil.ArrayIterator(nodeVector);

    while (e.hasNext())
      v.push(graph.getConstraintNode(e.next()));
    return v; // Array
  },

  makeAcyclic : function(graph)
  {
    // summary:
    //		Make a constraint network acyclic.
    // tags:
    //		private
    
    var mkAcyclAlg = new ibm_ilog.graphlayout.hierarchical.makeacyclic.Algorithm(graph, this.getGraph().getLayout(), this.getPercController());
    mkAcyclAlg.run();
    mkAcyclAlg.clean();
  },

  handleIncremental : function (a0)
  {
    // summary:
    //		Handle the nodes that are not marked for incremental complete
    //		recalulation by adding constraint edges between them that ensure
    //		they keep ordered coorrsponding to their coordinates in level flow.
    // tags:
    //		private
    
    if(arguments.length == 0)
      return this.handleIncremental_overload_0();
    else if(arguments.length == 1)
      return this.handleIncremental_overload_1(a0);
  },
  
  handleIncremental_overload_0 : function()
                                          
  {
    var iter = this.getGraph().getLevels();

    while (iter.hasNext())
      this.handleIncremental(iter.next());
  },

  handleIncremental_overload_1 : function(level)
  {
    // summary:
    //		Handle the incremental positions of one level.
    // tags:
    //		private
    
    var graph = this.getGraph();

    var iter = level.getNodes();
    var i = 0;

    while (iter.hasNext())
    {
      if (this.isIncremental(iter.next())) {
        i++;
      }
    }

    if (i == 0) {
      return;
    }

    var nodes = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(i, null);
    var node;

    iter = level.getNodes();
    i = 0;

    while (iter.hasNext())
    {
      node = iter.next();
      if (this.isIncremental(node)) {
        nodes[i++] = node;
      }
    }

    var factor = 1.0;
    var dir = graph.getLevelFlow();

    for (i = 0; i < nodes.length; i++)
      nodes[i].setSortValue(factor * nodes[i].getCenter(dir));

    this._sortAlg.sort(nodes);

    var constraintNetwork = level.getOrAllocateConstraintNetwork();

    for (i = 0; i < nodes.length - 1; i++)
    {
      constraintNetwork.addEdgeForceLeft(10000.0, true, graph.getConstraintNode(nodes[i]), graph.getConstraintNode(nodes[i + 1]));
    }
  }

}
);
