dojo.provide('ibm_ilog.graphlayout.hierarchical.HFloatNodeMarker');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.HFloatNodeMarker', null, 
{
  // summary:
  //		HFloatNodeMarker encapsulates the mechanism to use float number
  //		markers per hierarchical node in graph wrapper algorithms. 
  // description:
  //		HFloatNodeMarker encapsulates the mechanism to use float number
  //		markers per hierarchical node in graph wrapper algorithms. 
  //		We assume here that the number IDs of nodes are intact, because we
  //		need them as indexe for accessing the arrays.  
  // tags:
  //		private
  
  _markers: null,

  constructor : function(graph)
  {
    this._markers = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(graph.getNumberOfNodes(), 0);
    graph.updateNodeIDs();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._markers = null;
  },

  set : function(node, markerNumber)
  {
    // summary:
    //		Sets the marker of a hierarchical node.
    // tags:
    //		private
    
    this._markers[node.getNumID()] = markerNumber;
  },

  get : function(node)
  {
    // summary:
    //		Returns the marker of a hierarchical node.
    // tags:
    //		private
    
    return this._markers[node.getNumID()]; // Number
  },

  add : function(node, incNumber)
  {
    // summary:
    //		Increments the marker of a hierarchical node by an amount.
    // tags:
    //		private
    
    this._markers[node.getNumID()] += incNumber;
  },

  setAll : function(markerNumber)
  {
    // summary:
    //		Marks all objects in the same way.
    // tags:
    //		private
    
    for (var i = 0; i < this._markers.length; i++)
      this._markers[i] = markerNumber;
  }

}
);
