dojo.provide('ibm_ilog.graphlayout.hierarchical.HGraphMemberList');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.HGraphMemberList', ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMemberList, 
{
  // summary:
  //		A doubly linked list of graph members. 
  // description:
  //		A doubly linked list of graph members. 
  //		This is used for node lists, link lists, segment lists in the graph. 
  //		
  // tags:
  //		private
  
  _IDsUpToDate: null,

  constructor : function()
  {
    this._IDsUpToDate = true;
  },
  
  isIDsUpToDate : function()
  {
    // summary:
    //		Returns true if the IDs are up to date.
    // tags:
    //		private
    
    return this._IDsUpToDate; // Boolean
  },

  add : function(owner, object)
  {
    // summary:
    //		Add the object to the list.  
    // owner: ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraph
    //		The owner of the list.
    // object: ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseGraphMember
    //		The object to be added. This must be a HGraphMember.
    // tags:
    //		private
    
    this.inherited("add", arguments, [owner, object]);
    (object).setNumID(this.getSize() - 1);
  },

  remove : function(object)
  {
    // summary:
    //		Remove the object from the list.
    // tags:
    //		private
    
    this.inherited("remove", arguments, [object]);
    this._IDsUpToDate = false;
  },

  removeLast : function()
  {
    // summary:
    //		Remove the last object from the list.
    // tags:
    //		private
    
    var oldFlag = this._IDsUpToDate;
    this.remove(this.getLast());
    this._IDsUpToDate = oldFlag;
  },

  updateNumIDs : function()
  {
    // summary:
    //		Updates the numIDs if necessary.
    // tags:
    //		private
    
    if (!this._IDsUpToDate)
    {
      var i = 0;
      var x = this.getFirst();

      while (x != null)
      {
        (x).setNumID(i++);
        x = x.getNextGraphMember();
      }

      this._IDsUpToDate = true;
    }
  }

}
);
