dojo.provide('ibm_ilog.graphlayout.hierarchical.HIntLevelMarker');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.HIntLevelMarker', null, 
{
  // summary:
  //		HIntLevelMarker encapsulates the mechanism to use integer markers per
  //		hierarchical level in hierarchical graph algorithms. 
  // description:
  //		HIntLevelMarker encapsulates the mechanism to use integer markers per
  //		hierarchical level in hierarchical graph algorithms. 
  //		We assume here that the number IDs of levels are intact, because we
  //		need them as indexe for accessing the arrays.  
  // tags:
  //		private
  
  _markers: null,

  constructor : function(graph)
  {
    this._markers = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(graph.getNumberOfLevels(), 0);
    graph.updateLevelIDs();
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the object after usage. 
    // description:
    //		Cleans the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._markers = null;
  },

  get : function(level)
  {
    // summary:
    //		Returns the marker of a hieararchical level.
    // tags:
    //		private
    
    return this._markers[level.getNumID()]; // int
  },

  add : function(level, incNumber)
  {
    // summary:
    //		Increments the marker of a hierarchical level by an amount.
    // tags:
    //		private
    
    this._markers[level.getNumID()] += incNumber;
  }

}
);
