dojo.provide('ibm_ilog.graphlayout.hierarchical.HLevelAlgApplicator');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.hierarchical.HLevelSweepAlgorithm');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalLayout');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.HLevelAlgApplicator', ibm_ilog.graphlayout.hierarchical.HLevelSweepAlgorithm, 
{
  // summary:
  //		HLevelAlgApplicator traverses the levels and applies a
  //		HLevelAlgorithm to all levels. 
  // description:
  //		HLevelAlgApplicator traverses the levels and applies a
  //		HLevelAlgorithm to all levels. 
  //		This is appropriate for all HLevelAlgorithms that require only one
  //		sweep. Pass backward = true if the algorithm requires a backward
  //		sweep.  
  // tags:
  //		private
  
  _levelAlg: null,
  _backward: null,
  _runOnFirstLevel: null,
  _recursive: null,

  constructor : function (a0, a1, a2, a3, a4)
  {
    if(arguments.length == 3)
      this._constructor_overload_ibm_ilog_graphlayout_hierarchical_HLevelAlgApplicator_3(a0, a1, a2);
    else if(arguments.length == 5)
      this._constructor_overload_ibm_ilog_graphlayout_hierarchical_HLevelAlgApplicator_5(a0, a1, a2, a3, a4);
  },
  
  _constructor_overload_ibm_ilog_graphlayout_hierarchical_HLevelAlgApplicator_3 : function(graph, levelAlg, backward)
  {
    this._constructor_overload_ibm_ilog_graphlayout_hierarchical_HLevelAlgApplicator_5(graph, levelAlg, backward, false, false);
  },
  
  _constructor_overload_ibm_ilog_graphlayout_hierarchical_HLevelAlgApplicator_5 : function(graph, levelAlg, backward, runOnFirstLevel , recursive )
  {
    this.init(graph);
    this._levelAlg = levelAlg;
    this._backward = backward;
    this._runOnFirstLevel = runOnFirstLevel;
    this._recursive = recursive;
  },
  
  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);

    this._levelAlg = null;
  },

  run : function()
  {
    // summary:
    //		Starts the algorithm.
    // tags:
    //		private
    
    if (this._backward) {
      this.sweepBackward();
    }
    else {
      this.sweepForward();
    }
  },

  initForwardFirstLevel : function(firstLevel)
  {
    // summary:
    //		Initializes the first level (with level number 0) in a forward
    //		sweep.
    // tags:
    //		private
    
    if (this._runOnFirstLevel)
    {
      this._levelAlg.init(null, firstLevel);
      this._levelAlg.run();
      if (this._recursive) {
        this.sweepLevelForward(firstLevel);
      }
    }
  },

  treatForwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number 1 ... 
    // description:
    //		Treats a level (with level number 1 ... 
    //		n) in a forward sweep.  
    // prevLevel: ibm_ilog.graphlayout.hierarchical.HLevel
    //		The level before the actual level (with level number
    //		i-1).
    // level: ibm_ilog.graphlayout.hierarchical.HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    this._levelAlg.init(prevLevel, level);
    this._levelAlg.run();
    if (this._recursive) {
      this.sweepLevelForward(level);
    }
  },

  treatBackwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number n-1 ... 
    // description:
    //		Treats a level (with level number n-1 ... 
    //		0) in a backward sweep.  
    // prevLevel: ibm_ilog.graphlayout.hierarchical.HLevel
    //		The level before the actual level (with level number
    //		i+1).
    // level: ibm_ilog.graphlayout.hierarchical.HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    
    ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.hierarchical.HierarchicalLayout, "graphlayout.expert.message.6400E");
  }

}
);
