dojo.provide('ibm_ilog.graphlayout.hierarchical.HLevelAlgorithm');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.HLevelAlgorithm', null, 
{
  // summary:
  //		HLevelAlgorithm is the base class of all algorithms that work on one
  //		level or a pair of adjacent levels.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  _upperLevel: null,
  _lowerLevel: null,
  _graph: null,

  _levelFlowDir: null,
  _edgeFlowDir: null,

  init : function(upperLevel, lowerLevel)
  {
    // summary:
    //		Initializes the algorithm with the actual levels.
    // tags:
    //		private
    
    this._graph = (upperLevel != null ? upperLevel.getOwnerGraph() : lowerLevel.getOwnerGraph());
    this._upperLevel = upperLevel;
    this._lowerLevel = lowerLevel;
    this._levelFlowDir = this._graph.getLevelFlow();
    this._edgeFlowDir = this._graph.getEdgeFlow();
  },

  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this._upperLevel = null;
    this._lowerLevel = null;
    this._graph = null;
  },

  run : function()
  {
    // summary:
    //		Start the algorithm.
    // tags:
    //		private
    },
  
  getGraph : function()
  {
    // summary:
    //		Access the hierarchical graph this algorithm is currently running
    //		on.
    // tags:
    //		private
    
    return this._graph; // ibm_ilog.graphlayout.hierarchical.HGraph
  },

  getUpperLevel : function()
  {
    // summary:
    //		Access the upper level this algorithm is currently running on.
    // tags:
    //		private
    
    return this._upperLevel; // ibm_ilog.graphlayout.hierarchical.HLevel
  },

  getLowerLevel : function()
  {
    // summary:
    //		Access the lower level this algorithm is currently running on.
    // tags:
    //		private
    
    return this._lowerLevel; // ibm_ilog.graphlayout.hierarchical.HLevel
  },

  getLevelFlowDir : function()
  {
    // summary:
    //		Access the coordinate index in level flow direction.
    // tags:
    //		private
    
    return this._levelFlowDir; // int
  },

  getEdgeFlowDir : function()
  {
    // summary:
    //		Access the coordinate index in edge flow direction.
    // tags:
    //		private
    
    return this._edgeFlowDir; // int
  }

}
);
