dojo.provide('ibm_ilog.graphlayout.hierarchical.HLevelSweepAlgorithm');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.HLevelSweepAlgorithm', ibm_ilog.graphlayout.hierarchical.HGraphAlgorithm, 
{
  // summary:
  //		HLevelSweepAlgorithm traverses the levels forwards and backwards to
  //		perform a certain task.  
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  init : function(graph)
  {
    // summary:
    //		Initializes the algorithm with the hierarchical graph.
    // tags:
    //		private
    
    this.inherited("init", arguments, [graph]);
  },

  clean : function()
  {
    // summary:
    //		Clean the object after usage. 
    // description:
    //		Clean the object after usage. 
    //		It is not necessary to use this, but it speeds up garbage collection
    //		if we do it when we don't need the object anymore.
    // tags:
    //		private
    
    this.inherited("clean", arguments, []);
  },

  initForwardFirstLevel : function(firstLevel)
  {
    // summary:
    //		Initializes the first level (with level number 0) in a forward
    //		sweep.
    // tags:
    //		private
    
  },

  initBackwardFirstLevel : function(firstLevel)
  {
    // summary:
    //		Initializes the first level (with level number n) in a backward
    //		sweep.
    // tags:
    //		private
    
  },

  treatForwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number 1 ... 
    // description:
    //		Treats a level (with level number 1 ... 
    //		n) in a forward sweep.  
    // prevLevel: ibm_ilog.graphlayout.hierarchical.HLevel
    //		The level before the actual level (with level number
    //		i-1).
    // level: ibm_ilog.graphlayout.hierarchical.HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    },
  
  treatBackwardLevel : function(prevLevel, level)
  {
    // summary:
    //		Treats a level (with level number n-1 ... 
    // description:
    //		Treats a level (with level number n-1 ... 
    //		0) in a backward sweep.  
    // prevLevel: ibm_ilog.graphlayout.hierarchical.HLevel
    //		The level before the actual level (with level number
    //		i+1).
    // level: ibm_ilog.graphlayout.hierarchical.HLevel
    //		The actual level (with level number i).
    // tags:
    //		private
    },
  
  sweepLevelForward : function(level)
  {
    // summary:
    //		Sweep forward for all subgraphs contained in the input level.  
    // tags:
    //		private
    
    if (level == null) {
      return;
    }
    var iter = level.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getRepresentationGraph() != null) {
        this.sweepGraphForward(node.getRepresentationGraph());
      }
    }
  },

  sweepLevelBackward : function(level)
  {
    // summary:
    //		Sweep backward for all subgraphs contained in the input level.  
    // tags:
    //		private
    
    if (level == null) {
      return;
    }
    var iter = level.getNodes();
    var node;

    while (iter.hasNext())
    {
      node = iter.next();
      if (node.getRepresentationGraph() != null) {
        this.sweepGraphBackward(node.getRepresentationGraph());
      }
    }
  },

  sweepGraphForward : function(graph)
  {
    // summary:
    //		Sweep forward of a subgraph.  
    // tags:
    //		private
    
    var oldGraph = this.getGraph();
    this.init(graph);
    this.sweepForward();
    this.init(oldGraph);
  },

  sweepGraphBackward : function(graph)
  {
    // summary:
    //		Sweep backward of a subgraph.  
    // tags:
    //		private
    
    var oldGraph = this.getGraph();
    this.init(graph);
    this.sweepBackward();
    this.init(oldGraph);
  },

  sweepForward : function()
  {
    // summary:
    //		Performs a sweep forwards over the levels.
    
    var graph = this.getGraph();

    if (graph.getNumberOfLevels() > 1)
    {
      var iter = graph.getLevels();
      var prevLevel;
      var level;

      prevLevel = iter.next();
      this.initForwardFirstLevel(prevLevel);

      while (iter.hasNext())
      {
        level = iter.next();
        this.treatForwardLevel(prevLevel, level);
        this.getPercController().addPoints(1);
        this.layoutStepPerformed();
        prevLevel = level;
      }
    }
  },

  sweepBackward : function()
  {
    // summary:
    //		Performs a sweep backwards over the levels.
    // tags:
    //		private
    
    var graph = this.getGraph();

    if (graph.getNumberOfLevels() > 1)
    {
      var iter = graph.getLevelsBackward();
      var prevLevel;
      var level;

      prevLevel = iter.prev();
      this.initBackwardFirstLevel(prevLevel);

      while (iter.hasPrev())
      {
        level = iter.prev();
        this.treatBackwardLevel(prevLevel, level);
        this.getPercController().addPoints(1);
        this.layoutStepPerformed();
        prevLevel = level;
      }
    }
  }

}
);
