dojo.provide('ibm_ilog.graphlayout.hierarchical.HSegmentBufferedIterator');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.hierarchical.HSegmentIterator');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.HSegmentBufferedIterator', ibm_ilog.graphlayout.hierarchical.HSegmentIterator, 
{
  // summary:
  //		A hierarchical segment iterator that buffers the segments before
  //		iterating over them.  
  // tags:
  //		private
  
  _buffer: null,
  _count: null,
  _maxcount: null,

  constructor : function(iter)
  {
    this._buffer = new Array();

    while (iter.hasNext())
      this._buffer.push(iter.next());
    this._count = 0;
    this._maxcount = this._buffer.length;
  },
  
  hasNext : function()
  {
    // summary:
    //		Returns <tt>true</tt> if the iteration has more elements.
    // tags:
    //		private
    
    return this._count < this._maxcount; // Boolean
  },

  next : function()
  {
    // summary:
    //		Returns the next element of this iteration. 
    // description:
    //		Returns the next element of this iteration. 
    //		Different than standard iterations of class <tt>Iterator</tt>, we
    //		don't require to throw an exception if there are no more elements. The access to <tt>next</tt> should always be preceeded by a test <tt>hasNext</tt>.  
    // returns:
    //		The next segment of this iteration.
    // tags:
    //		private
    
    return this._buffer[this._count++]; // ibm_ilog.graphlayout.hierarchical.HSegment
  }

}
);
