dojo.provide('ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint');
dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint', ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint, 
{
  // summary:
  //		'RelativeConstraint' is the base class of 
  //		'RelativeLevelConstraint' and 
  //		'RelativePositionConstraint'. 
  // description:
  //		<code>RelativeConstraint</code> is the base class of 
  //		<code>RelativeLevelConstraint</code> and 
  //		<code>RelativePositionConstraint</code>. 
  //		<p>
  //		Both classes have common internal functionality.    
  //		</p>
  
  _lwNodeOrGroup: null,

  _hgNodeOrGroup: null,

  constructor : function (a0, a1, a2)
  {
    if(arguments.length == 3)
      this._constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalRelativeConstraint_3(a0, a1, a2);
    else if(arguments.length == 1)
      this._constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalRelativeConstraint_1(a0);
  },
  
  _constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalRelativeConstraint_3 : function(lowerNodeOrGroup, higherNodeOrGroup, priority)
  {
    this.setPriority(priority);
    this._lwNodeOrGroup = lowerNodeOrGroup;
    this._hgNodeOrGroup = higherNodeOrGroup;
  },
  
  _constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalRelativeConstraint_1 : function(source)
  {
    this._lwNodeOrGroup = source._lwNodeOrGroup;
    this._hgNodeOrGroup = source._hgNodeOrGroup;
  },
  
  getFirstSubject : function()
  {
    // summary:
    //		Returns the first subject of the constraint. 
    // description:
    //		Returns the first subject of the constraint. 
    //		You set the first subject using <code>
    //		HierarchicalRelativeConstraint.setFirstSubject()</code>.   
    // returns:
    //		The first subject of the constraint.
    // tags:
    //		private
    
    return this._lwNodeOrGroup; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.  
    // subject: Object
    //		The first subject of the constraint.
    // tags:
    //		private
    
    this._lwNodeOrGroup = subject;
  },

  getSecondSubject : function()
  {
    // summary:
    //		Returns the second subject of the constraint. 
    // description:
    //		Returns the second subject of the constraint. 
    //		You set the second subject by calling <code>
    //		HierarchicalRelativeConstraint.setSecondSubject()</code>.
    // tags:
    //		private
    
    return this._hgNodeOrGroup; // Object
  },

  setSecondSubject : function(subject)
  {
    // summary:
    //		Sets the second subject of the constraint.  
    // subject: Object
    //		The second subject of the constraint.
    // tags:
    //		private
    
    this._hgNodeOrGroup = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Tests if the the constraint is valid in the input graph model.  
    // model: ibm_ilog.graphlayout.AbstractGraphLayoutModel
    //		The graph model to test.
    // returns:
    //		If the constraint is valid for 'model', 
    //		'true' is returned.
    // tags:
    //		private
    
    if (!this.validateNodeOrGroup(model, this.getFirstSubject())) {
      return false; // Boolean
    }
    if (!this.validateNodeOrGroup(model, this.getSecondSubject())) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose of this method is the same as <code>
    //		HierarchicalRelativeConstraint.validate()</code>.  You call this
    //		method to set the validate flag temporarily during layout, calls to
    //		<code> HierarchicalRelativeConstraint.validate()</code> are used to
    //		remove  invalid constraints completely.   
    // graph: ibm_ilog.graphlayout.hierarchical.HGraph
    //		The node to be validated.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateNodeOrGroupForLayout(graph, this.getFirstSubject());
    this.validateNodeOrGroupForLayout(graph, this.getSecondSubject());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.  
    // manager: ibm_ilog.graphlayout.hierarchical.ConstraintManager
    //		The constraint manager.
    // tags:
    //		private
    
    var subject = this.getFirstSubject();
    if (subject instanceof ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup) {
      manager.addGroup(subject);
    }
    subject = this.getSecondSubject();
    if (subject instanceof ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup) {
      manager.addGroup(subject);
    }
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint;
    if(ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint._fields_init)
      ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 1352696757646768778;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint._fields_init(); })();
