dojo.provide('ibm_ilog.graphlayout.hierarchical.HierarchicalRelativePositionConstraint');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.HierarchicalRelativePositionConstraint', ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint, 
{
  // summary:
  //		The class 'RelativePositionConstraint' is  a constraint to
  //		place a node relative to another node that belongs to the same level.
  //		
  // description:
  //		The class <code>RelativePositionConstraint</code> is  a constraint to
  //		place a node relative to another node that belongs to the same level.
  //		
  //		It does not affect the order of nodes that belong to different
  //		levels. It forces a node to be placed after another node within the
  //		same level. The constraint can also be applied to groups of nodes.   
  //		<p>
  //		Nodes are organized in horizontal or vertical levels.  Within each
  //		level, the nodes are placed sequentially at relative positions
  //		numbered from 0 to "n". If the link flow direction is from top to
  //		bottom, the node with position index 0 is placed leftmost within its
  //		level, and the nodes with higher position indexes are placed farther
  //		to the right. If the link flow direction is from right to left, the
  //		node with position index 0 is placed topmost within its level, and
  //		the nodes with higher position indexes are placed below. The
  //		constraint specifies that a node is placed at a higher position index
  //		than another node. The constraint is ignored, if both nodes do not
  //		belong to the same level.  
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated for
  //		those nodes that are marked for incremental recalculation, because
  //		otherwise, the incremental positions of the nodes are dominant.  
  //		</p>
  //		<p>
  //		Among the constraints, this kind is dominated by side by side
  //		constraints, that is, if a node A and B must be placed side by side,
  //		then a node C cannot be forced to be at a higher position than A but
  //		at a lower position than B at the same time. The node C cannot be
  //		forced to be placed in between A and B. The constraint is also
  //		dominated by specified position indexes, i.e. it does not change the
  //		order of nodes that have specified position indexes, and by swim lane
  //		constraints, that is, it is not able to break swim lanes  apart.  
  //		</p>
  //		<p>
  //		The relative constraints have priorities. Conflicting relative
  //		position constraints are resolved by removing the constraint with the
  //		smallest priority.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speed up the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), both nodes of
  //		the relative position constraint must belong to the same subgraph,
  //		and the constraint must be installed at the layout instance that is
  //		attached to this subgraph. It is not possible to have a relative
  //		position constraint containing nodes of different subgraphs.    
  //		</p>
  
  constructor : function (a0, a1, a2)
  {
    if(arguments.length == 3)
      this._constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalRelativePositionConstraint_3(a0, a1, a2);
    else if(arguments.length == 1)
      this._constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalRelativePositionConstraint_1(a0);
  },
  
  _constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalRelativePositionConstraint_3 : function(lowerNodeOrGroup , higherNodeOrGroup , priority )
  {
  },
  
  _constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalRelativePositionConstraint_1 : function(source)
  {
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new ibm_ilog.graphlayout.hierarchical.HierarchicalRelativePositionConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getLowerSubject : function()
  {
    // summary:
    //		Returns the subject of this constraint that is placed at the levels
    //		with lower index than the other subject. 
    // description:
    //		Returns the subject of this constraint that is placed at the levels
    //		with lower index than the other subject. 
    //		<p>
    //		The subject is  either the constraint node, or the instance of
    //		<code> HierarchicalNodeGroup</code> that describes a group of nodes.
    //		 
    //		</p>
    
    return this._lwNodeOrGroup; // Object
  },

  getHigherSubject : function()
  {
    // summary:
    //		Returns the subject of this constraint that is placed at the levels
    //		with higher index than the other subject. 
    // description:
    //		Returns the subject of this constraint that is placed at the levels
    //		with higher index than the other subject. 
    //		<p>
    //		The subject is  either the constraint node, or the instance of
    //		<code> HierarchicalNodeGroup</code> that describes a group of nodes.
    //		 
    //		</p>
    
    return this._hgNodeOrGroup; // Object
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.hierarchical.HierarchicalRelativePositionConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.hierarchical.HierarchicalRelativePositionConstraint;
    if(ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint._fields_init)
      ibm_ilog.graphlayout.hierarchical.HierarchicalRelativeConstraint._fields_init(c);
    
    c.serialVersionUID = 6189367828095812689;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.hierarchical.HierarchicalRelativePositionConstraint._fields_init(); })();
