dojo.provide('ibm_ilog.graphlayout.hierarchical.HierarchicalSameLevelConstraint');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.HierarchicalSameLevelConstraint', ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint, 
{
  // summary:
  //		The class 'SameLevelConstraint'  is a constraint that
  //		forces two nodes to be placed at the same level. 
  // description:
  //		The class <code>SameLevelConstraint</code>  is a constraint that
  //		forces two nodes to be placed at the same level. 
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated if
  //		at least one of the nodes is marked for incremental recalculation,
  //		because otherwise, the incremental positions of the nodes are
  //		dominant.  
  //		</p>
  //		<p>
  //		Among the constraints, this kind has the highest priority. If several
  //		conflicting constraints are specified (such as the node must be
  //		placed in a lower level than another node <i>and</i> at the same
  //		level as this other node), the constraints with lower priority are
  //		ignored during layout.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speedup the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		The same level constraint has the same priority as the group spread
  //		constraint, because both cannot be conflicting. In fact, there are
  //		two ways of forcing two nodes to the same level: use the same level
  //		constraint, or use a group spread constraint of a group of two nodes
  //		with spread size 0.  
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), both nodes of
  //		the same level constraint must belong to the same subgraph, and the
  //		constraint must be installed at the layout instance that is attached
  //		to this subgraph. It is not possible to have a same level constraint
  //		containing nodes of different subgraphs.   
  //		</p>
  
  _node1: null,
  _node2: null,

  constructor : function (a0, a1)
  {
    if(arguments.length == 2)
      this._constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalSameLevelConstraint_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalSameLevelConstraint_1(a0);
  },
  
  _constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalSameLevelConstraint_2 : function(node1 , node2 )
  {
    this.setPriority(Number.MAX_VALUE);
    this._node1 = node1;
    this._node2 = node2;
  },
  
  _constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalSameLevelConstraint_1 : function(source)
  {
    this._node1 = source._node1;
    this._node2 = source._node2;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new ibm_ilog.graphlayout.hierarchical.HierarchicalSameLevelConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getFirstNode : function()
  {
    // summary:
    //		Returns the first node of this constraint.
    
    return this._node1; // Object
  },

  getSecondNode : function()
  {
    // summary:
    //		Returns the second node of this constraint.
    
    return this._node2; // Object
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalSameLevelConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._node1; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._node1 = subject;
  },

  getSecondSubject : function()
  {
    // summary:
    //		Returns the "second" subject of the constraint. 
    // description:
    //		Returns the "second" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalSameLevelConstraint.setSecondSubject()</code>.
    // tags:
    //		private
    
    return this._node2; // Object
  },

  setSecondSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._node2 = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    if (!this.validateNode(model, this.getFirstNode())) {
      return false; // Boolean
    }
    if (!this.validateNode(model, this.getSecondNode())) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalSameLevelConstraint.validate()</code> is used to remove
    //		invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateNodeForLayout(graph, this.getFirstNode());
    this.validateNodeForLayout(graph, this.getSecondNode());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.hierarchical.HierarchicalSameLevelConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.hierarchical.HierarchicalSameLevelConstraint;
    if(ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint._fields_init)
      ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 6689456825437964877;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.hierarchical.HierarchicalSameLevelConstraint._fields_init(); })();
