dojo.provide('ibm_ilog.graphlayout.hierarchical.HierarchicalSideBySideConstraint');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.HierarchicalSideBySideConstraint', ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint, 
{
  // summary:
  //		The class 'SideBySideConstraint'  is a constraint that
  //		forces a group of nodes that belong to the same  level to be placed
  //		side by side. 
  // description:
  //		The class <code>SideBySideConstraint</code>  is a constraint that
  //		forces a group of nodes that belong to the same  level to be placed
  //		side by side. 
  //		It prohibits that other nodes of the same level are placed in the
  //		middle of the group. By this, the relative positions of the nodes of
  //		the group are close together. It does not affect the order of nodes
  //		that belong to different levels.  
  //		<p>
  //		Nodes are organized in horizontal or vertical levels.  Within each
  //		level, the nodes are placed sequentially at relative positions
  //		numbered from 0 to "n". The constraint specifies that those nodes of
  //		the group that belong to the same level are placed in subsequent
  //		positions within the level. The constraint is ignored, if all nodes
  //		of the group belong to different levels.  
  //		</p>
  //		<p>
  //		For instance, assume the group consists of nodes A, B, C, D, E. If A,
  //		B and C belong to one level  and D and E to another level, then the
  //		side by side constraint forces the nodes A, B, C to be placed side by
  //		side, and D and E to be placed side by side. The constraint is
  //		satisfied if the positions of A, B, C are 5, 6, 7 and the positions
  //		of D and E are 1 and 2. The constraint affects only the nodes that
  //		belong to the same level, therefore the constraint affects the
  //		subgroup ( A, B, C ) and the subgroup ( D, E ) individually, not the
  //		entire group ( A, B, C, D, E ) as a unit. The constraint is not
  //		satisfied if the positions of A, B and C are 5, 7 and 8, because in
  //		this case, there must be a node between A and B that does not belong
  //		to the same group. The node between A and B cannot be D or E, because
  //		D and E belong to a different level.  
  //		</p>
  //		<p>
  //		The constraint is evaluated, if the incremental mode is disabled. If
  //		the incremental mode is enabled, the constraint is only evaluated if
  //		the nodes of the group are marked for incremental recalculation,
  //		because otherwise, the incremental positions of the nodes are
  //		dominant.  
  //		</p>
  //		<p>
  //		This kind of constraint dominates the relative position constraints.
  //		The constraints have priorities. If several conflicting constraints
  //		are specified (such as a node must be side by side to three different
  //		groups), the constraints with lower priority are ignored during
  //		layout. The constraint is dominated by specified position indexes,
  //		i.e. it does not change the order of nodes that have specified
  //		position indexes, and by swim lane constraints, that is, it is not
  //		able to break swim lanes  apart.  
  //		</p>
  //		<p>
  //		The automatic conflict resolution can handle conflicting constraints.
  //		However, to speed up the layout, it is recommended to specify
  //		constraints in a way such that there are no conflicts.   
  //		</p>
  //		<p>
  //		In recursive layout mode (see <code>
  //		HierarchicalLayout.setRecursiveLayoutMode()</code>), all nodes of the
  //		group of a side by side constraint must belong to the same subgraph,
  //		and the constraint must be installed at the layout instance that is
  //		attached to this subgraph. It is not possible to have a side by side
  //		constraint containing a group of nodes of different subgraphs.   
  //		</p>
  
  _group: null,

  constructor : function (a0, a1)
  {
    if(arguments.length == 2)
      this._constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalSideBySideConstraint_2(a0, a1);
    else if(arguments.length == 1)
      this._constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalSideBySideConstraint_1(a0);
  },
  
  _constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalSideBySideConstraint_2 : function(groupArg , priorityArg )
  {
    this.setPriority(priorityArg);
    this._group = groupArg;
  },
  
  _constructor_overload_ibm_ilog_graphlayout_hierarchical_HierarchicalSideBySideConstraint_1 : function(source)
  {
    this._group = source._group;
  },
  
  copy : function()
  {
    // summary:
    //		Copies the constraint. 
    // description:
    //		Copies the constraint. 
    //		<p>
    //		</p>
    
    return new ibm_ilog.graphlayout.hierarchical.HierarchicalSideBySideConstraint(this); // ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint
  },

  getGroup : function()
  {
    // summary:
    //		Returns the group of this constraint.
    
    return this._group; // ibm_ilog.graphlayout.hierarchical.HierarchicalNodeGroup
  },

  getFirstSubject : function()
  {
    // summary:
    //		Returns the "first" subject of the constraint. 
    // description:
    //		Returns the "first" subject of the constraint. 
    //		This means simply we can set it via <code>
    //		HierarchicalSideBySideConstraint.setFirstSubject()</code>.
    // tags:
    //		private
    
    return this._group; // Object
  },

  setFirstSubject : function(subject)
  {
    // summary:
    //		Sets the first subject of the constraint.
    // tags:
    //		private
    
    this._group = subject;
  },

  validate : function(model)
  {
    // summary:
    //		Returns <tt>true</tt> if the constraint is valid in the input graph
    //		model.
    // tags:
    //		private
    
    return this.validateGroup(model, this.getGroup()); // Boolean
  },

  validateForLayout : function(graph)
  {
    // summary:
    //		Sets the valid flag of the constraint during layout. 
    // description:
    //		Sets the valid flag of the constraint during layout. 
    //		The purpose is the same as validate, but this is used temporarily
    //		during layout while <code>
    //		HierarchicalSideBySideConstraint.validate()</code> is used to remove
    //		invalid constraints completely.
    // tags:
    //		private
    
    this.setValidForLayout(true);
    this.validateGroupForLayout(graph, this.getGroup());
  },

  actAfterAdd : function(manager)
  {
    // summary:
    //		Acts after the constraint was added to the constraint manager.
    // tags:
    //		private
    
    manager.addGroup(this.getGroup());
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.hierarchical.HierarchicalSideBySideConstraint,
{
  serialVersionUID : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.hierarchical.HierarchicalSideBySideConstraint;
    if(ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint._fields_init)
      ibm_ilog.graphlayout.hierarchical.HierarchicalConstraint._fields_init(c);
    
    c.serialVersionUID = 4890354678543809875;
  }
  
}
);

(function(){ ibm_ilog.graphlayout.hierarchical.HierarchicalSideBySideConstraint._fields_init(); })();
