dojo.provide('ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge', ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge, 
{
  // summary:
  //		An edge for the algorithm to calculate a leveling of a graph. 
  // description:
  //		An edge for the algorithm to calculate a leveling of a graph. 
  //		Each edge has a minimal span, that is the minimal distance between
  //		the level number of source and target node.   
  // tags:
  //		private
  
  _minSpan: null,

  constructor : function (a0, a1)
  {
    if(arguments.length == 1)
      this._constructor_overload_ibm_ilog_graphlayout_hierarchical_leveling_HLVEdge_1(a0);
    else if(arguments.length == 2)
      this._constructor_overload_ibm_ilog_graphlayout_hierarchical_leveling_HLVEdge_2(a0, a1);
  },
  
  _constructor_overload_ibm_ilog_graphlayout_hierarchical_leveling_HLVEdge_1 : function(priority)
  {
    this._minSpan = 0;
  },
  
  _constructor_overload_ibm_ilog_graphlayout_hierarchical_leveling_HLVEdge_2 : function(priority, minSpan )
  {
    this._minSpan = minSpan;
  },
  
  getHLVSource : function()
  {
    // summary:
    //		Returns the current source of the edge.
    // tags:
    //		private
    
    return this._source; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  getHLVTarget : function()
  {
    // summary:
    //		Returns the current target of the edge.
    // tags:
    //		private
    
    return this._target; // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  getOpposite : function(node)
  {
    // summary:
    //		Returns the opposite of the input node.
    // tags:
    //		private
    
    return this.getOppositeBaseNode(node); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  getMinSpan : function()
  {
    // summary:
    //		Returns the minimal span of the edge.
    // tags:
    //		private
    
    return this._minSpan; // int
  },

  setMinSpan : function(span)
  {
    // summary:
    //		Sets the minimal span of the edge.
    // tags:
    //		private
    
    this._minSpan = span;
  }

}
);
