dojo.provide('ibm_ilog.graphlayout.hierarchical.leveling.HLVGraph');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdgeIterator');
dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNodeIterator');
dojo.require('ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge');
dojo.require('ibm_ilog.graphlayout.hierarchical.leveling.HLVEdgeIterator');
dojo.require('ibm_ilog.graphlayout.hierarchical.leveling.HLVNodeIterator');
dojo.require('ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAGraph');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.leveling.HLVGraph', ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAGraph, 
{
  // summary:
  //		A graph for the algorithm to calculate a leveling of a graph. 
  // description:
  //		A graph for the algorithm to calculate a leveling of a graph. 
  //		The advantage of not calculating the levels on the original grapher
  //		is that we can add nodes and edges for the constraints, or that we
  //		can leave out edges that are unnecessary.  
  // tags:
  //		private
  
  constructor : function()
  {
  },
  
  addEdgeWithGroupCheck : function(edge, source, target)
  {
    // summary:
    //		Adds an edge to the graph. 
    // description:
    //		Adds an edge to the graph. 
    //		If the target node of the edge has a predecessor that is a
    //		propagation group start node, also add an edge to the propagation
    //		group start node. This auxiliary edge should avoid that the
    //		propagation start node is handled before the source node of the new
    //		edge is handled.
    // tags:
    //		private
    
    var iter = target.getInEdges();
    var auxEdge;
    var auxNode;

    while (iter.hasNext())
    {
      auxEdge = iter.next();
      auxNode = auxEdge.getHLVSource();

      if (auxNode.isPropagationGroupStartNode() && !this.belongsToSameGroup(source, auxNode))
      {
        auxEdge = new ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge(0.0);
        auxEdge.setMinSpan(/*Number.MIN_VALUE*/(-2147483648));
        this.inherited("addEdgeBetweenNodes", arguments, [auxEdge, source, auxNode]);
      }
    }

    this.inherited("addEdgeBetweenNodes", arguments, [edge, source, target]);
  },

  belongsToSameGroup : function(node, groupStartNode)
  {
    // summary:
    //		Returns true if the input node belongs to the same group as the
    //		start node. 
    // description:
    //		Returns true if the input node belongs to the same group as the
    //		start node. 
    //		That is, the input node must have a predecessor which is the input
    //		group start node.
    // tags:
    //		private
    
    var iter = node.getInEdges();

    while (iter.hasNext())
      if (iter.next().getHLVSource() == groupStartNode) {
        return true; // Boolean
      }
    return false; // Boolean
  },

  updatePropagationFlags : function()
  {
    // summary:
    //		Updates the propagation flags of all nodes. 
    // description:
    //		Updates the propagation flags of all nodes. 
    //		This must be called once after the graph topology was made acyclic,
    //		but before any propagation is done.
    // tags:
    //		private
    
    var iter = this.getNodes(false);

    while (iter.hasNext())
      iter.next().updatePropagationFlags();
  },

  getNodes : function(backwards)
  {
    // summary:
    //		Returns the nodes of the graph.
    // tags:
    //		private
    
    return new ibm_ilog.graphlayout.hierarchical.leveling.HLVGraphNodeIterator(this, backwards); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNodeIterator
  },

  getEdges : function(backwards)
  {
    // summary:
    //		Returns the edges of the graph.
    // tags:
    //		private
    
    return new ibm_ilog.graphlayout.hierarchical.leveling.HLVGraphEdgeIterator(this, backwards); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdgeIterator
  }

}
);

dojo.declare('ibm_ilog.graphlayout.hierarchical.leveling.HLVGraphEdgeIterator', ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdgeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(graph, backwards)
  {
  },
  
  next : function()
  {
    return this.nextBaseEdge(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge
  },

  prev : function()
  {
    return this.prevBaseEdge(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVEdge
  }

}
);

dojo.declare('ibm_ilog.graphlayout.hierarchical.leveling.HLVGraphNodeIterator', ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseNodeIterator, 
{
  // summary:
  //		
  // tags:
  //		private
  
  constructor : function(graph, backwards)
  {
  },
  
  next : function()
  {
    return this.nextBaseNode(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  },

  prev : function()
  {
    return this.prevBaseNode(); // ibm_ilog.graphlayout.hierarchical.leveling.HLVNode
  }

}
);
