dojo.provide('ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge');
dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');

dojo.declare('ibm_ilog.graphlayout.hierarchical.makeacyclic.HMAEdge', ibm_ilog.graphlayout.hierarchical.graphbase.HTBaseEdge, 
{
  // summary:
  //		An edge for the algorithm to make the graph acyclic. 
  // description:
  //		An edge for the algorithm to make the graph acyclic. 
  //		This edge maintains the priority that determines which edge can be
  //		broken. It maintains various flags as well.   
  // tags:
  //		private
  
  _priority: null,
  _flags: null,

  constructor : function(priority)
  {
    this._priority = priority;
    this._flags = 0;
  },
  
  getHMASource : function()
  {
    // summary:
    //		Returns the current source of the edge.
    
    return this._source; // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode
  },

  getHMATarget : function()
  {
    // summary:
    //		Returns the current target of the edge.
    // tags:
    //		private
    
    return this._target; // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode
  },

  getHMAOpposite : function(node)
  {
    // summary:
    //		Returns the opposite node if the input node.
    // tags:
    //		private
    
    if (node == this._source) {
      return this._target; // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode
    }
    return this._source; // ibm_ilog.graphlayout.hierarchical.makeacyclic.HMANode
  },

  getPriority : function()
  {
    // summary:
    //		Returns the priority of the edge.
    // tags:
    //		private
    
    return this._priority; // Number
  },

  setPriority : function(priority)
  {
    // summary:
    //		Sets the priority of the edge to a new value. 
    // description:
    //		Sets the priority of the edge to a new value. 
    //		This works only if the edge is in the graph.
    // tags:
    //		private
    
    if (priority <= 0.0) {
      priority = 0.1;
    }
    if (priority > 10000.0) {
      priority = 10000.0;
    }
    if ((this.getOwnerBaseGraph()).isNodeEdgeDataValid())
    {
      (this._source).removeOutEdgeData(this);
      (this._target).removeInEdgeData(this);
    }

    this._priority = priority;

    if ((this.getOwnerBaseGraph()).isNodeEdgeDataValid())
    {
      (this._source).addOutEdgeData(this);
      (this._target).addInEdgeData(this);
    }
  },

  isUnbreakable : function()
  {
    // summary:
    //		Returns true if the edge is unbreakable.
    // tags:
    //		private
    
    return (this._flags & 4) != 0; // Boolean
  },

  makeUnbreakable : function()
  {
    // summary:
    //		Makes the edge unbreakable. 
    // description:
    //		Makes the edge unbreakable. 
    //		Of course, in a cycle of unbreakable edges, we must break one of
    //		them.
    // tags:
    //		private
    
    this._flags |= 4;
  },

  isTwoCycle : function()
  {
    // summary:
    //		Returns true if the edge is a two cycle. 
    // description:
    //		Returns true if the edge is a two cycle. 
    //		Each two cycle has at least two edges which are both marked. One of
    //		both is additionally marked as reversed.
    // tags:
    //		private
    
    return (this._flags & 2) != 0; // Boolean
  },

  markTwoCycle : function()
  {
    // summary:
    //		Mark the edge as two cycle.
    // tags:
    //		private
    
    this._flags |= 2;
  },

  isReversed : function()
  {
    // summary:
    //		Returns true if the edge is reversed.
    // tags:
    //		private
    
    return (this._flags & 1) != 0; // Boolean
  },

  markReversed : function()
  {
    // summary:
    //		Mark the edge as reversed. 
    // description:
    //		Mark the edge as reversed. 
    //		If a reversed edge gets reversed again, it is marked a unreversed.
    // tags:
    //		private
    
    if (this.isReversed()) {
      this._flags &= ~1;
    }
    else {
      this._flags |= 1;
    }
  }

}
);
