dojo.provide('ibm_ilog.diagram.interactors.FocusInteractor');

dojo.require('ibm_ilog.diagram.interactors.Interactor');
//dojo.require('ibm_ilog.diagram.util.Geometry');
//dojo.require('ibm_ilog.diagram.util.GraphUtil');

(function () {
//	var g = ibm_ilog.diagram.util.Geometry;
//	var gu = ibm_ilog.diagram.util.GraphUtil;

dojo.declare("ibm_ilog.diagram.interactors.FocusInteractor", [ibm_ilog.diagram.interactors.Interactor], {
	//
	//	summary:
	//

	//
	//	_viewport: ibm_ilog.diagram.widget.Viewport
	//		The diagram viewport 
	//
	_viewport: null,

	//
	//	_diagram: ibm_ilog.diagram.widget.Diagram
	//
	_diagram: null,

	//
	//	_diagram: ibm_ilog.diagram.widget.Diagram
	//
	_graph: null,

	initialize: function ( /*ibm_ilog.diagram.widget.Diagram*/ diagram ) {
		this._diagram = diagram;
		this._graph = diagram.getGraph();
		this._viewport = diagram.getViewport();
		this._initialize();
		return this;
	},

	_declareStates: function () {
		this._declareState("idle", ["changeFocus"]);
	},

	getDefaultConnections: function () {
		//
		//	summary:
		//		returns the default event mapping
		//
		return {
			changeFocus: {
				src: this._viewport.getEventSource(),
				srcEvt: "onmousedown",
				connectTo: "_changeFocus",
				gfxConnect: true
			}
		};
	},

	_getGraphElementFromEvent: function (e) {
		// Summary:
		//		return the selection object
		var ge = this._getGraphElementFromEventInRoot(e, this._graph);
		return ge !== this._graph ? ge : null;
	},
	
	_changeFocus: function (e) {

		this._diagram.setFocusedElement(this._getGraphElementFromEvent(e));

		dojo.stopEvent(e);
	},

	onEnabled: function () {
		this._goStateId("idle");
	},

	onDisabled: function () {
		this._goState(null);
	}
	
});

})();