/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.viewlets.internal.dashboard.ConfigurationSpaceInfo");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("jazz.app.context");
dojo.require("jazz.util.i18n");
dojo.require("jazz.util.html");
dojo.require("net.jazz.ajax.contextRoot");
dojo.require("com.ibm.team.vvc.shared.web.ui.context.ContextUtils");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmps.viewlets.internal.dashboard", "ProjectContextInfoMessages");

(function(){
	
var messages;
var CONFIGURE_SPACE_SETTING_PAGE_ACTION = "#action=rmps.app.settings.configureSpace";
var VVCContextUtils = com.ibm.team.vvc.shared.web.ui.context.ContextUtils;

//	 Configuration Space (link to the space, and link to the project properties)

dojo.declare("rmps.viewlets.internal.dashboard.ConfigurationSpaceInfo", [dijit._Widget, dijit._Templated], {

	templatePath: dojo.moduleUrl("rmps.viewlets", "internal/dashboard/templates/ConfigurationSpaceInfo.html"),
	
	constructor: function(args) {
		if (!messages) {
			messages = dojo.i18n.getLocalization("rmps.viewlets.internal.dashboard", "ProjectContextInfoMessages");
		}
		this.messages = messages;
	},

	postCreate: function() {
		this._titleLink.href = CONFIGURE_SPACE_SETTING_PAGE_ACTION;
		
		var context = VVCContextUtils.getCurrentContext();
		var currentSpace = VVCContextUtils.getSpace();
	
		if (!currentSpace) {
			this._bottom.innerHTML = ""; // Remove loading message
			jazz.util.i18n.addMessage(dojo.create("div", {}, this._bottom), messages.toConfigureSpaceAreaNoCurrentSpace)[0].href = CONFIGURE_SPACE_SETTING_PAGE_ACTION;
			return;
		}
		
		var deferred_space = this.getAllSpaces();		
		deferred_space.addCallback(this, function(spaces) {
			for (var space in spaces) {
				var _space = spaces[space];
				if (currentSpace === _space.uri) {
					dojo.create("a", {
						className: "space",
						innerHTML: jazz.util.html.escape(_space.title),
						href: "#action=rmps.app.settings.configureSpace"
					}, this._contentArea);
					break;
				}
			}
			this._bottom.innerHTML = ""; // Remove loading message
			jazz.util.i18n.addMessage(dojo.create("div", {}, this._bottom), messages.toConfigureSpaceArea)[0].href = CONFIGURE_SPACE_SETTING_PAGE_ACTION;
		});
	},
		
	getAllSpaces: function() {
		var args = {
				url: net.jazz.ajax.contextRoot() + "/queryvvc/allspaces",
				headers: {
					"Accept" : "application/json"
				},
				handleAs: "json",
				sync: true,
				load: function(response, ioArgs) {
					var spaces = [];
					for (var uri in response) {
						var r = {uri: uri, title: response[uri]};
						spaces.push(r);
					}
					return spaces;
				}
		};
		return jazz.client.xhrGet(args);
	}
});
}());