dojo.provide('ibm_ilog.graphlayout.internalutil.GraphLayoutRecUtil');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.LayoutUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.NestedData');
dojo.require('ibm_ilog.graphlayout.GraphLayout');
dojo.require('ibm_ilog.graphlayout.GraphLayoutReport');

dojo.declare('ibm_ilog.graphlayout.internalutil.GraphLayoutRecUtil', null, 
{
  // summary:
  //		Internal class to perform a recursive layout. 
  // description:
  //		Internal class to perform a recursive layout. 
  //		Before JViews 8.1, this stuff was in GraphModel, but for translating
  //		to Diagrammer.NET, it is simpler if the stuff is separated out.   
  // tags:
  //		private
  
  constructor : function()
  {
    
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.GraphLayoutRecUtil,
{

  performLayout : function(model, layoutProvider, recursiveLayout, force, redraw, traverse)
  {
    if (layoutProvider == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6037E");
    }

    var res = 0;

    ibm_ilog.graphlayout.internalutil.NestedData.cleanData(model);

    try
    {
      var rootModel = ibm_ilog.graphlayout.internalutil.LayoutUtil.getRootModel(model);
      res = ibm_ilog.graphlayout.internalutil.GraphLayoutRecUtil.performLayoutInternal(model, null, layoutProvider, recursiveLayout, rootModel, force, redraw, redraw, traverse);
    }
    finally
    {
      ibm_ilog.graphlayout.internalutil.NestedData.cleanData(model);
    }

    return res; // int
  },

  performLayoutInternal : function(model, subgraph, layoutProvider, recursiveLayout, rootModel, force, redraw, userRedraw, traverse)
  {
    ibm_ilog.graphlayout.internalutil.GraphLayoutRecUtil.setDuringRecursiveLayout(model, true);

    var combinedCode = ibm_ilog.graphlayout.GraphLayoutReport.NOT_NEEDED;

    var code;

    try
    {
      var layout = layoutProvider.getGraphLayout(model);
      var needLayoutForThisModel = false;
      if (layout != null) {
        needLayoutForThisModel = layout.isLocalRecursiveLayoutNeeded(layoutProvider, recursiveLayout, rootModel, traverse);
      }
      if (traverse)
      {
        var subGraphModel;
        var node;
        var subgraphs = new ibm_ilog.graphlayout.internalutil.ArrayIterator(model.getSubgraphs());

        while (subgraphs.hasNext())
        {
          node = subgraphs.next();

          subGraphModel = rootModel.getGraphModel(node);

          if (subGraphModel != null)
          {
            code = ibm_ilog.graphlayout.internalutil.GraphLayoutRecUtil.applyLayoutToSubgraph(model, node, subGraphModel, layoutProvider, recursiveLayout, rootModel, force, false, userRedraw);
            if (combinedCode < code) {
              combinedCode = code;
            }
            if (combinedCode == ibm_ilog.graphlayout.GraphLayoutReport.STOPPED_AND_INVALID || combinedCode == ibm_ilog.graphlayout.GraphLayoutReport.EXCEPTION_DURING_LAYOUT) {
              return combinedCode; // int
            }
          }
        }
      }

      if (needLayoutForThisModel)
      {
        if (!redraw && userRedraw && false) {
          redraw = true;
        }
        layout._calledFromRecUtil = true;

        try
        {
          if (recursiveLayout != null) {
            code = recursiveLayout.performSublayout(subgraph, layout, force);
          }
          else {
            code = layout.performLayout(force, false);
          }
        }
        finally
        {
          layout._calledFromRecUtil = false;
        }

        if (code > ibm_ilog.graphlayout.GraphLayoutReport.GREATEST_CODE) {
          code = ibm_ilog.graphlayout.GraphLayoutReport.STOPPED_AND_INVALID;
        }
        if (layout.isStoppedImmediately() && combinedCode < ibm_ilog.graphlayout.GraphLayoutReport.STOPPED_AND_INVALID) {
          combinedCode = ibm_ilog.graphlayout.GraphLayoutReport.STOPPED_AND_INVALID;
        }
        if (combinedCode < code) {
          combinedCode = code;
        }
      }
    }
    finally
    {
      ibm_ilog.graphlayout.internalutil.GraphLayoutRecUtil.setDuringRecursiveLayout(model, false);
    }

    return combinedCode; // int
  },

  applyLayoutToSubgraph : function(model, subgraph, subGraphModel, layoutProvider, recursiveLayout, rootModel, force, redraw, userRedraw)
  {
    return ibm_ilog.graphlayout.internalutil.GraphLayoutRecUtil.performLayoutInternal(
                                 subGraphModel, subgraph, layoutProvider,
                                 recursiveLayout, rootModel, force, redraw,
                                 userRedraw, true);
  },

  setDuringRecursiveLayout : function(model, flag)
  {
    if (flag)
    {
      if (model._duringRecursiveLayout)
      {
        ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowGraphLayoutExc(
                         ibm_ilog.graphlayout.GraphLayout,
                         "graphlayout.expert.message.6038E", [model]);
      }
    }

    model._duringRecursiveLayout = flag;
  }

}
);

