dojo.provide("ibm_ilog.graphlayout.internalutil.GraphModelUtil");

dojo.require("ibm_ilog.graphlayout.internalutil.FixedPoint");

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// #######################################
// ######## NOT Generated by J2JS ########
// ###### DO NOT DELETE THIS FILE! #######
// #######################################

// ------------------------------------------------------------------------
// Utility methods used in the code generated by J2JS.
// ------------------------------------------------------------------------

ibm_ilog.graphlayout.internalutil.GraphModelUtil = {
	getObjectBounds : function(model, obj)
	{
		var r = model.boundingBox(obj);
		if (r) 
			return {
				x: r.x,
				y: r.y,
				width: r.width,
				height: r.height
			};
		else 
			return null;
	},
	
    reshapeLink : function(model, layout, link, linkStyle, fromPoint, points, startIndex, pointsLen, toPoint)
	{
	// summary:    
    //		Reshapes the points of a link.
	
	
	  var clip = layout.isLinkClipping();
	  
      var fromPointMode;
      if (fromPoint instanceof ibm_ilog.graphlayout.internalutil.FixedPoint) {
        fromPointMode = ibm_ilog.graphlayout.ReshapeLinkMode.FIX;
      } else if (fromPoint != null) {
        fromPointMode = clip ? ibm_ilog.graphlayout.ReshapeLinkMode.MOVE_AND_CLIP : ibm_ilog.graphlayout.ReshapeLinkMode.MOVE;
      } else {
        fromPointMode = clip ? ibm_ilog.graphlayout.ReshapeLinkMode.CLIP : ibm_ilog.graphlayout.ReshapeLinkMode.IGNORE;
      }

      var toPointMode;
      if (toPoint instanceof ibm_ilog.graphlayout.internalutil.FixedPoint) {
        toPointMode = ibm_ilog.graphlayout.ReshapeLinkMode.FIX;
      } else if (toPoint != null) {
        toPointMode = clip ? ibm_ilog.graphlayout.ReshapeLinkMode.MOVE_AND_CLIP : ibm_ilog.graphlayout.ReshapeLinkMode.MOVE;
      } else {
        toPointMode = clip ? ibm_ilog.graphlayout.ReshapeLinkMode.CLIP : ibm_ilog.graphlayout.ReshapeLinkMode.IGNORE;
      }
      
      var style;
      switch (linkStyle) {                
        case ibm_ilog.graphlayout.internalutil.LinkStyles.ORTHOGONAL_STYLE:
        case ibm_ilog.graphlayout.internalutil.LinkStyles.THREE_BENDS_ORTHOGONAL_STYLE:
        case ibm_ilog.graphlayout.internalutil.LinkStyles.TWO_BENDS_ORTHOGONAL_STYLE:
          style = ibm_ilog.graphlayout.ReshapeLinkStyle.ORTHOGONAL;
          break;
        case ibm_ilog.graphlayout.internalutil.LinkStyles.POLYLINE_STYLE:
          style = ibm_ilog.graphlayout.ReshapeLinkStyle.POLYLINE;
          break;
        case ibm_ilog.graphlayout.internalutil.LinkStyles.DIRECT_STYLE:
          style = ibm_ilog.graphlayout.ReshapeLinkStyle.DIRECT;
          break;
        case ibm_ilog.graphlayout.internalutil.LinkStyles.STRAIGHT_LINE_STYLE:
        default:
          style = ibm_ilog.graphlayout.ReshapeLinkStyle.STRAIGHT;
          break;
      }
      model.reshapeLink(link, style, 
                        fromPoint, fromPointMode,
                        points, startIndex, pointsLen, 
                        toPoint, toPointMode);
    },
	
    deleteIntermediatePointsOnLinks : function(graphModel, layout)
	{                                
    // summary:
    //		Deletes all the intermediate points (if any) of all the links.
     
      var link;
  	  var links = graphModel.getLinks();
	  var i;
      if (layout.supportsPreserveFixedLinks()) {
        var isPreserveFixedLinks = layout.isPreserveFixedLinks();
        for (i = 0; i < links.length; i++) {
		  link = links[i];
          if (!(isPreserveFixedLinks && layout.isFixed(link)))
            ibm_ilog.graphlayout.internalutil.GraphModelUtil.reshapeLink(graphModel, layout, link, ibm_ilog.graphlayout.internalutil.LinkStyles.STRAIGHT_LINE_STYLE, null, null, 0, 0, null);
        }
      } else {
        for (i = 0; i < links.length; i++) {
			link = links[i];
			ibm_ilog.graphlayout.internalutil.GraphModelUtil.reshapeLink(graphModel, layout, link, ibm_ilog.graphlayout.internalutil.LinkStyles.STRAIGHT_LINE_STYLE, null, null, 0, 0, null);
		}
      }
    },
	
	getNodesAndLinks : function(graphModel)
	{
		var nodes = graphModel.getNodes();
		var links = graphModel.getLinks();
		var result = [];
		var i;
		
		for(i = 0; i < nodes.length; i++)
			result.push(nodes[i]);
		for(i = 0; i < links.length; i++)
			result.push(links[i]);
		
		return result;
	},
	
	getLinks : function(graphModel, node)
	{
		var linksFrom = graphModel.getLinksFrom(node);
		var linksTo = graphModel.getLinksTo(node);
		var result = [];
		var i;
		
		for(i = 0; i < linksFrom.length; i++)
			result.push(linksFrom[i]);
		for(i = 0; i < linksTo.length; i++)
			result.push(linksTo[i]);
		
		return result;
	},

	getLinksCount : function(graphModel, node)
	{
		return graphModel.getLinksFromCount(node) + graphModel.getLinksToCount(node);
	},
	
	getOpposite: function(model, link, node)
	{
		if (node == model.getFrom(link)) 
			return model.getTo(link);
		if (node == model.getTo(link)) 
			return model.getFrom(link);
		ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.internalutil.TranslateUtil, "graphlayout.expert.message.6010E");
	},
	
    getNeighbors : function(model, node)
	{
      var result = [];
      var neighbor;
      var link;
	  var links;
      var i;
      // OPTIMIZEME?
      
	  links = model.getLinksFrom(node);
      for(i = 0; i < links.length; i++) {
	  	link = links[i];
        neighbor = ibm_ilog.graphlayout.internalutil.GraphModelUtil.getOpposite(model, link, node);
        if (neighbor != null && neighbor != node)
          result.push(neighbor);
      }
      
      for(i = 0; i < links.length; i++) {
	  	link = links[i];
        neighbor = ibm_ilog.graphlayout.internalutil.GraphModelUtil.getOpposite(model, link, node);
        if (neighbor != null && neighbor != node)
          result.push(neighbor);
      }
      return result;
    },
	
    getNodeDegree : function(model, node)
	{
      var result = [];
      var neighbor;
      var link;
	  var links;
      var i;
      // OPTIMIZEME?
      
	  links = model.getLinksFrom(node);
      for(i = 0; i < links.length; i++) {
	  	link = links[i];
        neighbor = ibm_ilog.graphlayout.internalutil.GraphModelUtil.getOpposite(model, link, node);
        if (neighbor != node && dojo.indexOf(result, neighbor) == -1)
          result.push(neighbor);
      }
      
      for(i = 0; i < links.length; i++) {
	  	link = links[i];
        neighbor = ibm_ilog.graphlayout.internalutil.GraphModelUtil.getOpposite(model, link, node);
        if (neighbor != node && dojo.indexOf(result, neighbor) == -1)
          result.push(neighbor);
      }
      return result.length;
    },
	
	getModelBounds : function(model)
	{
		var nodes = model.getNodes();
		var links = model.getLinks();
		var bbox = null;
		var bb;
		var i;
		
		for (i = 0; i < nodes.length; i++) {
			bb = model.boundingBox(nodes[i]);
			if(bbox == null)
				bbox = { x: bb.x, y: bb.y, width: bb.width, height: bb.height };
			else
				ibm_ilog.graphlayout.internalutil.TranslateUtil.addRect(bbox, bb);
		}
		for(i = 0; i < links.length; i++){
			bb = model.boundingBox(links[i]);
			if(bbox == null)
				bbox = { x: bb.x, y: bb.y, width: bb.width, height: bb.height };
			else
				ibm_ilog.graphlayout.internalutil.TranslateUtil.addRect(bbox, bb);
		}
		
		if(bbox)
			return bbox;
		else
			return { x:0, y:0, width:0, height:0 };
	},
	
	move: function(model, x, y){
		var currentBBox = ibm_ilog.graphlayout.internalutil.GraphModelUtil.getModelBounds(model);
		var dx = x - currentBBox.x;
		var dy = y - currentBBox.y;
		if (dx == 0 && dy == 0) 
			return;
		
		var nds = model.getNodes();
		if (nds.length == 0) 
			return;
		
		// Get the link points before any movement
		// because the end points position depend on
		// the position of the nodes
		var lks = model.getLinks();
		var link;
		var lprop;
		var lindex = 0;
		var linkPoints;
		var linksArray = null;
		
		// Get the link points before node movement
		// so that end points are correct.
		if (lks.length > 0) 
			linksArray = new Array(lks.length);
		var i;
		for (i = 0; i < lks.length; i++) {
			var link = lks[i];
			linkPoints = model.getLinkPoints(link);
			lprop = new Object();
			lprop.link = link;
			lprop.linkPoints = linkPoints;
			linksArray[lindex] = lprop;
			lindex++;
		}
		
		// First move nodes
		for (i = 0; i < nds.length; i++) {
			var node = nds[i];
			var bbox = model.boundingBox(node);
			model.moveNode(node, bbox.x + dx, bbox.y + dy);
		}
		
		// Reshape the link if the link is not straight.
		
		if (linksArray) {
			for (i = i; i < linksArray.length; i++) {
				var lprop = linksArray[i];
				link = lprop.link;
				linkPoints = lprop.linkPoints;
				if (linkPoints != null /* AV: NO LONGER && (linkPoints.length > 2) */) {
					// Translate link points
					var lastIndex = linkPoints.length - 1;
					var j;
					for (j = 0; j < linkPoints.length; j++) {
						var p = linkPoints[j];
						p.x = p.x + dx;
						p.y = p.y + dy;
					}
					
					model.reshapeLink(null, link, ibm_ilog.graphlayout.ReshapeLinkStyle.IGNORE, null, ibm_ilog.graphlayout.ReshapeLinkMode.IGNORE, linkPoints, 1, lastIndex - 1, null, ibm_ilog.graphlayout.ReshapeLinkMode.IGNORE);
				/* WAS
				 model.reshapeLink(null, link, ReshapeLinkStyle.IGNORE,
				 linkPoints[0], ReshapeLinkMode.MOVE,
				 linkPoints, 1, lastIndex - 1,
				 linkPoints[lastIndex], ReshapeLinkMode.MOVE);
				 */
				}
			}
		}
	}
};