dojo.provide('ibm_ilog.graphlayout.internalutil.LayoutParametersUtil');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');
dojo.require('ibm_ilog.graphlayout.GraphLayout');

dojo.declare('ibm_ilog.graphlayout.internalutil.LayoutParametersUtil', null, 
{
  // summary:
  //		This class contains utilities for managing node/link parameters. 
  // description:
  //		This class contains utilities for managing node/link parameters. 
  //		To use the standard parameter storage mechanism (including input
  //		check, and taking into account isUseDefaultParameters), use the
  //		high-level API: Set/GetNode/Link/NodeOrLinkParameter To avoid use of
  //		isUseDefaultParameters, or in other specific cases, use the
  //		lower-level API: Set/GetNode/Link/NodeOrLinkProperty
  // tags:
  //		private
  
  // no nonstatic constructor in static JavaScript class

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.LayoutParametersUtil,
{

  checkInputNode : function(layout, node, objDescr)
  {
    ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.checkInputNodeOrLink(layout, node, objDescr, "The node", "a node", true, false);
  },

  checkInputLink : function(layout, link, objDescr)
  {
    ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.checkInputNodeOrLink(layout, link, objDescr, "The link", "a link", false, true);
  },

  checkInputNodeOrLink : function(layout, nodeOrLink, objDescr, defaultDescr

, reqDescr , checkNode , checkLink )
  {
    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6018E");
    }

    if (nodeOrLink == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6048E");
    }

    if (!layout.isInputCheckEnabled()) {
      return;
    }
    if (!(checkNode && graphModel.isNode(nodeOrLink)) && !(checkLink && (graphModel.isLink(nodeOrLink) || graphModel.isIntergraphLink(nodeOrLink))))
    {
      var params = [nodeOrLink, graphModel ];
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6049E", params);
    }
  },

  setNodeParameter : function(layout, node, key, value

)
  {
    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.setNodeParameter2(layout, node, true, key, value ); // Boolean
  },

  setNodeParameter2 : function(layout, node, checkNode, key, value

)
  {
    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, node, "The input node", checkNode, false, key, value ); // Boolean
  },

  setLinkParameter : function(layout, link, key, value

)
  {
    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, link, "The input link", false, true, key, value ); // Boolean
  },

  setNodeOrLinkParameter : function(layout, nodeOrLink, key, value

)
  {
    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.setNodeOrLinkParameterImpl(layout, nodeOrLink, "The input node or link", true, true, key, value ); // Boolean
  },

  setNodeOrLinkParameterImpl : function(layout, nodeOrLink, objectDescr, checkNode, checkLink, key, value

)
  {
    var graphModel = ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getGraphModel(layout, nodeOrLink, objectDescr, checkNode, checkLink);
    var changed = false;
    var oldValue = null;

    oldValue = layout.setObjectParameter(graphModel, nodeOrLink, key, value);

    changed = !ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.areEqual(oldValue, value);
    if (changed) {
      layout.onObjectParameterChanged(nodeOrLink, key);
    }
    return changed; // Boolean
  },

  setNodeOrLinkProperty : function(layout, nodeOrLink, objectDescr, checkNode, checkLink, key, value)
  {
    var graphModel = ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getGraphModel(layout, nodeOrLink, objectDescr, checkNode, checkLink);
    var oldValue = layout.setObjectParameter(graphModel, nodeOrLink, key, value);
    return !ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.areEqual(oldValue, value); // Boolean
  },

  getGraphModel : function(layout, nodeOrLink, objectDescr, checkNode, checkLink)
  {
    if (checkNode && checkLink) {
      ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.checkInputNodeOrLink(layout, nodeOrLink, objectDescr, "The object", "a node or link", true, true);
    }
    else if (checkNode) {
      ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.checkInputNode(layout, nodeOrLink, objectDescr);
    }
    else if (checkLink) {
      ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.checkInputLink(layout, nodeOrLink, objectDescr);
    }

    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6018E");
    }

    return graphModel; // ibm_ilog.graphlayout.AbstractGraphLayoutModel
  },

  areEqual : function(obj1, obj2)
  {
    if (obj1 == null) {
      return obj2 == null; // Boolean
    }
    else {
      return obj1 == obj2; // Boolean
    }
  },

  getNodeBooleanParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6050E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkBooleanParameter(layout, node, key, defaultValue); // Boolean
  },

  getNodeIntParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6050E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkIntParameter(layout, node, key, defaultValue); // int
  },

  getNodeFloatParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6050E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkFloatParameter(layout, node, key, defaultValue); // Number
  },

  getNodeEnumParameter : function(layout, node, key, defaultValue)
  {
    if (node == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6050E");
    }

    if (false) {
      return defaultValue; // int
    }
    var prop = ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkParameter(layout, node, key);

    if (prop == null) {
      return defaultValue; // int
    }
    else
    {
      return  (prop); // int
    }
  },

  getNodeParameter : function(layout, node, key)
  {
    if (node == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6050E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkParameter(layout, node, key); // Object
  },

  getLinkBooleanParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6051E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkBooleanParameter(layout, link, key, defaultValue); // Boolean
  },

  getLinkIntParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6051E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkIntParameter(layout, link, key, defaultValue); // int
  },

  getLinkFloatParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6051E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkFloatParameter(layout, link, key, defaultValue); // Number
  },

  getLinkParameter : function(layout, link, key)
  {
    if (link == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6051E");
    }

    return ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkParameter(layout, link, key); // Object
  },

  getLinkEnumParameter : function(layout, link, key, defaultValue)
  {
    if (link == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6051E");
    }

    if (false) {
      return defaultValue; // int
    }
    var prop = ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkParameter(layout, link, key);

    if (prop == null)
    {
      return defaultValue; // int
    }
    else
    {
      return  (prop); // int
    }
  },

  getNodeOrLinkBooleanParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // Boolean
    }
    var prop = ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return ((prop != null) ? prop : defaultValue);
  },

  getNodeOrLinkIntParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // int
    }
    var prop = ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return (prop == null ? defaultValue :  (prop)); // int
  },

  getNodeOrLinkFloatParameter : function(layout, nodeOrLink, key, defaultValue)
  {
    if (false) {
      return defaultValue; // Number
    }
    var prop = ibm_ilog.graphlayout.internalutil.LayoutParametersUtil.getNodeOrLinkParameter(layout, nodeOrLink, key);
    return (prop == null ? defaultValue : (prop)); // Number
  },

  getNodeOrLinkParameter : function(layout, nodeOrLink, key)
  {
    var graphModel = layout.getGraphModel();

    if (graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.GraphLayout, "graphlayout.expert.message.6018E");
    }

    return layout.getObjectParameter(graphModel, nodeOrLink, key); // Object
  },

  getNodeParameterName : function(propertyName)
  {
    return (propertyName + "N"); // String
  },

  getLinkParameterName : function(propertyName)
  {
    return (propertyName + "L"); // String
  }

}
);

