dojo.provide('ibm_ilog.graphlayout.internalutil.NestedData');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.HashTable');
dojo.require('ibm_ilog.graphlayout.internalutil.LayoutUtil');

dojo.declare('ibm_ilog.graphlayout.internalutil.NestedData', null, 
{
  // summary:
  //		Additional data about the nested graph models, sometimes needed by
  //		recursive nested layouts. 
  // description:
  //		Additional data about the nested graph models, sometimes needed by
  //		recursive nested layouts. 
  //		If all our graph models were GrapherAdapter, this would probably be
  //		unnecessary, but since we have some GraphModels that are no
  //		GrapherAdapter, this is needed.  
  //		<p>
  //		It allows:  
  //		<ul>
  //		<li> To ask for the parent of a node. </li>  
  //		<li> To ask for the node which is a subgraph represented a graph
  //		model. </li>  
  //		<li> More to come later ... if needed. </li>  
  //		</ul>
  //		Usually, we keep this data only during recursive layout, stored as
  //		property in the root model.   
  //		</p>
  // tags:
  //		private
  
  _nodeToParent: null,
  _graphModelToNode: null,

  getGraphModelNode : function(model)
  {
    // summary:
    //		Returns the node of the parent graph model that is a subgraph that
    //		has the input graph model. 
    // description:
    //		Returns the node of the parent graph model that is a subgraph that
    //		has the input graph model. 
    //		In GrapherAdapter, this is equivalent to adapter.getGrapher(). In
    //		GraphModel, this is equivalent in accessing the parent model and
    //		searching for the subgraph that has a graph model equal to the input
    //		model. Returns null if the model is the root model.
    // tags:
    //		private
    
    return this._graphModelToNode.item(model); // Object
  },

  getParent : function(node)
  {
    // summary:
    //		Returns the parent node of the input node. 
    // description:
    //		Returns the parent node of the input node. 
    //		In GrapherAdapter, this is equivalent to
    //		getParentModel().getGrapher(). In GraphModel, this is equivalent in
    //		retrieving the model that contains the input node and then asking
    //		getGraphModelNode(model).  Returns null if the node is in the root
    //		model.
    // tags:
    //		private
    
    return this._nodeToParent.item(node); // Object
  },

  constructor : function(rootModel)
  {
    this._nodeToParent = new ibm_ilog.graphlayout.internalutil.HashTable();
    this._graphModelToNode = new ibm_ilog.graphlayout.internalutil.HashTable();
    var submodel;
    var e = new ibm_ilog.graphlayout.internalutil.ArrayIterator(rootModel.getSubgraphs());

    while (e.hasNext())
    {
      var node = e.next();
      submodel = rootModel.getGraphModel(node);
      this.traverse(rootModel, node, submodel);
    }
  },
  
  traverse : function(rootModel, subgraph, model)
  {
    this._graphModelToNode.add(model, subgraph);
    var e = new ibm_ilog.graphlayout.internalutil.ArrayIterator(model.getNodes());

    while (e.hasNext())
    {
      this._nodeToParent.add(e.next(), subgraph);
    }

    var submodel;
    e = new ibm_ilog.graphlayout.internalutil.ArrayIterator(model.getSubgraphs());

    while (e.hasNext())
    {
      var node = e.next();
      submodel = rootModel.getGraphModel(node);
      this.traverse(rootModel, node, submodel);
    }
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.NestedData,
{
  PROPERTY_NAME : null,

  getData : function(model)
  {
    var rootModel = ibm_ilog.graphlayout.internalutil.LayoutUtil.getRootModel(model);
    var data = rootModel.getParameter(ibm_ilog.graphlayout.internalutil.NestedData.PROPERTY_NAME);

    if (data == null)
    {
      data = new ibm_ilog.graphlayout.internalutil.NestedData(rootModel);
      rootModel.setParameter(ibm_ilog.graphlayout.internalutil.NestedData.PROPERTY_NAME, data);
    }

    return data; // ibm_ilog.graphlayout.internalutil.NestedData
  },

  cleanData : function(model)
  {
    var rootModel = ibm_ilog.graphlayout.internalutil.LayoutUtil.getRootModel(model);
    rootModel.setParameter(ibm_ilog.graphlayout.internalutil.NestedData.PROPERTY_NAME, null);
  },

  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.internalutil.NestedData;
    
    c.PROPERTY_NAME = "__NestedDataInfo";
  }
  
}
);

(function(){ ibm_ilog.graphlayout.internalutil.NestedData._fields_init(); })();
