dojo.provide('ibm_ilog.graphlayout.internalutil.SplineRouter');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.genericquadtree.GenericApplyObject');
dojo.require('ibm_ilog.graphlayout.internalutil.genericquadtree.GenericIndexedSet');
dojo.require('ibm_ilog.graphlayout.internalutil.genericquadtree.IGenericQuadtreeObject');
dojo.require('ibm_ilog.graphlayout.internalutil.Point');
dojo.require('ibm_ilog.graphlayout.internalutil.Rectangle');
dojo.require('ibm_ilog.graphlayout.internalutil.SubgraphData');

dojo.declare('ibm_ilog.graphlayout.internalutil.SplineRouter', null, 
{
  // summary:
  //		A simple utility that corrects the bend points of links so that they
  //		become appropriate for splines. 
  // description:
  //		A simple utility that corrects the bend points of links so that they
  //		become appropriate for splines. 
  //		It assumes that we use smooth splines. polyline route. (This may not
  //		work with short link layout). The algorithm can handle intergraph
  //		links but requires a SubgraphData graph model in this case, because
  //		it needs a flat view of all node obstacles.  
  // tags:
  //		private
  
  _model: null,
  _layout: null,
  _percCompleteController: null,
  _percentageFromAll: null,
  _equalizeThreshold: null,
  _maxCurveLen: null,
  _minCurveLen: null,
  _includeNormalLinks: null,
  _includeIntergraphLinks: null,

  A : null,

  B : null,

  C : null,

  P : null,

  QR : null,
  _doIntergraphLinkCheck: null,
  _changed: null,
  _indexedSet: null,

  _applyObject : null,

  constructor : function(layout, percController, percentageFromAll, minCurveLen, maxCurveLen, equalizeThreshold, normalLinks, intergraphLinks)
  {
    this.A = new ibm_ilog.graphlayout.internalutil.Point();
    this.B = new ibm_ilog.graphlayout.internalutil.Point();
    this.C = new ibm_ilog.graphlayout.internalutil.Point();
    this.P = new ibm_ilog.graphlayout.internalutil.Point();
    this.QR = new ibm_ilog.graphlayout.internalutil.Rectangle();
    this._applyObject = new ibm_ilog.graphlayout.internalutil.SplineRouterApplyObject(this);
    this._model = layout.getGraphModel();
    this._layout = layout;
    this._percCompleteController = percController;
    this._percentageFromAll = percentageFromAll;
    this._minCurveLen = minCurveLen;
    this._maxCurveLen = maxCurveLen;
    this._equalizeThreshold = equalizeThreshold;
    this._includeNormalLinks = normalLinks;
    this._includeIntergraphLinks = intergraphLinks;
    if (this._minCurveLen > this._maxCurveLen) {
      this._minCurveLen = this._maxCurveLen;
    }
  },
  
  run : function(redraw, finalStep)
  {
    // summary:
    //		Runs the algorithm.  
    // redraw: Boolean
    //		Whether to redraw the links.
    // finalStep: Boolean
    //		Whether the routing is the final step of the layout
    //		algorithm. This is only important if a percentage complete
    //		controller was given.
    // tags:
    //		private
    
    if (this._percCompleteController != null)
    {
      var points = 0;
      if (this._includeNormalLinks) {
        points += this._model.getLinksCount();
      }
      if (this._includeIntergraphLinks) {
        points += this._model.getIntergraphLinksCount();
      }
      this._percCompleteController.startStep(this._percentageFromAll, points, finalStep);
    }

    this.initQuadtree();
    this.reshapeLinks(redraw);
  },

  isObstacle : function(node)
  {
    // summary:
    //		Returns whether the node is considered an obstacle.
    // tags:
    //		private
    
    return true; // Boolean
  },

  reshapeLinks : function (a0, a1)
  {
    // summary:
    //		Reshapes all links. 
    // description:
    //		Reshapes all links. 
    //		
    // tags:
    //		private
    
    if(arguments.length == 1)
      return this.reshapeLinks_overload_1(a0);
    else if(arguments.length == 2)
      return this.reshapeLinks_overload_2(a0, a1);
  },
  
  reshapeLinks_overload_1 : function(redraw)
                                            
  {
    this._doIntergraphLinkCheck = (this._model instanceof ibm_ilog.graphlayout.internalutil.SubgraphData);
    var e;

    if (this._includeNormalLinks)
    {
      e = new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._model.getLinks());
      this.reshapeLinks(e, redraw);
    }

    if (this._includeIntergraphLinks)
    {
      e = (new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._model.getIntergraphLinks()));
      this.reshapeLinks(e, redraw);
    }
  },

  reshapeLinks_overload_2 : function(e, redraw)
  {
    // summary:
    //		Reshape all links of the input enumeration.  
    // tags:
    //		private
    
    while (e.hasNext())
    {
      var link = e.next();

      if (this.isReshapeAllowed(link))
      {
        this._applyObject.link = link;
        this._changed = false;
        var pts = this._model.getLinkPoints(link);
        pts = this.correctSplineControlPoints(pts);

        if (this._changed)
        {
          var n = pts.length;
          ibm_ilog.graphlayout.internalutil.GraphModelUtil.reshapeLink(this._model,this._layout,link,ibm_ilog.graphlayout.internalutil.LinkStyles.NO_RESHAPE_STYLE,pts[0],pts,1, n-2,pts[n-1]);
        }

        if (this._percCompleteController != null) {
          this._percCompleteController.addPoints(1);
        }
        this._layout.callLayoutStepPerformedIfNeeded();
      }
    }
  },

  isReshapeAllowed : function(link)
  {
    // summary:
    //		Returns whether reshaping the link is allowed.
    // tags:
    //		private
    
    return true; // Boolean
  },

  isInvisibleToLink : function(node, link)
  {
    // summary:
    //		Returns whether the node is invisible to the link. 
    // description:
    //		Returns whether the node is invisible to the link. 
    //		If thats the case, the
    //		node's corner are not taken into account when calculating the spline bends for the link. The default implementation returns true if the link is an intergraph link of the SubgraphData graph model and the node is a subgraph that contains an end of the link.
    // tags:
    //		private
    
    if (this._doIntergraphLinkCheck)
    {
      var dmodel = this._model;
      if (dmodel.fromEndsInside(link, node)) {
        return true; // Boolean
      }
      if (dmodel.toEndsInside(link, node)) {
        return true; // Boolean
      }
    }

    return false; // Boolean
  },

  correctSplineControlPoints : function(points)
  {
    // summary:
    //		Corrects the control points of a polyline to be a correct spline.  
    // points: Array
    //		The points of the spline.
    // returns:
    //		The new control points of the spline.
    // tags:
    //		private
    
    var n = points.length;
    var newPoints = new Array();
    var lastPoint = new ibm_ilog.graphlayout.internalutil.Point(points[0] .x, points[0] .y);
    newPoints.push(points[0]);

    if (n > 2)
    {
      var m = n - 1;

      for (var i = 1; i < m; i++)
      {
        this._changed = true;
        var act = points[i];
        var prv = points[i - 1];
        var nxt = points[i + 1];
        ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(this.A, act.x, act.y);
        ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(this.B, 0.5 * (act.x + prv.x), 0.5 * (act.y + prv.y));
        ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(this.C, 0.5 * (act.x + nxt.x), 0.5 * (act.y + nxt.y));
        this.correctTriangle(this.A, this.B, this.C);

        if (this.isValidTriangle(this.A, this.B, this.C))
        {
          if (!ibm_ilog.graphlayout.internalutil.TranslateUtil.pointEquals(lastPoint, this.B)) {
            newPoints.push(new ibm_ilog.graphlayout.internalutil.Point(this.B .x, this.B .y));
          }
          newPoints.push(new ibm_ilog.graphlayout.internalutil.Point(this.A .x, this.A .y));
          newPoints.push(new ibm_ilog.graphlayout.internalutil.Point(this.C .x, this.C .y));
        }
        else
        {
          if (!ibm_ilog.graphlayout.internalutil.TranslateUtil.pointEquals(lastPoint, this.C)) {
            newPoints.push(new ibm_ilog.graphlayout.internalutil.Point(this.C .x, this.C .y));
          }
        }

        ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(lastPoint, this.C.x, this.C.y);
      }
    }

    if (!ibm_ilog.graphlayout.internalutil.TranslateUtil.pointEquals(lastPoint, points[n - 1])) {
      newPoints.push(points[n - 1]);
    }
    return ibm_ilog.graphlayout.internalutil.TranslateUtil.copyArrayInto(newPoints,
           ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(newPoints.length, null)); // Array
  },

  correctTriangle : function(a, b, c)
  {
    // summary:
    //		Corrects the triangle B and C points so that no obstacle point is
    //		inside the triangle.  
    // tags:
    //		private
    
    if (!this.isValidTriangle(a, b, c)) {
      return;
    }
    var checkAgain = false;
    var dabx = a.x - b.x;
    var daby = a.y - b.y;
    var dab = Math.sqrt(dabx * dabx + daby * daby);
    var dacx = a.x - c.x;
    var dacy = a.y - c.y;
    var dac = Math.sqrt(dacx * dacx + dacy * dacy);

    if (this._maxCurveLen > 0)
    {
      if (dab > this._maxCurveLen)
      {
        b.x = (a.x - dabx * this._maxCurveLen / dab);
        b.y = (a.y - daby * this._maxCurveLen / dab);
        dabx = a.x - b.x;
        daby = a.y - b.y;
        dab = Math.sqrt(dabx * dabx + daby * daby);
        checkAgain = true;
      }

      if (dac > this._maxCurveLen)
      {
        c.x = (a.x - dacx * this._maxCurveLen / dac);
        c.y = (a.y - dacy * this._maxCurveLen / dac);
        dacx = a.x - c.x;
        dacy = a.y - c.y;
        dac = Math.sqrt(dacx * dacx + dacy * dacy);
        checkAgain = true;
      }
    }

    if (dab >= this._equalizeThreshold && dac >= this._equalizeThreshold)
    {
      if (dab > dac)
      {
        b.x = (a.x - dabx * dac / dab);
        b.y = (a.y - daby * dac / dab);
      }
      else
      {
        c.x = (a.x - dacx * dab / dac);
        c.y = (a.y - dacy * dab / dac);
      }

      checkAgain = true;
    }

    if (checkAgain && !this.isValidTriangle(a, b, c)) {
      return;
    }
    this.QR.x = this.A.x;
    this.QR.y = this.A.y;
    this.QR.width = 0.01;
    this.QR.height = 0.01;
    ibm_ilog.graphlayout.internalutil.TranslateUtil.addPoint(this.QR, this.B.x, this.B.y);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.addPoint(this.QR, this.C.x, this.C.y);

    this._indexedSet.mapIntersects(this.QR, this._applyObject, null);
  },

  pointInTriangle : function(a, b, c, p)
  {
    // summary:
    //		Checks whether p lies inside the triangle (a, b, c). 
    // description:
    //		Checks whether p lies inside the triangle (a, b, c). 
    //		If p is outside (a, b, c), false is returned and the triangle is
    //		left unchanged. If p is inside (a, b, c), b and c are corrected so
    //		that a smaller rectangle is used so that p is on the border of that
    //		rectangle. In this case, true is returned.  The input triangle must
    //		be valid.  
    // tags:
    //		private
    
    if (p.x <= a.x && p.x <= b.x && p.x <= c.x) {
      return false; // Boolean
    }
    if (p.x >= a.x && p.x >= b.x && p.x >= c.x) {
      return false; // Boolean
    }
    if (p.y <= a.y && p.y <= b.y && p.y <= c.y) {
      return false; // Boolean
    }
    if (p.y >= a.y && p.y >= b.y && p.y >= c.y) {
      return false; // Boolean
    }
    if (p.x == a.x && p.y == a.y) {
      return false; // Boolean
    }
    if (p.x == b.x && p.y == b.y) {
      return false; // Boolean
    }
    if (p.x == c.x && p.y == c.y) {
      return false; // Boolean
    }

    var dcbx = c.x - b.x;
    var dcby = c.y - b.y;
    var dpax = p.x - a.x;
    var dpay = p.y - a.y;
    var D = dcbx * dpay - dcby * dpax;

    if (D == 0) {
      return false; // Boolean
    }
    var dabx = a.x - b.x;
    var daby = a.y - b.y;
    var L = (dabx * dcby - daby * dcbx) / D;
    if (L <= 1) {
      return false; // Boolean
    }
    var M = (daby + L * dpay) / dcby;
    if (M <= 0 || M >= 1) {
      return false; // Boolean
    }
    var nbx = (a.x + (b.x - a.x) / L);
    var nby = (a.y + (b.y - a.y) / L);
    var ncx = (a.x + (c.x - a.x) / L);
    var ncy = (a.y + (c.y - a.y) / L);
    dabx = a.x - nbx;
    daby = a.y - nby;

    if (Math.sqrt(dabx * dabx + daby * daby) >= this._minCurveLen)
    {
      b.x = nbx;
      b.y = nby;
    }

    dabx = a.x - ncx;
    daby = a.y - ncy;

    if (Math.sqrt(dabx * dabx + daby * daby) >= this._minCurveLen)
    {
      c.x = ncx;
      c.y = ncy;
    }

    return true; // Boolean
  },

  isValidTriangle : function(a, b, c)
  {
    // summary:
    //		Checks whether the input triable (a, b, c) is a valid triangle. 
    // description:
    //		Checks whether the input triable (a, b, c) is a valid triangle. 
    //		A triangle is degenerated (not valid) if a, b, c are on one line.  
    // tags:
    //		private
    
    if ((b.x - a.x) * (c.y - a.y) == (c.x - a.x) * (b.y - a.y)) {
      return false; // Boolean
    }
    return true; // Boolean
  },

  initQuadtree : function()
  {
    // summary:
    //		Initialize the quadtree.  
    // tags:
    //		private
    
    this._indexedSet = new ibm_ilog.graphlayout.internalutil.genericquadtree.GenericIndexedSet(20, 20, new SplineRouterAnonClass_1());
    var e = new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._model.getNodes());

    while (e.hasNext())
    {
      var node = e.next();
      if (!this.isObstacle(node)) {
        continue;
      }
      var bbox = ibm_ilog.graphlayout.internalutil.GraphModelUtil.getObjectBounds(this._model, node);
      var corners = this.getCorners(node, bbox);
      var obj = new ibm_ilog.graphlayout.internalutil.SplineRouterQuadtreeObject();
      obj.node = node;
      obj.bbox = bbox;
      obj.corners = corners;
      this._indexedSet.addObject(obj);
    }
  },

  getCorners : function(node, bbox)
  {
    // summary:
    //		Returns the corners of a node. 
    // description:
    //		Returns the corners of a node. 
    //		The default implementation returns the corners of the bounding box
    //		of the node. To support different node shapes better, overridden
    //		versions can take the more precise corners of the node into account.
    // tags:
    //		private
    
    var corners = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(4, null);
    corners[0] = new ibm_ilog.graphlayout.internalutil.Point(bbox.x, bbox.y);
    corners[1] = new ibm_ilog.graphlayout.internalutil.Point(bbox.x + bbox.width, bbox.y);
    corners[2] = new ibm_ilog.graphlayout.internalutil.Point(bbox.x, bbox.y + bbox.height);
    corners[3] = new ibm_ilog.graphlayout.internalutil.Point(bbox.x + bbox.width, bbox.y + bbox.height);
    return corners; // Array
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.internalutil.SplineRouter,
{
}
);

dojo.declare('ibm_ilog.graphlayout.internalutil.SplineRouterApplyObject', ibm_ilog.graphlayout.internalutil.genericquadtree.GenericApplyObject, 
{
  __outerThis: null,

  constructor : function(input__outerThis)
  {
    this.__outerThis = input__outerThis;
  },
  link: null,

  apply : function(obj, arg)
  {
    var qo = obj;
    if (this.__outerThis.isInvisibleToLink(qo.node, this.link)) {
      return;
    }
    var corners = qo.corners;

    for (var i = 0; i < corners.length; i++)
    {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(this.__outerThis.P, corners[i].x, corners[i].y);
      this.__outerThis.pointInTriangle(this.__outerThis.A, this.__outerThis.B, this.__outerThis.C, this.__outerThis.P);
    }
  }

}
);
/**
 * @private
 */
dojo.declare('SplineRouterAnonClass_1', ibm_ilog.graphlayout.internalutil.genericquadtree.IGenericQuadtreeObject,
{
  // tags:
  //		private
  
  constructor : function()
  {
    
  },

  boundingBox : function(object)
  {
    var qo = object;
    return qo.bbox; // Rectangle
  }

});

dojo.declare('ibm_ilog.graphlayout.internalutil.SplineRouterQuadtreeObject', null, 
{

  constructor : function()
  {
    
  },
  node: null,
  bbox: null,
  corners: null
}
);
