dojo.provide('ibm_ilog.graphlayout.internalutil.SubgraphData');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.BaseSubgraphData');

dojo.declare('ibm_ilog.graphlayout.internalutil.SubgraphData', ibm_ilog.graphlayout.internalutil.BaseSubgraphData, 
{
  // summary:
  //		A container class that collects and delivers the node and link data
  //		of subgraphs. 
  // description:
  //		A container class that collects and delivers the node and link data
  //		of subgraphs. 
  //		This subclass of <code>BaseSubgraphData</code> is used by the link
  //		layouts for intergraph link layout. It adds handling of  links that
  //		need to be considered as fixed by the intergraph link layout.   
  //		<p>
  //		 
  //		</p>
  // tags:
  //		private
  
  normalLinksAreFixed: null,

  constructor : function()
  {
    this.normalLinksAreFixed = true;
  },
  
  setNormalLinksFixed : function(fixed)
  {
    // summary:
    //		Sets whether normal links should be considered fixed such that only
    //		intergraph links are routed. 
    // description:
    //		Sets whether normal links should be considered fixed such that only
    //		intergraph links are routed. 
    //		If passed false, both intergraph links and normal links are
    //		considered nonfixed and can be routed at the same time.
    // tags:
    //		private
    
    this.normalLinksAreFixed = fixed;
  },

  isFixedLink : function(link)
  {
    // summary:
    //		Returns true if intergraph link routing should consider this link as
    //		fixed. 
    // description:
    //		Returns true if intergraph link routing should consider this link as
    //		fixed. 
    //		All links that
    //		don't belong to the main graph model are considered fixed. This method is used in the link layout.
    // tags:
    //		private
    
    if (this.normalLinksAreFixed && this.wasIntergraphLink(link) == false) {
      return true; // Boolean
    }
    if (this.getOriginalGraphModel(link) != this.getOriginalGraphModel()) {
      return true; // Boolean
    }
    return false; // Boolean
  }

}
);
