dojo.provide('ibm_ilog.graphlayout.longlink.LongLinkLayoutReport');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.GraphLayoutReport');

dojo.declare('ibm_ilog.graphlayout.longlink.LongLinkLayoutReport', ibm_ilog.graphlayout.GraphLayoutReport, 
{
  // summary:
  //		The class used to store information about the behavior of the
  //		Orthogonal Long Link Layout algorithm.
  
  _numberOfFallbackLinks : null,

  constructor : function()
  {
    this._numberOfFallbackLinks = 0;
  },
  
  setNumberOfFallbackLinks : function(number)
  {
    // summary:
    //		Sets the number of fallback links.
    // tags:
    //		private
    
    this._numberOfFallbackLinks = number;
  },

  incrNumberOfFallbackLinks : function()
  {
    // summary:
    //		Increments the number of fallback links.
    // tags:
    //		private
    
    this._numberOfFallbackLinks += 1;
  },

  getNumberOfFallbackLinks : function()
  {
    // summary:
    //		Returns the number of links that could not be routed on the grid
    //		without obstacle overlaps. 
    // description:
    //		Returns the number of links that could not be routed on the grid
    //		without obstacle overlaps. 
    //		<p>
    //		A link may not be routed without overlaps if the allowed time to
    //		find a route for this link has elapsed (see <code>
    //		LongLinkLayout.getAllowedTimePerLink()</code>), or if the route
    //		would have to bypass too many obstacles (see <code>
    //		LongLinkLayout.getMaxBacktrack()</code>), or if there is no path on
    //		the grid from the start node to the end node that bypasses all
    //		obstacles.  
    //		</p>
    //		<p>
    //		If the fallback routing option was set to <code>true</code> by using
    //		<code> LongLinkLayout.setFallbackRouteEnabled()</code>, such links
    //		are routed by a simple fallback routing algorithm.  
    //		</p>
    // returns:
    //		The number of links that could not be routed on the grid without
    //		obstacle overlaps.
    
    return this._numberOfFallbackLinks; // int
  }

}
);
