dojo.provide('ibm_ilog.diagram.overview.OverviewGfxRenderer');

dojo.require('ibm_ilog.diagram.overview.OverviewRenderer');
dojo.require('ibm_ilog.diagram.util.Geometry');
dojo.require('ibm_ilog.diagram.util.ErrorReporter');
dojo.require('ibm_ilog.diagram.util.GraphUtil');

(function() {
	var R = ibm_ilog.diagram.util.ErrorReporter;
	var g = ibm_ilog.diagram.util.Geometry, Rect = g.Rect, EmptyRect = g.EmptyRect, Size = g.Size, PointZero = g.PointZero, Point = g.Point;
	var gu = ibm_ilog.diagram.util.GraphUtil;

dojo.declare('ibm_ilog.diagram.overview.OverviewGfxRenderer',ibm_ilog.diagram.overview.OverviewRenderer, {
	
	// static
	_transformSerialize: function transformSerialize(
			/* dojox.gfx.Surface || dojox.gfx.Shape */ object,
			/* Function | String */                    transform
		)
	{
		var d = dojo, g = dojox.gfx, gu = g.utils;
		var t = {}, isSurface = object instanceof g.Surface;

		var transformChildren = function() {
			var mapf = function(x){ return transformSerialize(x,transform); };
			var notz = function(x){ return x!=null; };
			return d.filter(d.map(object.children,mapf),notz);
		};
		
		if(isSurface) {
			return transformChildren();	// Array
		} else {
			return transform(object,transformChildren);
		}

	},

	
	// static
	_shapeCopy: function(copy,shape,getChildren) {
		var d = dojo, g = dojox.gfx, gu = g.utils;
		var v;
		if(!(shape instanceof g.Surface) &&
	       !(shape instanceof g.Group)){		
			copy.shape = shape.getShape();
		} else {
			copy.children = getChildren();	
		}
		
		if(shape.getTransform){
			v = shape.getTransform();
			if(v){ copy.transform = v; }
		}
		if(shape.getStroke){
			v = shape.getStroke();
			if(v){ copy.stroke = v; }
		}
		if(shape.getFill){
			v = shape.getFill();
			if(v){ copy.fill = v; }
		}
		if(shape.getFont){
			v = shape.getFont();
			if(v){ copy.font = v; }
		}
	},


	// static
	stdShapeFilter: function(filter) {
		return function (shape,getChildren) {
				if(filter(shape)) {
					var copy = {};
					this._shapeCopy(copy,shape,getChildren);
					return copy;
				} else {
					return null;
				}
			};
	},
	
	// static
	overviewFilter0: function( object ) {
		return true;
	},

	// static
	overviewFilter1: function( object ) {
		var d = dojo, g = dojox.gfx, gu = g.utils;
		var t = {}, v, isSurface = object instanceof g.Surface;
		if(isSurface || object instanceof g.Group){
			return true;
		} else {
			return object.getShape().type=="rect";
		}
	},
	
	// static
	overviewFilter2: function( object ) {
		var d = dojo, g = dojox.gfx, gu = g.utils;
		var t = {}, v, isSurface = object instanceof g.Surface;
		if(isSurface || object instanceof g.Group){
			return true;
		} else {
			return object.getShape().type=="polyline";
		}
	},

	// static
	overviewTransform3: function(shape,getChildren) {
		var d = dojo, g = dojox.gfx, gu = g.utils;
		var isSurface = shape instanceof g.Surface;
		var isGroup   = shape instanceof g.Group;
		if(isSurface || isGroup || shape.getShape().type=="rect" ){
			var copy = {};
			this._shapeCopy(copy,shape,getChildren);
			if(shape.getShape().type=="rect") {
				copy.fill = {r:0,g:0,b:0,a:1}; // build fill by hand because destination objects are empty after "serialization"
			}
			return copy;
		} else {
			return null;
		}
	},
	
	constructor: function( /*ibm_ilog.diagram.widget.Diagram*/ diagram ) {
		this._diagram = diagram;
	},

	render: function( /*dojox.gfx.Group*/ output ) {

		var nodefilter = nodefilter || dojo.hitch(this,this.overviewTransform3);
		
		var graphJson = this._transformSerialize(this._diagram.getGraph(),nodefilter);
		
		dojox.gfx.utils.deserialize(output, graphJson);
		
	}
});

})();