/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
( function() {

dojo.provide("rmpw.widgets.palettes.TextPalette");

dojo.require("dijit.form.Select");

var _SELECTBOX_STYLING = {width: "140px"};

dojo.declare( "rmpw.widgets.palettes.TextPalette", [dijit._Widget,dijit._Templated], {
	
	widgetsInTemplate: true,
	
	DEFAULT_FAMILY: "San Serif",
	DEFAULT_SIZE: "10pt",
	DEFAULT_STYLE: "Normal",
	DEFAULT_WEIGHT: "Normal",
	
	family: this.DEFAULT_FAMILY,
	weight: this.DEFAULT_WEIGHT,
	size: this.DEFAULT_SIZE,
	style: this.DEFAULT_STYLE,

    templateString: '<div class="dijitInline dijitColorPalette" data-dojo-attach-point="shell">' + 
                        '<div class="dijitColorPaletteInner" data-dojo-attach-point="divNode">' + 
                            '<div data-dojo-type="dijit.layout.ContentPane" doLayout="false" style="font-size:8pt;">' + 
                            	'<table>' +
	                            	'<tr>' +
		                                '<td>Font Family:</td>'+
		                                '<td>'+
		                                    '<select data-dojo-attach-point="familyNode" data-dojo-type="dijit.form.Select" value="sans-serif" >' +
		                                        '<option value="serif">Serif</option>' +
		                                        '<option value="sans-serif" selected="true">Sans Serif</option>' +
		                                    '</select>' +
		                                '</td>' +
		                            '</tr>' +
	                                '<tr>' +
		                                '<td >Font Style:</td>' + 
		                                '<td>' +
		                                    '<select data-dojo-attach-point="styleNode" data-dojo-type="dijit.form.Select" value="normal">' +
		                                        '<option value="normal" selected="true">Normal</option>' +
		                                        '<option value="italic">Italic</option>' +
		                                        '<option value="oblique">Oblique</option>' +
		                                    '</select>' +
		                                '</td>' +
	                                '</tr>' +
	                                '<tr>' +
		                                '<td >Font Weight:</td>' +
		                                '<td>' +
		                                    '<select data-dojo-attach-point="weightNode" data-dojo-type="dijit.form.Select" value="normal" >' +
		                                        '<option value="normal" selected="true">Normal</option>' +
		                                        '<option value="bold">Bold</option>' +
		                                    '</select>' +
		                                '</td>' +
		                            '</tr>' +
		                            '<tr>' +
		                                '<td >Font Size:</td>' +
		                                '<td>' +
		                                    '<select data-dojo-attach-point="sizeNode" data-dojo-type="dijit.form.Select" value="12pt" >' +
		                                        '<option value="8pt">8pt</option>' +
		                                        '<option value="10pt">10pt</option>' +
		                                        '<option value="12pt" selected="true">12pt</option>' +
		                                        '<option value="14pt">14pt</option>' +
		                                        '<option value="16pt">16pt</option>' +
		                                        '<option value="20pt">20pt</option>' +
		                                        '<option value="30pt">30pt</option>' +
		                                        '<option value="40pt">40pt</option>' +
		                                        '<option value="50pt">50pt</option>' +
		                                    '</select>' +
		                                '</td>' +
		                            '</tr>' +
		                        '</table>' +
                                '<div data-dojo-attach-point="buttonNode" style="float:right;padding-top:5px;padding-right:5px;font-size:7pt">' +
                                '</div>' +
                            '</div>' +
                        '</div>' + 
                    '</div>',

    postCreate: function() {

        this.inherited(arguments);
        
        this.familyNode.set("style", _SELECTBOX_STYLING);
        this.styleNode.set("style", _SELECTBOX_STYLING);
        this.weightNode.set("style", _SELECTBOX_STYLING);
        this.sizeNode.set("style", _SELECTBOX_STYLING);

        this.ok = new dijit.form.Button({
            label : "OK",
            onClick : dojo.hitch(this, "setStyles")
        });

        this.buttonNode.appendChild(this.ok.domNode);

        this.cancel = new dijit.form.Button({
            label : "Cancel",
            onClick : dojo.hitch(this, "hide")
        });

        this.buttonNode.appendChild(this.cancel.domNode);
    }, 
    
    hide: function() {
        dojo.style(this.domNode, {
            display : "none"
        });
    }, 
    
    setStyles: function() {

        this.family = this.familyNode.value;
        this.weight = this.weightNode.value;
        this.style = this.styleNode.value;
        this.size = this.sizeNode.value;
        this.hide();
    },

	getFontObject: function(){
		var fontObject = { 
			family: this.family, 
			weight: this.weight, 
			style: this.style, 
			size: this.size 
		};
		return fontObject;
	}

});

}());
