/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("rmps.app.pickers.internal.QueryPicker");

dojo.require("rmps.core.querymodel.QueryModelClient");
dojo.require("rmps.app.pickers.internal.ContextPicker");

/**
 * An OSLC style delegated selection dialog for selecting DM queries.
 */
dojo.declare("rmps.app.pickers.internal.QueryPicker", [rmps.app.pickers.internal.ContextPicker], {
	
	/**
	 * Overridden from superclass.  Fetches queries for the given project ID.
	 */
	fetchContexts: function(projectId) {
		var def = rmps.core.querymodel.QueryModelClient.getQueryModels(this.projectId); 
		//TODO filter and sort this list?
		def.addCallback(this, function(queries){
			/**The baseline objects returned by the client already have the appropriate format,
			 * so just return them as-is.
			 */
			return queries;
		});
		return def;
	}
	
});
})();