/*******************************************************************************
 * Licensed Materials - Property of IBM 
 * Copyright IBM Corp. 2010, 2011. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("rmpw.diagrams.layout.client.routers.MultiValueMap");

dojo.require("rmpw.diagrams.layout.client.util.ArrayList");
dojo.require("rmpw.diagrams.layout.client.util.HashMap");

dojo.declare("rmpw.diagrams.layout.client.routers.MultiValueMap", null, {
	constructor: function() {
		this.map = $HashMap(new HashMap());
	},

	get: function (key) {
		var v, value;
		value = $get(this.map, key);
		if (value == null)
			return null;
		if (value != null && canCast(value.typeId$, 12))
			return dynamicCast(value, 12);
		v = $ArrayList_0(new ArrayList(), 1);
		setCheck(v.array, v.size++, value);
		return v;
	},

	put: function (key, value){
		var existingValues, v;
		existingValues = $get(this.map, key);
		if (existingValues == null) {
			$put(this.map, key, value);
			return;
		}
		if (existingValues != null && canCast(existingValues.typeId$, 12)) {
			v = dynamicCast(existingValues, 12);
			if ($indexOf(v, value, 0) == -1)
				setCheck(v.array, v.size++, value);
			return;
		}
		if ((existingValues == null?null:existingValues) !== (value == null?null:value)) {
			v = $ArrayList_0(new ArrayList(), 2);
			setCheck(v.array, v.size++, existingValues);
			setCheck(v.array, v.size++, value);
			$put(this.map, key, v);
		}
	},

	remove: function (key, value){
		var existingValues, result, v;
		existingValues = $get(this.map, key);
		if (existingValues != null) {
			if (existingValues != null && canCast(existingValues.typeId$, 12)) {
				v = dynamicCast(existingValues, 12);
				result = $indexOf(v, value, 0);
				if (result == -1)
					return -1;
				$remove_2(v, result);
				if (v.size == 0)
					$remove_0(this.map, key);
				return result;
			}
			if ($remove_0(this.map, key) != null)
				return 0;
		}
		return -1;
	},

	removeValue: function (value_0){
		var current, iter, outerIter, value;
		outerIter = $AbstractHashMap$EntrySetIterator(new AbstractHashMap$EntrySetIterator(), $values(this.map).val$entrySet.this$0);
		iter = $AbstractMap$2$1(new AbstractMap$2$1(), outerIter);
		while ($hasNext(iter.val$outerIter.iter)) {
			value = $next(iter.val$outerIter).getValue();
			current = value;
			if (equals__devirtual$(value_0, current)) {
				$remove(iter.val$outerIter);
				return value_0;
			}
			else if (current != null && canCast(current.typeId$, 14)) {
				if (dynamicCast(current, 14).remove_1(value_0)) {
					if (dynamicCast(current, 14).isEmpty())
						$remove(iter.val$outerIter);
					return value_0;
				}
			}
		}
		return null;
	}
});