dojo.provide('ibm_ilog.graphlayout.shortlink._CombinatorialOptimization');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');
dojo.require('ibm_ilog.graphlayout.shortlink.ShortLinkLayout');

dojo.declare('ibm_ilog.graphlayout.shortlink._CombinatorialOptimization', null, 
{
  // summary:
  //		A generic interface for combinatorial optimization algorithms. 
  // description:
  //		A generic interface for combinatorial optimization algorithms. 
  //		
  // tags:
  //		extension
  
  _variables: null,

  _variants: null,

  constructor : function(variables)
  {
    // summary:
    //		An array of integer values that represent the current choice for
    //		each  decision variable.
    
    if (variables == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.shortlink.ShortLinkLayout, "graphlayout.expert.message.6600E");
    }

    this._variables = variables;
    this._variants = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(this._variables.length, 0);
  },
  
  optimize : function()
  {
    // summary:
    //		Performs the combinatorial optimization.
    },
  
  setVariant : function(indexVariable, variant)
  {
    // summary:
    //		Called from time to time when a step of the optimization has been
    //		performed. 
    // description:
    //		Called from time to time when a step of the optimization has been
    //		performed. 
    //		The default implementation does nothing. You can  override this
    //		method in order to notify your layout algorithm (see
    //		GraphLayout.layoutStepPerformed()).
    // tags:
    //		protected
    
    this._variants[indexVariable] = variant;
  },

  applyVariant : function(variable, variableIndex, variant)
  {
    // summary:
    //		Applies a variant.  
    // returns:
    //		true if the variant can be applied, false otherwise
    // tags:
    //		protected
    },
  
  getVariant : function(indexVariable)
  {
    return this._variants[indexVariable]; // int
  },

  getVariantsCount : function(variable)
  {},
  
  getCost : function(variable)
  {
    // summary:
    //		Returns the cost associated to a variable.
    // tags:
    //		protected
    },
  
  isBetterVariant : function(variable, variant1, cost1, variant2, cost2)
  {
    // summary:
    //		Returns true if the variant1 with cost1 is preferred to variant2
    //		with cost2 for variable. 
    // description:
    //		Returns true if the variant1 with cost1 is preferred to variant2
    //		with cost2 for variable. 
    //		Returns false otherwise. The default implementation returns true if
    //		cost1 < cost2 (strictly).
    // tags:
    //		protected
    
    return cost1 < cost2; // Boolean
  },

  isOptimalCost : function(cost)
  {
    // summary:
    //		Returns true if cost is the minimum cost.
    // tags:
    //		protected
    
    return cost <= 0; // Boolean
  }

}
);
