dojo.provide('ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.Point');
dojo.require('ibm_ilog.graphlayout.internalutil.QuickSort');
dojo.require('ibm_ilog.graphlayout.shortlink._LinkShapeProducer');
dojo.require('ibm_ilog.graphlayout.shortlink._LinkShapeType');

dojo.declare('ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer', ibm_ilog.graphlayout.shortlink._LinkShapeProducer, 
{
  // summary:
  //		A class that is used to produce candidate direct-link shapes for the
  //		links. 
  // description:
  //		A class that is used to produce candidate direct-link shapes for the
  //		links. 
  //		This class is used by the link layout algorithm.  
  // tags:
  //		private
  
  _linkOrderSort : null,

  constructor : function(layout)
  {
    this._linkOrderSort = new ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.LinkOrderSort();
  },
  
  getMaxNumberOfBends : function()
  {
    // summary:
    //		Returns the maximum number of bends.
    // tags:
    //		private
    
    return 3; // int
  },

  getBypassDistance : function(linkData, globalBypassDistance)
  {
    // summary:
    //		Computes the bypass distance to be used for a particular link. 
    // description:
    //		Computes the bypass distance to be used for a particular link. 
    //		The default implementation from the base class adds the link width
    //		to the global bypass distance. But for direct links we get better
    //		results without adding the link width. Indeed, an increased
    //		(sometimes overestimated) bypass dist means an increased risk to get
    //		orthogonal shapes (which are used in direct link style for
    //		overlapping nodes), which are not pleasant in this style because of
    //		the mix of direct and orthogonal shapes.
    // tags:
    //		protected
    
    return globalBypassDistance; // Number
  },

  getTopToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.TOP_TOP_SIDE_ARRAY; // Array
  },

  getTopToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.TOP_BOTTOM_SIDE_ARRAY; // Array
  },

  getTopToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.TOP_LEFT_SIDE_OVERLAP_ARRAY : ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.TOP_LEFT_SIDE_ARRAY); // Array
  },

  getTopToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.TOP_RIGHT_SIDE_OVERLAP_ARRAY : ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.TOP_RIGHT_SIDE_ARRAY); // Array
  },

  getBottomToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.BOTTOM_TOP_SIDE_ARRAY; // Array
  },

  getBottomToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.BOTTOM_BOTTOM_SIDE_ARRAY; // Array
  },

  getBottomToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.BOTTOM_LEFT_SIDE_OVERLAP_ARRAY : ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.BOTTOM_LEFT_SIDE_ARRAY); // Array
  },

  getBottomToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.BOTTOM_RIGHT_SIDE_OVERLAP_ARRAY : ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.BOTTOM_RIGHT_SIDE_ARRAY); // Array
  },

  getLeftToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.LEFT_TOP_SIDE_OVERLAP_ARRAY : ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.LEFT_TOP_SIDE_ARRAY); // Array
  },

  getLeftToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.LEFT_BOTTOM_SIDE_OVERLAP_ARRAY : ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.LEFT_BOTTOM_SIDE_ARRAY); // Array
  },

  getLeftToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.LEFT_LEFT_SIDE_ARRAY; // Array
  },

  getLeftToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.LEFT_RIGHT_SIDE_ARRAY; // Array
  },

  getRightToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.RIGHT_TOP_SIDE_OVERLAP_ARRAY : ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.RIGHT_TOP_SIDE_ARRAY); // Array
  },

  getRightToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.RIGHT_BOTTOM_SIDE_OVERLAP_ARRAY : ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.RIGHT_BOTTOM_SIDE_ARRAY); // Array
  },

  getRightToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.RIGHT_LEFT_SIDE_ARRAY; // Array
  },

  getRightToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.RIGHT_RIGHT_SIDE_ARRAY; // Array
  },

  getAllQuasiSelfInterGraphLinkShapeTypes : function()
  {
    // summary:
    //		Returns all the shape types for quasi-self-intergraph-links. 
    // description:
    //		Returns all the shape types for quasi-self-intergraph-links. 
    //		Used Only when the node side filtering or side-constraints have
    //		rejected all the shapes obtained by the fine-grain choice depending
    //		on the relative position of the end-nodes.
    // tags:
    //		protected
    
    return ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.ALL_QUASI_SELF_INTERGRAPH_LINK_TYPES; // Array
  },

  getFromBottomLeftToTopRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		Returns an array of shape types and computes the link region. 
    // description:
    //		Returns an array of shape types and computes the link region. 
    //		The selection of shapes depends on the relative position of the
    //		nodes and eventually on various settings. ----- -----------|   | /  
    //		        | T | /          --|   | |         /  ----- |        /    |
    //		| | ------------- | | |    /        / -----  /      / |   |--    / |
    //		F |---/ |   | -----
    // tags:
    //		protected
    
    return ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.BOTTOM_LEFT_TO_TOP_RIGHT_POSITION_ARRAY; // Array
  },

  getFromTopLeftToBottomRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | F | ----- ----- | T | -----
    // tags:
    //		protected
    
    return ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.TOP_LEFT_TO_BOTTOM_RIGHT_POSITION_ARRAY; // Array
  },

  getFromLeftToRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		-----   ----- | F |   | T | -----   -----
    // tags:
    //		protected
    
    return ((toRect.x - 2 * bypassDistance > fromRect.x + fromRect.width) ? ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.LEFT_TO_RIGHT_POSITION_ARRAY : ibm_ilog.graphlayout.shortlink.
        _DirectLinkShapeProducer.CLOSE_LEFT_TO_RIGHT_POSITION_ARRAY); // Array
  },

  getFromBottomRightToTopLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | T | ----- ----- | F | -----
    // tags:
    //		protected
    
    return ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.BOTTOM_RIGHT_TO_TOP_LEFT_POSITION_ARRAY; // Array
  },

  getFromTopRightToBottomLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | F | ----- ----- | T | -----
    // tags:
    //		protected
    
    return ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.TOP_RIGHT_TO_BOTTOM_LEFT_POSITION_ARRAY; // Array
  },

  getFromRightToLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		-----   ----- | T |   | F | -----   -----
    // tags:
    //		protected
    
    return ((fromRect.x - 2 * bypassDistance > toRect.x + toRect.width) ? ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.RIGHT_TO_LEFT_POSITION_ARRAY : ibm_ilog.graphlayout.shortlink.
        _DirectLinkShapeProducer.CLOSE_RIGHT_TO_LEFT_POSITION_ARRAY); // Array
  },

  getFromBottomToTopPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | T | ----- ----- | F | -----
    // tags:
    //		protected
    
    return ((toRect.y + toRect.height + 2 * bypassDistance < fromRect.y) ? ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.BOTTOM_TO_TOP_POSITION_ARRAY : ibm_ilog.graphlayout.shortlink.
        _DirectLinkShapeProducer.CLOSE_BOTTOM_TO_TOP_POSITION_ARRAY); // Array
  },

  getFromTopToBottomPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | F | ----- ----- | T | -----
    // tags:
    //		protected
    
    return ((toRect.y - 2 * bypassDistance > fromRect.y + fromRect.height) ? ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.TOP_TO_BOTTOM_POSITION_ARRAY : ibm_ilog.graphlayout.shortlink.
        _DirectLinkShapeProducer.CLOSE_TOP_TO_BOTTOM_POSITION_ARRAY); // Array
  },

  sortShapeTypes : function(shapeTypes, linkData, minFinalSegmentLength, copyBeforeSort)
  {
    // summary:
    //		Overridden implementation of the method from LinkShapeProducer
    //		(which does nothing).
    // tags:
    //		protected
    
    var shapeTypesToSort = (copyBeforeSort ? this.copyShapeTypes(shapeTypes, shapeTypes.length) : shapeTypes);
    this._linkOrderSort.sort(shapeTypesToSort, linkData, minFinalSegmentLength);
    return shapeTypesToSort; // Array
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer,
{
  TOP_TOP_SIDE_ARRAY : null,
  TOP_BOTTOM_SIDE_ARRAY : null,
  TOP_LEFT_SIDE_ARRAY : null,
  TOP_RIGHT_SIDE_ARRAY : null,
  BOTTOM_TOP_SIDE_ARRAY : null,
  BOTTOM_BOTTOM_SIDE_ARRAY : null,
  BOTTOM_LEFT_SIDE_ARRAY : null,
  BOTTOM_RIGHT_SIDE_ARRAY : null,
  LEFT_TOP_SIDE_ARRAY : null,
  LEFT_BOTTOM_SIDE_ARRAY : null,
  LEFT_LEFT_SIDE_ARRAY : null,
  LEFT_RIGHT_SIDE_ARRAY : null,
  RIGHT_TOP_SIDE_ARRAY : null,
  RIGHT_BOTTOM_SIDE_ARRAY : null,
  RIGHT_LEFT_SIDE_ARRAY : null,
  RIGHT_RIGHT_SIDE_ARRAY : null,

  TOP_LEFT_SIDE_OVERLAP_ARRAY : null,
  TOP_RIGHT_SIDE_OVERLAP_ARRAY : null,
  BOTTOM_LEFT_SIDE_OVERLAP_ARRAY : null,
  BOTTOM_RIGHT_SIDE_OVERLAP_ARRAY : null,
  LEFT_TOP_SIDE_OVERLAP_ARRAY : null,
  LEFT_BOTTOM_SIDE_OVERLAP_ARRAY : null,
  RIGHT_TOP_SIDE_OVERLAP_ARRAY : null,
  RIGHT_BOTTOM_SIDE_OVERLAP_ARRAY : null,

  BOTTOM_LEFT_TO_TOP_RIGHT_POSITION_ARRAY : null,
  TOP_LEFT_TO_BOTTOM_RIGHT_POSITION_ARRAY : null,
  LEFT_TO_RIGHT_POSITION_ARRAY : null,
  CLOSE_LEFT_TO_RIGHT_POSITION_ARRAY : null,
  BOTTOM_RIGHT_TO_TOP_LEFT_POSITION_ARRAY : null,
  TOP_RIGHT_TO_BOTTOM_LEFT_POSITION_ARRAY : null,
  RIGHT_TO_LEFT_POSITION_ARRAY : null,
  CLOSE_RIGHT_TO_LEFT_POSITION_ARRAY : null,
  BOTTOM_TO_TOP_POSITION_ARRAY : null,
  CLOSE_BOTTOM_TO_TOP_POSITION_ARRAY : null,
  TOP_TO_BOTTOM_POSITION_ARRAY : null,
  CLOSE_TOP_TO_BOTTOM_POSITION_ARRAY : null,

  ALL_QUASI_SELF_INTERGRAPH_LINK_TYPES : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeProducer._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeProducer._fields_init(c);
    
    c.TOP_TOP_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTT.instance ];
    c.TOP_BOTTOM_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTB.instance ];
    c.TOP_LEFT_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTL.instance ];
    c.TOP_RIGHT_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTR.instance ];
    c.BOTTOM_TOP_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBT.instance ];
    c.BOTTOM_BOTTOM_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBB.instance ];
    c.BOTTOM_LEFT_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBL.instance ];
    c.BOTTOM_RIGHT_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBR.instance ];
    c.LEFT_TOP_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLT.instance ];
    c.LEFT_BOTTOM_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLB.instance ];
    c.LEFT_LEFT_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLL.instance ];
    c.LEFT_RIGHT_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLR.instance ];
    c.RIGHT_TOP_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRT.instance ];
    c.RIGHT_BOTTOM_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRB.instance ];
    c.RIGHT_LEFT_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRL.instance ];
    c.RIGHT_RIGHT_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRR.instance ];
    c.TOP_LEFT_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL_OVERLAP.instance ];
    c.TOP_RIGHT_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR_OVERLAP.instance ];
    c.BOTTOM_LEFT_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL_OVERLAP.instance ];
    c.BOTTOM_RIGHT_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR_OVERLAP.instance ];
    c.LEFT_TOP_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT_OVERLAP.instance ];
    c.LEFT_BOTTOM_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB_OVERLAP.instance ];
    c.RIGHT_TOP_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT_OVERLAP.instance ];
    c.RIGHT_BOTTOM_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB_OVERLAP.instance ];
    c.BOTTOM_LEFT_TO_TOP_RIGHT_POSITION_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRL.instance
     ];
    c.TOP_LEFT_TO_BOTTOM_RIGHT_POSITION_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBL.instance
     ];
    c.LEFT_TO_RIGHT_POSITION_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBB.instance
     ];
    c.CLOSE_LEFT_TO_RIGHT_POSITION_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTT.instance, ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBB.instance ];
    c.BOTTOM_RIGHT_TO_TOP_LEFT_POSITION_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLB.instance
     ];
    c.TOP_RIGHT_TO_BOTTOM_LEFT_POSITION_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLR.instance
     ];
    c.RIGHT_TO_LEFT_POSITION_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBB.instance
     ];
    c.CLOSE_RIGHT_TO_LEFT_POSITION_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTT.instance, ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBB.instance ];
    c.BOTTOM_TO_TOP_POSITION_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRR.instance
     ];
    c.CLOSE_BOTTOM_TO_TOP_POSITION_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLL.instance, ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRR.instance ];
    c.TOP_TO_BOTTOM_POSITION_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRR.instance
     ];
    c.CLOSE_TOP_TO_BOTTOM_POSITION_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLL.instance, ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRR.instance ];
    c.ALL_QUASI_SELF_INTERGRAPH_LINK_TYPES = 
    [
      
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLR.instance
     ];
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer.LinkOrderSort', ibm_ilog.graphlayout.internalutil.QuickSort, 
{

  constructor : function()
  {
    
  this._shapeTypes = null;
  this._lengthArray = null;
  this._p1 = new ibm_ilog.graphlayout.internalutil.Point();
  this._p2 = new ibm_ilog.graphlayout.internalutil.Point();},
  _shapeTypes : null,

  _lengthArray : null,

  _p1 : null,
  _p2 : null,

  sort : function(shapeTypes, linkData, minFinalSegmentLength)
  {
    // summary:
    // tags:
    //		private
    
    if (shapeTypes == null) {
      return;
    }
    var nShapes = shapeTypes.length;
    if (nShapes < 2) {
      return;
    }
    this._shapeTypes = shapeTypes;
    if (this._lengthArray == null || this._lengthArray.length < nShapes) {
      this._lengthArray = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(nShapes, 0);
    }
    var fromSide;
    var toSide;
    var shapeType;
    var fromRect = linkData.getFromNode().getLinkConnectionRect();
    var toRect = linkData.getToNode().getLinkConnectionRect();

    for (var i = 0; i < nShapes; i++)
    {
      shapeType = shapeTypes[i];

      fromSide = shapeType.getFromNodeSide(linkData);
      toSide = shapeType.getToNodeSide(linkData);

      fromSide.moveToDefaultConnectionPoint(this._p1, fromRect);
      fromSide.translateOutside(this._p1, minFinalSegmentLength);
      toSide.moveToDefaultConnectionPoint(this._p2, toRect);
      toSide.translateOutside(this._p2, minFinalSegmentLength);
      this._lengthArray[i] = (this._p2.x - this._p1.x) * (this._p2.x - this._p1.x) + (this._p2.y - this._p1.y) * (this._p2.y - this._p1.y);
    }

    this.inherited("sort", arguments, [nShapes]);
  },

  compare : function(loc1, loc2)
  {
    // summary:
    //		Compare the elements. 
    // description:
    //		Compare the elements. 
    //		Currently, the criteria used for sorting the shapes is the length of
    //		the intermediate segment of the link. This gives fairly close
    //		results in comparison with using an angle criteria.
    // tags:
    //		private
    
    if (this._lengthArray[loc1] == this._lengthArray[loc2]) {
      return 0; // int
    }
    else if (this._lengthArray[loc1] < this._lengthArray[loc2]) {
      return -1; // int
    }
    else {
      return 1; // int
    }
  },

  swap : function(loc1, loc2)
  {
    // summary:
    //		Swap two elements.
    // tags:
    //		private
    
    var shapeType = this._shapeTypes[loc1];
    this._shapeTypes[loc1] = this._shapeTypes[loc2];
    this._shapeTypes[loc2] = shapeType;

    var length = this._lengthArray[loc1];
    this._lengthArray[loc1] = this._lengthArray[loc2];
    this._lengthArray[loc2] = length;
  }

}
);

(function(){ ibm_ilog.graphlayout.shortlink._DirectLinkShapeProducer._fields_init(); })();
