dojo.provide('ibm_ilog.graphlayout.shortlink._IncidentLinksSorter');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.QuickSort');
dojo.require('ibm_ilog.graphlayout.shortlink.ShortLinkLayout');
dojo.require('ibm_ilog.graphlayout.Direction');

dojo.declare('ibm_ilog.graphlayout.shortlink._IncidentLinksSorter', ibm_ilog.graphlayout.internalutil.QuickSort, 
{
  // summary:
  //		This class is used to sort the links incident to a node. 
  // description:
  //		This class is used to sort the links incident to a node. 
  //		A layout instance uses only one instance of class for each link
  //		style.   
  // tags:
  //		extension
  
  _vectLinks: null,

  _node: null,

  _side: null,

  _layout: null,

  constructor : function(layout)
  {
    this._layout = layout;
  },
  
  clean : function()
  {
    // summary:
    //		Cleans the data stored by this class.
    // tags:
    //		private
    
    this._side = null;
    this._vectLinks = null;
    this._node = null;
  },

  sort : function(vectLinks, node, side, bundleMode)
  {
    // summary:
    //		Performs the sort.
    
    if (bundleMode != ibm_ilog.graphlayout.shortlink.ShortLinkLayout.NO_BUNDLE)
    {
      var nLinks = (vectLinks != null ? vectLinks.length : 0);

      if (nLinks > 0)
      {
        this._vectLinks = vectLinks;
        this._node = node;
        this._side = side;
        this.inherited("sort", arguments, [nLinks]);
      }
    }
  },

  compare : function(loc1, loc2)
  {
    // summary:
    //		Compares two elements. 
    // description:
    //		Compares two elements. 
    //		Returns 0 if both elements are equal. Returns a number less than 0
    //		if the first element should come before the second element, and a
    //		number larger than 0 if the first element should come after the
    //		second element.
    // tags:
    //		protected
    
    if (this.compare1(loc1, loc2)) {
      return -1; // int
    }
    return 1; // int
  },

  compare1 : function(loc1, loc2)
  {
    // summary:
    //		Compare two elements. 
    // description:
    //		Compare two elements. 
    //		This is used when computing the order of the nodes connected to the
    //		same side of a node.
    // tags:
    //		private
    
    var link1 = this._vectLinks[loc1];
    var link2 = this._vectLinks[loc2];
    var origin1 = link1.isOrigin(this._node, this._side);
    var origin2 = link2.isOrigin(this._node, this._side);
    var connectionFixed1 = link1.isConnectionPointFixed(origin1);
    var connectionFixed2 = link2.isConnectionPointFixed(origin2);

    var position;

    if (connectionFixed1 && connectionFixed2) {
      return this._side.getTangentDelta(link1.getConnectionPoint(origin1), link2.getConnectionPoint(origin2)) <= 0; // Boolean
    }
    else if (link1.isSelfLink())
    {
      if (link1.isSameSideSelfLink()) {
        return true; // Boolean
      }
      else if (!link2.isSelfLink())
      {
        position = this._side.getSidePosition(link1.getNodeSide(!origin1).getDirection());
        if (position == ibm_ilog.graphlayout.Direction.LEFT) {
          return true; // Boolean
        }
        else if (position == ibm_ilog.graphlayout.Direction.RIGHT) {
          return false; // Boolean
        }
      }
    }
    else if (link2.isSelfLink())
    {
      if (link2.isSameSideSelfLink()) {
        return false; // Boolean
      }
      else if (!link1.isSelfLink())
      {
        position = this._side.getSidePosition(link2.getNodeSide(!origin2).getDirection());
        if (position == ibm_ilog.graphlayout.Direction.LEFT) {
          return false; // Boolean
        }
        else if (position == ibm_ilog.graphlayout.Direction.RIGHT) {
          return true; // Boolean
        }
      }
    }

    return this.compareLinks(link1, link2, origin1, origin2, this._side); // Boolean
  },

  compareLinks : function(link1, link2, origin1, origin2, nodeSide)
  {
    // summary:
    //		Compare two non-self-links that
    //		don't have (both of them) fixed connection points. 
    // description:
    //		Compare two non-self-links that don't have (both of them) fixed
    //		connection points. 
    //		This is used when computing the order of the nodes connected to the 
    //		same side of a node.
    // tags:
    //		protected
    },
  
  swap : function(loc1, loc2)
  {
    // summary:
    //		Swap two elements. 
    // description:
    //		Swap two elements. 
    //		(Method coming from the class QuickSort.)
    // tags:
    //		protected
    
    var link = this._vectLinks[loc1];
    this._vectLinks[loc1] =   this._vectLinks[loc2];
    this._vectLinks[loc2] =   link;
  }

}
);
