dojo.provide('ibm_ilog.graphlayout.shortlink._LinkLayoutBestNeighborOptimization');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');
dojo.require('ibm_ilog.graphlayout.shortlink.ShortLinkLayout');
dojo.require('ibm_ilog.graphlayout.shortlink._BestNeighborOptimization');

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkLayoutBestNeighborOptimization', ibm_ilog.graphlayout.shortlink._BestNeighborOptimization, 
{
  // summary:
  //		A specialized best neighbor algo for the link layout. 
  // description:
  //		A specialized best neighbor algo for the link layout. 
  //		
  // tags:
  //		private
  
  _graphModel: null,
  _layout: null,
  _isLinkBundlesRequired : null,

  constructor : function(layout, numberOfIterations, allowedTime, variables)
  {
    this._isLinkBundlesRequired = false;
    var msg;

    if (layout == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.shortlink.ShortLinkLayout, "graphlayout.expert.message.6616E");
    }

    this._graphModel = layout.getGraphModel();

    if (this._graphModel == null)
    {
      ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowIllegalArgExc(ibm_ilog.graphlayout.shortlink.ShortLinkLayout, "graphlayout.expert.message.6012E");
    }

    this._layout = layout;
    this._isLinkBundlesRequired = (layout.getShortLinkLayout().getLinkBundlesMode() != ibm_ilog.graphlayout.shortlink.ShortLinkLayout.NO_BUNDLE);
  },
  
  preamble:function(){
      return [arguments[3], arguments[1], arguments[2]];
  },
  variantStepPerformed : function()
  {
    this._layout.getShortLinkLayout().callLayoutStepPerformedIfNeeded();
  },

  applyVariant : function(variable, variableIndex, variant)
  {
    // summary:
    //		Applies a variant.  
    // returns:
    //		false if the variant was already applied, true otherwise
    // tags:
    //		protected
    
    if (variant == this.getVariant(variableIndex)) {
      return false; // Boolean
    }
    var linkData = variable;
    this.setVariant(variableIndex, variant);
    var shapeType = linkData.getShapeType(variant);
    if (shapeType == linkData.getCurrentShapeType()) {
      return false; // Boolean
    }
    this._layout.reshapeLink(this._graphModel, linkData, shapeType, this._isLinkBundlesRequired);

    return true; // Boolean
  },

  getCost : function(variable)
  {
    // summary:
    //		Returns the cost associated with variable.
    // tags:
    //		protected
    
    return this._layout.getLinkCost(this._graphModel, variable, false); // Number
  },

  getVariantsCount : function(variable)
  {
    return (variable).getShapeTypesCount(); // int
  },

  isBetterVariant : function(variable, variant1, cost1, variant2, cost2)
  {
    // summary:
    //		Returns true if the variant1 with cost1 is preferred to variant2
    //		with cost2 for variable. 
    // description:
    //		Returns true if the variant1 with cost1 is preferred to variant2
    //		with cost2 for variable. 
    //		Returns false otherwise. This overridden implementation adds the
    //		comparison of the number of bends in the case cost1 == cost2.
    // tags:
    //		protected
    
    if (cost1 < cost2) {
      return true; // Boolean
    }
    else if (cost1 > cost2) {
      return false; // Boolean
    }
    else
    {
      var linkData = variable;
      var shapeType1 = linkData.getShapeType(variant1);
      var shapeType2 = linkData.getShapeType(variant2);

      return shapeType1.getNumberOfBends() < shapeType2.getNumberOfBends(); // Boolean
    }
  }

}
);
