dojo.provide('ibm_ilog.graphlayout.shortlink._LinkShapeType');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.Point');

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeType', null, 
{
  // summary:
  //		A class that is used to identify the types of link shapes produced by
  //		a link shape producer. 
  // description:
  //		A class that is used to identify the types of link shapes produced by
  //		a link shape producer. 
  //		There are a lot of predefined subclasses, but note that just one
  //		instance of each one is created (they follow the singleton pattern). 
  //		
  // tags:
  //		extension
  
  constructor : function()
  {
  },
  
  restoreIntermediatePoints : function(linkData, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    // summary:
    //		Restores the intermediate points.  
    // tags:
    //		private
    
    var fromPoint = linkData.getConnectionPoint(true);
    var toPoint = linkData.getConnectionPoint(false);

    this.doComputeIntermediatePoints(linkData, fromRect, toRect, fromSide, toSide, fromPoint, toPoint, minFinalSegment);

    linkData.getLinkShape().setNumberOfPoints(this.getNumberOfBends() + 2);
  },

  computeIntermediatePoints : function(layout, linkData, minFinalSegment, reversed)
  {
    // summary:
    //		Computes the intermediate points.
    
    minFinalSegment += linkData.getLinkWidth() * 0.5;

    var fromNodeData = (reversed ? linkData.getToNode() : linkData.getFromNode());
    var toNodeData = (reversed ? linkData.getFromNode() : linkData.getToNode());

    var fromSide = linkData.getFromNodeSide();
    var toSide = linkData.getToNodeSide();

    var fromRect = layout.getTempRect1();
    var toRect = layout.getTempRect2();
    var rect = fromNodeData.getLinkConnectionRect();
    ibm_ilog.graphlayout.internalutil.TranslateUtil.reshapeRect(fromRect, rect.x, rect.y, rect.width, rect.height);
    rect = toNodeData.getLinkConnectionRect();
    ibm_ilog.graphlayout.internalutil.TranslateUtil.reshapeRect(toRect, rect.x, rect.y, rect.width, rect.height);

    var fromPoint = linkData.getConnectionPoint(!reversed);
    var toPoint = linkData.getConnectionPoint(reversed);
    if (!linkData.isFromPointFixed()) {
      fromSide.moveToDefaultConnectionPoint(fromPoint, fromRect);
    }
    if (!linkData.isToPointFixed()) {
      toSide.moveToDefaultConnectionPoint(toPoint, toRect);
    }
    if (linkData.isFromPointFixed()) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.addPoint(fromRect, fromPoint .x, fromPoint .y);
    }
    if (linkData.isToPointFixed()) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.addPoint(toRect, toPoint .x, toPoint .y);
    }
    this.restoreIntermediatePoints(linkData, fromRect, toRect, fromSide, toSide, minFinalSegment);

    fromSide.setLayoutUpToDate(false);
    toSide.setLayoutUpToDate(false);
  },

  doComputeIntermediatePoints : function(linkData, fromRect, toRect, fromSide, toSide, fromPoint, toPoint, minFinalSegment)
  {
    // summary:
    //		Computes the intermediate points. 
    // description:
    //		Computes the intermediate points. 
    //		Only called from the base class itself.  
    // tags:
    //		protected
    },
  
  getOrCreatePoint : function(bends, index)
  {
    var point = bends[index];

    if (point == null)
    {
      point = new ibm_ilog.graphlayout.internalutil.Point();
      bends[index] = point;
    }

    return point; // Point
  },

  getReversedShapeType : function()
  {
    // summary:
    //		Returns the shape type that corresponds to the reversed shape. 
    // description:
    //		Returns the shape type that corresponds to the reversed shape. 
    //		For instance, OneBendTB is the reversed shape of OneBendBT.
    },
  
  getFromNodeSide : function(linkData)
  {
    // summary:
    //		Returns the NodeSide to which the origin of the link having this
    //		shape type must be connected on nodeData (which is assumed to be its
    //		origin node).
    },
  
  getToNodeSide : function(linkData)
  {
    // summary:
    //		Returns the NodeSide to which the destination of the link having
    //		this shape type must be connected on nodeData (which is assumed to
    //		be its origin node).
    },
  
  getFromSide : function(linkData)
  {
    // summary:
    
    return this.getFromNodeSide(linkData).getSide(); // int
  },

  getToSide : function(linkData)
  {
    // summary:
    
    return this.getToNodeSide(linkData).getSide(); // int
  },

  isOrthogonal : function()
  {
    // summary:
    //		Returns true if this is an orthogonal shape and false otherwise.
    },
  
  getNumberOfBends : function()
  {
    // summary:
    //		Returns the number of bends (connection points are not counted).
    }
  
}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeType,
{

  getXMiddle : function(fromPoint, toPoint, fromRect, toRect)
  {
    var xMiddle = 0;
    if (fromRect.x > (toRect.x + toRect.width)) {
      xMiddle = (fromRect.x + toRect.x + toRect.width) * 0.5;
    }
    else if (toRect.x > (fromRect.x + fromRect.width)) {
      xMiddle = (toRect.x + fromRect.x + fromRect.width) * 0.5;
    }
    else {
      xMiddle = (fromPoint.x + toPoint.x) * 0.5;
    }
    return xMiddle; // Number
  },

  getYMiddle : function(fromPoint, toPoint, fromRect, toRect)
  {
    var yMiddle = 0;
    if (fromRect.y > (toRect.y + toRect.height)) {
      yMiddle = (fromRect.y + toRect.y + toRect.height) * 0.5;
    }
    else if (toRect.y > (fromRect.y + fromRect.height)) {
      yMiddle = (toRect.y + fromRect.y + fromRect.height) * 0.5;
    }
    else {
      yMiddle = (fromPoint.y + toPoint.y) * 0.5;
    }
    return yMiddle; // Number
  }

}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._DirectLinkShapeType', ibm_ilog.graphlayout.shortlink._LinkShapeType, 
{

  constructor : function()
  {
    
  },

  doComputeIntermediatePoints : function(linkData, fromRect, toRect, fromSide, toSide, fromPoint, toPoint, minFinalSegment)
  {
    // summary:
    //		
    // tags:
    //		protected
    
    var bends = linkData.getLinkShape().getIntermediatePoints();
    var point = this.getOrCreatePoint(bends, 0);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.setPointLocation(point, fromPoint);
    fromSide.translateOutside(point, minFinalSegment);
    point = this.getOrCreatePoint(bends, 1);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.setPointLocation(point, toPoint);
    toSide.translateOutside(point, minFinalSegment);
  },

  isOrthogonal : function()
  {
    return false; // Boolean
  },

  getNumberOfBends : function()
  {
    // summary:
    //		Returns the number of bends (connection points are not counted).
    
    return 2; // int
  }

}
);
dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTL', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTL;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTL();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTB', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTB;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTB();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTR', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTR;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTR();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRL', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRL;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRL();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRB', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRB;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRB();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBT', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBT;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBT();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBL', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBL;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBL();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBR', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBR;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBR();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRT', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRT;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRT();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLR', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLR;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLR();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLT', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLT;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLT();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLB', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLB;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLB();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTT', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return this; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTT;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTT();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBB', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return this; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBB;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBB();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRR', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return this; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRR;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRR();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLL', ibm_ilog.graphlayout.shortlink._DirectLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return this; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLL;
    if(ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._DirectLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLL();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeType', ibm_ilog.graphlayout.shortlink._LinkShapeType, 
{

  constructor : function()
  {
    
  },
  isOrthogonal : function()
  {
    return true; // Boolean
  }

}
);
dojo.declare('ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType', ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeType, 
{

  constructor : function()
  {
    
  },

  getNumberOfBends : function()
  {
    // summary:
    //		Returns the number of bends (connection points are not counted).
    
    return 1; // int
  },

  doComputeIntermediatePoints : function(linkData, fromRect, toRect, fromSide, toSide, fromPoint, toPoint, minFinalSegment)
  {
    // summary:
    //		
    // tags:
    //		protected
    
    var point = this.getOrCreatePoint(linkData.getLinkShape().getIntermediatePoints(), 0);
    fromSide.setTangentialCoord(point, fromSide.getTangentialCoord(fromPoint));
    toSide.setTangentialCoord(point, toSide.getTangentialCoord(toPoint));
  }

}
);
dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTL', ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTL;
    if(ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTL();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTR', ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTR;
    if(ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTR();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBL', ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBL;
    if(ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBL();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBR', ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBR;
    if(ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBR();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLT', ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLT;
    if(ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLT();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLB', ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLB;
    if(ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLB();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRT', ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRT;
    if(ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRT();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRB', ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRB;
    if(ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._OneBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRB();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._TwoBendLinkShapeType', ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeType, 
{

  constructor : function()
  {
    
  },

  getNumberOfBends : function()
  {
    // summary:
    //		Returns the number of bends (connection points are not counted).
    
    return 2; // int
  },

  doComputeIntermediatePoints : function(linkData, fromRect, toRect, fromSide, toSide, fromPoint, toPoint, minFinalSegment)
  {
    // summary:
    //		
    // tags:
    //		protected
    
    var bends = linkData.getLinkShape().getIntermediatePoints();
    var point0 = this.getOrCreatePoint(bends, 0);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.setPointLocation(point0, fromPoint);
    var point1 = this.getOrCreatePoint(bends, 1);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.setPointLocation(point1, toPoint);

    if (fromSide.getDirection() == toSide.getDirection())
    {
      if (fromSide.getPointRadialDelta(point0, point1) <= 0)
      {
        fromSide.translateOutside(point0, minFinalSegment);
        fromSide.copyRadialCoord(point0, point1);
      }
      else
      {
        toSide.translateOutside(point1, minFinalSegment);
        fromSide.copyRadialCoord(point1, point0);
      }
    }
    else
    {
      var coord = (fromSide.getPointRadialCoord(fromPoint) + toSide.getPointRadialCoord(toPoint)) * 0.5;
      fromSide.setRadialCoord(point0, coord);
      toSide.setRadialCoord(point1, coord);
    }
  }

}
);
dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendSameSide', ibm_ilog.graphlayout.shortlink._TwoBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return this; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  }

}
);
dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTT', ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendSameSide, 
{

  constructor : function()
  {
    
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTT;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendSameSide._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendSameSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTT();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBB', ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendSameSide, 
{

  constructor : function()
  {
    
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBB;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendSameSide._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendSameSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBB();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLL', ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendSameSide, 
{

  constructor : function()
  {
    
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLL;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendSameSide._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendSameSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLL();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRR', ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendSameSide, 
{

  constructor : function()
  {
    
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRR;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendSameSide._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendSameSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRR();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._TwoBendDifferentSide', ibm_ilog.graphlayout.shortlink._TwoBendLinkShapeType, 
{

  constructor : function()
  {
    
  }
}
);
dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBT', ibm_ilog.graphlayout.shortlink._TwoBendDifferentSide, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBT;
    if(ibm_ilog.graphlayout.shortlink._TwoBendDifferentSide._fields_init)
      ibm_ilog.graphlayout.shortlink._TwoBendDifferentSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBT();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTB', ibm_ilog.graphlayout.shortlink._TwoBendDifferentSide, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTB;
    if(ibm_ilog.graphlayout.shortlink._TwoBendDifferentSide._fields_init)
      ibm_ilog.graphlayout.shortlink._TwoBendDifferentSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTB();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRL', ibm_ilog.graphlayout.shortlink._TwoBendDifferentSide, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRL;
    if(ibm_ilog.graphlayout.shortlink._TwoBendDifferentSide._fields_init)
      ibm_ilog.graphlayout.shortlink._TwoBendDifferentSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRL();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLR', ibm_ilog.graphlayout.shortlink._TwoBendDifferentSide, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLR;
    if(ibm_ilog.graphlayout.shortlink._TwoBendDifferentSide._fields_init)
      ibm_ilog.graphlayout.shortlink._TwoBendDifferentSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLR();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType', ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeType, 
{

  constructor : function()
  {
    
  },

  getNumberOfBends : function()
  {
    // summary:
    //		Returns the number of bends (connection points are not counted).
    
    return 3; // int
  },

  isOverlapping : function()
  {
    // summary:
    //		Returns true for shapes of links connecting overlapping end-nodes. 
    // description:
    //		Returns true for shapes of links connecting overlapping end-nodes. 
    //		(Notice this
    //		isn't exactly equivalent to the overlap of the bboxes of the end-nodes - the "bypass distance" parameter is also considered.) The default implementation returns always false.
    // tags:
    //		protected
    
    return false; // Boolean
  },

  doComputeIntermediatePoints : function(linkData, fromRect, toRect, fromSide, toSide, fromPoint, toPoint, minFinalSegment)
  {
    // summary:
    //		
    // tags:
    //		protected
    
    var bends = linkData.getLinkShape().getIntermediatePoints();
    var point0 = this.getOrCreatePoint(bends, 0);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.setPointLocation(point0, fromPoint);
    var point2 = this.getOrCreatePoint(bends, 2);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.setPointLocation(point2, toPoint);

    if (linkData.isOverlapping() || this.isOverlapping())
    {
      if (fromSide.getRectRadialDelta(point0, toRect) > 0) {
        fromSide.setRadialCoord(point0, fromSide.getRectRadialCoord(toRect));
      }
      if (toSide.getRectRadialDelta(point2, fromRect) > 0) {
        toSide.setRadialCoord(point2, toSide.getRectRadialCoord(fromRect));
      }
    }

    fromSide.translateOutside(point0, minFinalSegment);
    toSide.translateOutside(point2, minFinalSegment);
    var point1 = this.getOrCreatePoint(bends, 1);

    fromSide.setRadialCoord(point1, fromSide.getPointRadialCoord(point0));
    toSide.setRadialCoord(point1, toSide.getPointRadialCoord(point2));
  }

}
);
dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT', ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT;
    if(ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT_OVERLAP', ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT_OVERLAP;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT_OVERLAP();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR', ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR;
    if(ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR_OVERLAP', ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR_OVERLAP;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR_OVERLAP();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL', ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL;
    if(ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL_OVERLAP', ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL_OVERLAP;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL_OVERLAP();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB', ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB;
    if(ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB_OVERLAP', ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB_OVERLAP;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB_OVERLAP();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR', ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR;
    if(ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR_OVERLAP', ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR_OVERLAP;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR_OVERLAP();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB', ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB;
    if(ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB_OVERLAP', ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB_OVERLAP;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB_OVERLAP();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL', ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL;
    if(ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL_OVERLAP', ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL_OVERLAP;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL_OVERLAP();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT', ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT;
    if(ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._ThreeBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT_OVERLAP', ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL_OVERLAP.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  isOverlapping : function()
  {
    return true; // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT_OVERLAP,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT_OVERLAP;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT_OVERLAP();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType', ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeType, 
{

  constructor : function()
  {
    
  },

  doComputeIntermediatePoints : function(linkData, fromRect, toRect, fromSide, toSide, fromPoint, toPoint, minFinalSegment)
  {
    // summary:
    //		
    // tags:
    //		protected
    
    var bends = linkData.getLinkShape().getIntermediatePoints();
    var point0 = this.getOrCreatePoint(bends, 0);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.setPointLocation(point0, fromPoint);
    fromSide.translateOutside(point0, minFinalSegment);
    var point3 = this.getOrCreatePoint(bends, 3);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.setPointLocation(point3, toPoint);
    toSide.translateOutside(point3, minFinalSegment);
    var point1 = this.getOrCreatePoint(bends, 1);
    var point2 = this.getOrCreatePoint(bends, 2);
    this.computePoints(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment);
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {},
  
  getNumberOfBends : function()
  {
    // summary:
    //		Returns the number of bends (connection points are not counted).
    
    return 4; // int
  }

}
);
dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBleft', ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTleft.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var xMin = Math.min(fromRect.x, toRect.x) - minFinalSegment;
    if (point0.x > point3.x) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point0, point0.x,
        Math.min(fromRect.y, toRect.y) - minFinalSegment);
    }
    else {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point3, point3.x,
        Math.max(fromRect.y + fromRect.height, toRect.y + toRect.height) + minFinalSegment);
    }
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point1, xMin, point0.y);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point2, xMin, point3.y);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBleft,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBleft;
    if(ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBleft();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTleft', ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBleft.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var xMin = Math.min(fromRect.x, toRect.x) - minFinalSegment;
    if (point0.x > point3.x) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point0, point0.x,
        Math.max(fromRect.y + fromRect.height, toRect.y + toRect.height) + minFinalSegment);
    }
    else {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point3, point3.x,
        Math.min(fromRect.y, toRect.y) - minFinalSegment);
    }
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point1, xMin, point0.y);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point2, xMin, point3.y);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTleft,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTleft;
    if(ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTleft();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBright', ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTright.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var xMax = Math.max(fromRect.x + fromRect.width, toRect.x + toRect.width) + minFinalSegment;
    if (point0.x <= point3.x) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point0, point0.x,
        Math.min(fromRect.y, toRect.y) - minFinalSegment);
    }
    else {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point3, point3.x,
        Math.max(fromRect.y + fromRect.height, toRect.y + toRect.height) + minFinalSegment);
    }
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point1, xMax, point0.y);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point2, xMax, point3.y);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBright,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBright;
    if(ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBright();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTright', ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBright.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var xMax = Math.max(fromRect.x + fromRect.width, toRect.x + toRect.width) + minFinalSegment;
    if (point0.x <= point3.x) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point0, point0.x,
        Math.max(fromRect.y + fromRect.height, toRect.y + toRect.height) + minFinalSegment);
    }
    else {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point3, point3.x,
        Math.min(fromRect.y, toRect.y) - minFinalSegment);
    }
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point1, xMax, point0.y);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point2, xMax, point3.y);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTright,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTright;
    if(ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTright();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBmiddle', ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTmiddle.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var xMiddle = ibm_ilog.graphlayout.shortlink._LinkShapeType.getXMiddle(point0, point3, fromRect, toRect);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point0, point0.x, fromRect.y - minFinalSegment);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point3, point3.x, toRect.y + toRect.height + minFinalSegment);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point1, xMiddle, point0.y);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point2, xMiddle, point3.y);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBmiddle,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBmiddle;
    if(ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBmiddle();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTmiddle', ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBmiddle.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var xMiddle = ibm_ilog.graphlayout.shortlink._LinkShapeType.getXMiddle(point0, point3, fromRect, toRect);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point0, point0.x, fromRect.y + fromRect.height + minFinalSegment);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point3, point3.x, toRect.y - minFinalSegment);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point1, xMiddle, point0.y);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point2, xMiddle, point3.y);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTmiddle,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTmiddle;
    if(ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTmiddle();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRtop', ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLtop.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var yMin = Math.min(fromRect.y, toRect.y) - minFinalSegment;
    if (point0.y <= point3.y) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point3,
        Math.max(fromRect.x + fromRect.width, toRect.x + toRect.width) + minFinalSegment, point3.y);
    }
    else {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point0, Math.min(fromRect.x, toRect.x) - minFinalSegment,
        point0.y);
    }
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point1, point0.x, yMin);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point2, point3.x, yMin);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRtop,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRtop;
    if(ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRtop();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLtop', ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRtop.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var yMin = Math.min(fromRect.y, toRect.y) - minFinalSegment;
    if (point0.y <= point3.y) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point3, Math.min(fromRect.x, toRect.x) - minFinalSegment,
        point3.y);
    }
    else {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point0,
        Math.max(fromRect.x + fromRect.width, toRect.x + toRect.width) + minFinalSegment, point0.y);
    }
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point1, point0.x, yMin);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point2, point3.x, yMin);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLtop,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLtop;
    if(ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLtop();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRbottom', ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLbottom.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var yMax = Math.max(fromRect.y + fromRect.height, toRect.y + toRect.height) + minFinalSegment;
    if (point0.y > point3.y) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point3,
        Math.max(fromRect.x + fromRect.width, toRect.x + toRect.width) + minFinalSegment, point3.y);
    }
    else {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point0, Math.min(fromRect.x, toRect.x) - minFinalSegment,
        point0.y);
    }
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point1, point0.x, yMax);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point2, point3.x, yMax);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRbottom,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRbottom;
    if(ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRbottom();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRmiddle', ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLmiddle.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var yMiddle = ibm_ilog.graphlayout.shortlink._LinkShapeType.getYMiddle(point0, point3, fromRect, toRect);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point0, fromRect.x - minFinalSegment, point0.y);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point3, toRect.x + toRect.width + minFinalSegment, point3.y);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point1, point0.x, yMiddle);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point2, point3.x, yMiddle);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRmiddle,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRmiddle;
    if(ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRmiddle();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLmiddle', ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRmiddle.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var yMiddle = ibm_ilog.graphlayout.shortlink._LinkShapeType.getYMiddle(point0, point3, fromRect, toRect);
    if (fromRect.y > (toRect.y + toRect.height)) {
      yMiddle = (fromRect.y + toRect.y + toRect.height) * 0.5;
    }
    else if (toRect.y > (fromRect.y + fromRect.height)) {
      yMiddle = (toRect.y + fromRect.y + fromRect.height) * 0.5;
    }
    else {
      yMiddle = (point0.y + point3.y) * 0.5;
    }
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point0, fromRect.x + fromRect.width + minFinalSegment, point0.y);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point3, toRect.x - minFinalSegment, point3.y);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point1, point0.x, yMiddle);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point2, point3.x, yMiddle);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLmiddle,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLmiddle;
    if(ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLmiddle();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLbottom', ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRbottom.instance; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    var yMax = Math.max(fromRect.y + fromRect.height, toRect.y + toRect.height) + minFinalSegment;
    if (point0.y > point3.y) {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point3, Math.min(fromRect.x, toRect.x) - minFinalSegment,
        point3.y);
    }
    else {
      ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point0,
        Math.max(fromRect.x + fromRect.width, toRect.x + toRect.width) + minFinalSegment, point0.y);
    }
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point1, point0.x, yMax);
    ibm_ilog.graphlayout.internalutil.TranslateUtil.movePoint(point2, point3.x, yMax);
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLbottom,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLbottom;
    if(ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init)
      ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLbottom();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide', ibm_ilog.graphlayout.shortlink._FourBendLinkShapeType, 
{

  constructor : function()
  {
    
  },
  getReversedShapeType : function()
  {
    return this; // ibm_ilog.graphlayout.shortlink._LinkShapeType
  },

  computePoints : function(point0, point1, point2, point3, fromRect, toRect, fromSide, toSide, minFinalSegment)
  {
    fromSide.setRadialCoord(point1, fromSide.getPointRadialCoord(point0));
    fromSide.setRadialCoord(point2, fromSide.getPointRadialCoord(point3));
    var upperRect;
    var upperPoint;
    var bottomPoint;

    if (fromSide.getPointRadialDelta(point0, point3) >= 0)
    {
      upperRect = toRect;
      upperPoint = point2;
      bottomPoint = point1;
    }
    else
    {
      upperRect = fromRect;
      upperPoint = point1;
      bottomPoint = point2;
    }

    fromSide.setTangentialCoord(upperPoint, ((this.isLeft() ? (fromSide.getMinTangentialCoord(upperRect) - minFinalSegment) : (fromSide.getMaxTangentialCoord(upperRect) + minFinalSegment))));
    fromSide.setTangentialCoord(bottomPoint, fromSide.getTangentialCoord(upperPoint));
  },

  isLeft : function()
  {}
  
}
);
dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTTleft', ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return true; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTTleft,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTTleft;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTTleft();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTTright', ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return false; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getTopSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTTright,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTTright;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTTright();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBBleft', ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return true; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBBleft,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBBleft;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBBleft();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBBright', ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return false; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getBottomSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBBright,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBBright;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBBright();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLLleft', ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return true; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLLleft,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLLleft;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLLleft();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLLright', ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return false; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getLeftSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLLright,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLLright;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLLright();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRRleft', ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return true; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRRleft,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRRleft;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRRleft();
  }
  
}
);

dojo.declare('ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRRright', ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide, 
{

  constructor : function()
  {
    
  },
  isLeft : function()
  {
    return false; // Boolean
  },

  getFromNodeSide : function(linkData)
  {
    return linkData.getFromNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkOrigin()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  },

  getToNodeSide : function(linkData)
  {
    return linkData.getToNode().getRightSide(true, linkData.isQuasiSelfInterGraphLinkDestination()); // ibm_ilog.graphlayout.shortlink._SLNodeSide
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRRright,
{
  instance : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRRright;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendSameSide._fields_init(c);
    
    c.instance = new ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRRright();
  }
  
}
);

(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRRright._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRRleft._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLLright._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLLleft._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBBright._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBBleft._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTTright._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTTleft._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLbottom._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLmiddle._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRmiddle._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRbottom._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLtop._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRtop._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTmiddle._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBmiddle._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTright._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBright._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTleft._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBleft._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT_OVERLAP._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL_OVERLAP._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB_OVERLAP._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR_OVERLAP._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB_OVERLAP._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL_OVERLAP._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR_OVERLAP._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT_OVERLAP._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLR._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRL._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTB._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBT._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRR._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLL._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBB._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTT._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRB._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRT._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLB._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLT._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBR._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBL._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTR._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTL._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLL._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRR._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBB._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTT._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLB._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLT._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectLR._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRT._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBR._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBL._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectBT._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRB._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectRL._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTR._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTB._fields_init(); })();
(function(){ ibm_ilog.graphlayout.shortlink._LinkShapeTypeDirectTL._fields_init(); })();
