dojo.provide('ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.LogResUtil');
dojo.require('ibm_ilog.graphlayout.shortlink.ShortLinkLayout');
dojo.require('ibm_ilog.graphlayout.shortlink._LinkShapeProducer');
dojo.require('ibm_ilog.graphlayout.shortlink._LinkShapeType');
dojo.require('ibm_ilog.graphlayout.shortlink._OrthoWith4BendsPositionArrays');
dojo.require('ibm_ilog.graphlayout.shortlink._OrthoWithout4BendsPositionArrays');
dojo.require('ibm_ilog.graphlayout.Direction');

dojo.declare('ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer', ibm_ilog.graphlayout.shortlink._LinkShapeProducer, 
{
  // summary:
  //		A class that is used to produce candidate shapes for the links. 
  // description:
  //		A class that is used to produce candidate shapes for the links. 
  //		This class is used by the short link layout algorithm.  
  // tags:
  //		private
  
  constructor : function(layout)
  {
  },
  
  getMaxNumberOfBends : function()
  {
    // summary:
    //		Returns the maximum number of bends that the producer can produce. 
    // description:
    //		Returns the maximum number of bends that the producer can produce. 
    //		The default implementation returns always 3. You can override this
    //		method if your subclass supports more bends.
    // tags:
    //		private
    
    return ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.MAX_NUMBER_OF_BENDS; // int
  },

  getTopToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.TOP_TOP_SIDE_ARRAY; // Array
  },

  getTopToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ((fromRect.y - toRect.y - toRect.height > 2 * bypassDistance)
      ? ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.TOP_BOTTOM_SIDE_2and4BENDS_ARRAY
      : ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.TOP_BOTTOM_SIDE_4BENDS_ARRAY); // Array
  },

  getTopToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.TOP_LEFT_SIDE_OVERLAP_ARRAY : ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.TOP_LEFT_SIDE_ARRAY); // Array
  },

  getTopToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping
      ? ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.TOP_RIGHT_SIDE_OVERLAP_ARRAY
      : ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.TOP_RIGHT_SIDE_ARRAY); // Array
  },

  getBottomToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ((toRect.y - fromRect.y - fromRect.height > 2 * bypassDistance)
      ? ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.BOTTOM_TOP_SIDE_2and4BENDS_ARRAY
      : ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.BOTTOM_TOP_SIDE_4BENDS_ARRAY); // Array
  },

  getBottomToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.BOTTOM_BOTTOM_SIDE_ARRAY; // Array
  },

  getBottomToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping
      ? ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.BOTTOM_LEFT_SIDE_OVERLAP_ARRAY
      : ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.BOTTOM_LEFT_SIDE_ARRAY); // Array
  },

  getBottomToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping
      ? ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.BOTTOM_RIGHT_SIDE_OVERLAP_ARRAY
      : ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.BOTTOM_RIGHT_SIDE_ARRAY); // Array
  },

  getLeftToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping ? ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.LEFT_TOP_SIDE_OVERLAP_ARRAY : ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.LEFT_TOP_SIDE_ARRAY); // Array
  },

  getLeftToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping
      ? ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.LEFT_BOTTOM_SIDE_OVERLAP_ARRAY
      : ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.LEFT_BOTTOM_SIDE_ARRAY); // Array
  },

  getLeftToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.LEFT_LEFT_SIDE_ARRAY; // Array
  },

  getLeftToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ((toRect.x - fromRect.x - fromRect.width > 2 * bypassDistance)
      ? ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.LEFT_RIGHT_SIDE_2and4BENDS_ARRAY
      : ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.LEFT_RIGHT_SIDE_4BENDS_ARRAY); // Array
  },

  getRightToTopSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping
      ? ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.RIGHT_TOP_SIDE_OVERLAP_ARRAY
      : ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.RIGHT_TOP_SIDE_ARRAY); // Array
  },

  getRightToBottomSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return (isOverlapping
      ? ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.RIGHT_BOTTOM_SIDE_OVERLAP_ARRAY
      : ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.RIGHT_BOTTOM_SIDE_ARRAY); // Array
  },

  getRightToLeftSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ((toRect.x - fromRect.x - fromRect.width > 2 * bypassDistance)
      ? ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.RIGHT_LEFT_SIDE_2and4BENDS_ARRAY
      : ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.RIGHT_LEFT_SIDE_4BENDS_ARRAY); // Array
  },

  getRightToRightSideTypes : function(fromRect, toRect, isOverlapping, bypassDistance)
  {
    return ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.RIGHT_RIGHT_SIDE_ARRAY; // Array
  },

  getAllQuasiSelfInterGraphLinkShapeTypes : function()
  {
    // summary:
    //		Returns all the shape types for quasi-self-intergraph-links. 
    // description:
    //		Returns all the shape types for quasi-self-intergraph-links. 
    //		Used Only when the node side filtering or side-constraints have
    //		rejected all the shapes obtained by the fine-grain choice depending
    //		on the relative position of the end-nodes.
    // tags:
    //		protected
    
    return ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer.ALL_QUASI_SELF_INTERGRAPH_LINK_TYPES; // Array
  },

  getFromBottomLeftToTopRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		Returns an array of shape types and computes the link region. 
    // description:
    //		Returns an array of shape types and computes the link region. 
    //		The selection of shapes depends on the relative position of the
    //		nodes and eventually on various settings. shapeTT ----------- |     
    //		   | |     ----- shapeLL--- |--------|   |------------------ |   |
    //		-------| T |--------         |shapeBR (not used) |   | |  ----|   | 
    //		     |      | |   | |  |   -----       |         | |   | |  |    | |
    //		       |  | |  ----- |sRL | |        |         | |  |   |--    | |  
    //		    |         | ---| F |-------shapeRB   |         | |  
    //		|--------|---------shapeRR  | -----        |                  | | | 
    //		 |                  | | -----------shapeBB           |
    //		--------------------------------
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(toRect.x - 2 * bypassDistance > fromRect.x + fromRect.width, fromRect.y - 2 * bypassDistance > toRect.y + toRect.height,
        this.getPositionArray(linkData, ibm_ilog.graphlayout.shortlink._OrthoWith4BendsPositionArrays.FROM_BL_TO_TR_POSITION_ARRAY,
            ibm_ilog.graphlayout.shortlink._OrthoWithout4BendsPositionArrays.FROM_BL_TO_TR_POSITION_ARRAY)); // Array
  },

  getFromTopLeftToBottomRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | F | ----- ----- | T | -----
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(toRect.x - 2 * bypassDistance > fromRect.x + fromRect.width, toRect.y - 2 * bypassDistance > fromRect.y + fromRect.height,
        this.getPositionArray(linkData, ibm_ilog.graphlayout.shortlink._OrthoWith4BendsPositionArrays.FROM_TL_TO_BR_POSITION_ARRAY,
            ibm_ilog.graphlayout.shortlink._OrthoWithout4BendsPositionArrays.FROM_TL_TO_BR_POSITION_ARRAY)); // Array
  },

  getFromLeftToRightPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		shapeTT --------- |       | -----   ----- | F |   | T | -----  
    //		----- |       | --------- shapeBB
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(toRect.x - 2 * bypassDistance > fromRect.x + fromRect.width,
        this.getPositionArray(linkData, ibm_ilog.graphlayout.shortlink._OrthoWith4BendsPositionArrays.FROM_L_TO_R_POSITION_ARRAY,
            ibm_ilog.graphlayout.shortlink._OrthoWithout4BendsPositionArrays.FROM_L_TO_R_POSITION_ARRAY)); // Array
  },

  getFromBottomRightToTopLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | T | ----- ----- | F | -----
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(fromRect.x - 2 * bypassDistance > toRect.x + toRect.width, fromRect.y - 2 * bypassDistance > toRect.y + toRect.height,
        this.getPositionArray(linkData, ibm_ilog.graphlayout.shortlink._OrthoWith4BendsPositionArrays.FROM_BR_TO_TL_POSITION_ARRAY,
            ibm_ilog.graphlayout.shortlink._OrthoWithout4BendsPositionArrays.FROM_BR_TO_TL_POSITION_ARRAY)); // Array
  },

  getFromTopRightToBottomLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | F | ----- ----- | T | -----
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(fromRect.x - 2 * bypassDistance > toRect.x + toRect.width, toRect.y - 2 * bypassDistance > fromRect.y + fromRect.height,
        this.getPositionArray(linkData, ibm_ilog.graphlayout.shortlink._OrthoWith4BendsPositionArrays.FROM_TR_TO_BL_POSITION_ARRAY,
            ibm_ilog.graphlayout.shortlink._OrthoWithout4BendsPositionArrays.FROM_TR_TO_BL_POSITION_ARRAY)); // Array
  },

  getFromRightToLeftPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		-----   ----- | T |   | F | -----   -----
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(toRect.x + toRect.width + 2 * bypassDistance < fromRect.x,
        this.getPositionArray(linkData, ibm_ilog.graphlayout.shortlink._OrthoWith4BendsPositionArrays.FROM_R_TO_L_POSITION_ARRAY,
            ibm_ilog.graphlayout.shortlink._OrthoWithout4BendsPositionArrays.FROM_R_TO_L_POSITION_ARRAY)); // Array
  },

  getFromBottomToTopPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- | T | ----- ----- | F | -----
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(toRect.y + toRect.height + 2 * bypassDistance < fromRect.y,
        this.getPositionArray(linkData, ibm_ilog.graphlayout.shortlink._OrthoWith4BendsPositionArrays.FROM_B_TO_T_POSITION_ARRAY,
            ibm_ilog.graphlayout.shortlink._OrthoWithout4BendsPositionArrays.FROM_B_TO_T_POSITION_ARRAY)); // Array
  },

  getFromTopToBottomPositionTypes : function(linkData, fromRect, toRect, bypassDistance)
  {
    // summary:
    //		----- ---| F |----- sh2 |  -----    | |   -----   | shape 1 ----| T
    //		|---- -----
    // tags:
    //		protected
    
    return this.getSelectedShapeTypes(toRect.y - 2 * bypassDistance > fromRect.y + fromRect.height,
        this.getPositionArray(linkData, ibm_ilog.graphlayout.shortlink._OrthoWith4BendsPositionArrays.FROM_T_TO_B_POSITION_ARRAY,
            ibm_ilog.graphlayout.shortlink._OrthoWithout4BendsPositionArrays.FROM_T_TO_B_POSITION_ARRAY)); // Array
  },

  getPositionArray : function(linkData, arrayWith4Bend, arrayWithout4Bend)
  {
    return ((this._nodeSideFilter != null || linkData.hasFixedConnectionPoint()) ? arrayWith4Bend : arrayWithout4Bend); // Array
  },

  getSelectedShapeTypes : function (a0, a1, a2)
  {
    // summary:
    // tags:
    //		private
    
    if(arguments.length == 2)
      return this.getSelectedShapeTypes_overload_2(a0, a1);
    else if(arguments.length == 3)
      return this.getSelectedShapeTypes_overload_3(a0, a1, a2);
  },
  
  getSelectedShapeTypes_overload_2 : function(condition, shapeTypesArray)
                                                                        
  {
    return (condition ? shapeTypesArray[0] : shapeTypesArray[1]); // Array
  },

  getSelectedShapeTypes_overload_3 : function(horizontalCondition, verticalCondition, shapeTypesArray)
  {
    if (horizontalCondition) {
      return (verticalCondition ? shapeTypesArray[3] : shapeTypesArray[1]); // Array
    }
    else if (verticalCondition) {
      return shapeTypesArray[2]; // Array
    }
    else {
      return shapeTypesArray[0]; // Array
    }
  },

  isEnoughSpace : function(linkData, shapeType, subgraphBox, nodeBox, bypassDistance, enoughSpaceOnLeft, enoughSpaceOnRight, enoughSpaceOnTop, enoughSpaceOnBottom)
  {
    // summary:
    //		Returns true if
    //		there's enough space on the node side, and returns false otherwise. 
    // description:
    //		Returns true if there's enough space on the node side, and returns
    //		false otherwise. 
    //		Overridden in OrthogonalLinkShapeProducer to add more checks.
    // tags:
    //		protected
    
    if (shapeType.isOrthogonal() && shapeType.getNumberOfBends() == 1)
    {
      var nodeSide = (linkData.isQuasiSelfInterGraphLinkOrigin() ? shapeType.getToSide(linkData) : shapeType.getFromSide(linkData));

      switch (nodeSide)
      {
        case ibm_ilog.graphlayout.Direction.LEFT:
          enoughSpaceOnLeft = nodeBox.x >= subgraphBox.x + subgraphBox.width * 0.5 + bypassDistance;
          break;
        case ibm_ilog.graphlayout.Direction.RIGHT:
          enoughSpaceOnRight = nodeBox.x + nodeBox.width <= subgraphBox.x + subgraphBox.width * 0.5 - bypassDistance;
          break;
        case ibm_ilog.graphlayout.Direction.TOP:
          enoughSpaceOnTop = nodeBox.y >= subgraphBox.y + subgraphBox.height * 0.5 + bypassDistance;
          break;
        case ibm_ilog.graphlayout.Direction.BOTTOM:
          enoughSpaceOnBottom = nodeBox.y + nodeBox.height <= subgraphBox.y + subgraphBox.height * 0.5 - bypassDistance;
          break;
        default:
          
          ibm_ilog.graphlayout.internalutil.LogResUtil.logAndThrowRuntimeExc(ibm_ilog.graphlayout.shortlink.ShortLinkLayout, "graphlayout.expert.message.6630E",  nodeSide);
      }
    }

    return this.inherited("isEnoughSpace", arguments, [linkData, shapeType, subgraphBox, nodeBox, bypassDistance, enoughSpaceOnLeft, enoughSpaceOnRight, enoughSpaceOnTop, enoughSpaceOnBottom]); // Boolean
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer,
{
  MAX_NUMBER_OF_BENDS : null,

  TOP_TOP_SIDE_ARRAY : null,
  TOP_BOTTOM_SIDE_2and4BENDS_ARRAY : null,
  TOP_BOTTOM_SIDE_4BENDS_ARRAY : null,
  TOP_LEFT_SIDE_ARRAY : null,
  TOP_RIGHT_SIDE_ARRAY : null,
  BOTTOM_TOP_SIDE_2and4BENDS_ARRAY : null,
  BOTTOM_TOP_SIDE_4BENDS_ARRAY : null,
  BOTTOM_BOTTOM_SIDE_ARRAY : null,
  BOTTOM_LEFT_SIDE_ARRAY : null,
  BOTTOM_RIGHT_SIDE_ARRAY : null,
  LEFT_TOP_SIDE_ARRAY : null,
  LEFT_BOTTOM_SIDE_ARRAY : null,
  LEFT_LEFT_SIDE_ARRAY : null,
  LEFT_RIGHT_SIDE_2and4BENDS_ARRAY : null,
  LEFT_RIGHT_SIDE_4BENDS_ARRAY : null,
  RIGHT_TOP_SIDE_ARRAY : null,
  RIGHT_BOTTOM_SIDE_ARRAY : null,
  RIGHT_LEFT_SIDE_2and4BENDS_ARRAY : null,
  RIGHT_LEFT_SIDE_4BENDS_ARRAY : null,
  RIGHT_RIGHT_SIDE_ARRAY : null,

  TOP_LEFT_SIDE_OVERLAP_ARRAY : null,
  TOP_RIGHT_SIDE_OVERLAP_ARRAY : null,
  BOTTOM_LEFT_SIDE_OVERLAP_ARRAY : null,
  BOTTOM_RIGHT_SIDE_OVERLAP_ARRAY : null,
  LEFT_TOP_SIDE_OVERLAP_ARRAY : null,
  LEFT_BOTTOM_SIDE_OVERLAP_ARRAY : null,
  RIGHT_TOP_SIDE_OVERLAP_ARRAY : null,
  RIGHT_BOTTOM_SIDE_OVERLAP_ARRAY : null,

  ALL_QUASI_SELF_INTERGRAPH_LINK_TYPES : null,
  _fields_init : function(c)
  {
    c = c || ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer;
    if(ibm_ilog.graphlayout.shortlink._LinkShapeProducer._fields_init)
      ibm_ilog.graphlayout.shortlink._LinkShapeProducer._fields_init(c);
    
    c.MAX_NUMBER_OF_BENDS = 4;
    c.TOP_TOP_SIDE_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTTleft.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTTright.instance
     ];
    c.TOP_BOTTOM_SIDE_2and4BENDS_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBright.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBleft.instance
     ];
    c.TOP_BOTTOM_SIDE_4BENDS_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBright.instance, ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendTBleft.instance ];
    c.TOP_LEFT_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTL.instance, ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL.instance ];
    c.TOP_RIGHT_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTR.instance, ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR.instance ];
    c.BOTTOM_TOP_SIDE_2and4BENDS_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTright.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTleft.instance
     ];
    c.BOTTOM_TOP_SIDE_4BENDS_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTright.instance, ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBTleft.instance ];
    c.BOTTOM_BOTTOM_SIDE_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBBleft.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendBBright.instance
     ];
    c.BOTTOM_LEFT_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBL.instance, ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL.instance ];
    c.BOTTOM_RIGHT_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBR.instance, ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR.instance ];
    c.LEFT_TOP_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLT.instance, ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT.instance ];
    c.LEFT_BOTTOM_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLB.instance, ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB.instance ];
    c.LEFT_LEFT_SIDE_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLLleft.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLLright.instance
     ];
    c.LEFT_RIGHT_SIDE_2and4BENDS_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRmiddle.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRtop.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRbottom.instance
     ];
    c.LEFT_RIGHT_SIDE_4BENDS_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRmiddle.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRtop.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendLRbottom.instance
     ];
    c.RIGHT_TOP_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRT.instance, ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT.instance ];
    c.RIGHT_BOTTOM_SIDE_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRB.instance, ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB.instance ];
    c.RIGHT_LEFT_SIDE_2and4BENDS_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLmiddle.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLtop.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLbottom.instance
     ];
    c.RIGHT_LEFT_SIDE_4BENDS_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLmiddle.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLtop.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRLbottom.instance
     ];
    c.RIGHT_RIGHT_SIDE_ARRAY = 
    [
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRRleft.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeFourBendRRright.instance
     ];
    c.TOP_LEFT_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL_OVERLAP.instance ];
    c.TOP_RIGHT_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR_OVERLAP.instance ];
    c.BOTTOM_LEFT_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL_OVERLAP.instance ];
    c.BOTTOM_RIGHT_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR_OVERLAP.instance ];
    c.LEFT_TOP_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT_OVERLAP.instance ];
    c.LEFT_BOTTOM_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB_OVERLAP.instance ];
    c.RIGHT_TOP_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT_OVERLAP.instance ];
    c.RIGHT_BOTTOM_SIDE_OVERLAP_ARRAY = [ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB_OVERLAP.instance ];
    c.ALL_QUASI_SELF_INTERGRAPH_LINK_TYPES = 
    [
      
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendTR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendBR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendLT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeOneBendRT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendBT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendTB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendRL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeTwoBendLR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendLB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRB.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendRT.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTL.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendTR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBR.instance,
      ibm_ilog.graphlayout.shortlink._LinkShapeTypeThreeBendBL.instance
     ];
  }
  
}
);

(function(){ ibm_ilog.graphlayout.shortlink._OrthogonalLinkShapeProducer._fields_init(); })();
