dojo.provide('ibm_ilog.graphlayout.tree.TNodeParameters');

///////////////////////////////////////////////////////////////////////////////
// IBM ILOG Dojo Diagrammer 1.0
///////////////////////////////////////////////////////////////////////////////

// ------------------------------------------------------------------------
// Generated by J2JS
// DO NOT EDIT THIS FILE!
// ------------------------------------------------------------------------

dojo.require('ibm_ilog.graphlayout.internalutil.GraphModelUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.TranslateUtil');
dojo.require('ibm_ilog.graphlayout.internalutil.BaseSubgraphData');
dojo.require('ibm_ilog.graphlayout.internalutil.LayoutUtil');
dojo.require('ibm_ilog.graphlayout.tree.TreeLayout');

dojo.declare('ibm_ilog.graphlayout.tree.TNodeParameters', null, 
{
  // summary:
  //		A node parameter container. 
  // description:
  //		A node parameter container. 
  //		This node parameter container is used to store all the parameters and
  //		 data we need for the layout at the real node object (not the TNode).
  //		The main objective is to reduce the number of individual properties
  //		stored at the node, to avoid that we allocate a separate property for
  //		each bit or byte to be stored. Therefore we store only this
  //		TNodeParameters object, which contains all parameters.  
  // tags:
  //		private
  
  _rootPreference: null,

  _alignment: null,

  _childAlignment: null,
  _eastNeighbor: null,
  _westNeighbor: null,
  _associateParent: null,
  _associateChildren: null,
  _isSpecRoot: null,
  _isCalcRoot: null,
  _subtreeBlockMargin: null,

  constructor : function(layout, node)
  {
    this._rootPreference = -1;
    this._alignment = ibm_ilog.graphlayout.tree.TreeLayout._defaultAlignment;
    this._childAlignment = ibm_ilog.graphlayout.tree.TreeLayout.UNSPECIFIED;
    this._eastNeighbor = null;
    this._westNeighbor = null;
    this._isSpecRoot = false;
    this._isCalcRoot = false;
    this._subtreeBlockMargin = null;

    var model = layout.getGraphModel();

    layout = ibm_ilog.graphlayout.tree.TNodeParameters.adjust(layout, model, node);

    model.setParameter(node, layout._NODE_PROPERTY, this);
  },
  
  isNeeded : function()
  {
    // summary:
    //		Returns 'true' if the parameter container is still
    //		needed, and 'false' if the parameter container can be
    //		removed from the node.
    // tags:
    //		private
    
    return (this._rootPreference >= 0 || this._alignment != ibm_ilog.graphlayout.tree.TreeLayout._defaultAlignment || this._childAlignment != ibm_ilog.graphlayout.tree.TreeLayout.UNSPECIFIED ||
        this._eastNeighbor != null || this._westNeighbor != null || this._associateParent != null || this._associateChildren != null || this._subtreeBlockMargin != null || this._isSpecRoot ||
        this._isCalcRoot); // Boolean
  },

  dispose : function(layout, node)
  {
    // summary:
    //		Dispose the parameter container.
    // tags:
    //		private
    
    this._eastNeighbor = null;
    this._westNeighbor = null;
    var model = layout.getGraphModel();

    layout = ibm_ilog.graphlayout.tree.TNodeParameters.adjust(layout, model, node);

    model.setParameter(node, layout._NODE_PROPERTY, null);
  },

  getEastNeighbor : function()
  {
    // summary:
    //		Returns the east neighbor node of this node.
    // tags:
    //		private
    
    return this._eastNeighbor; // Object
  },

  setEastNeighbor : function(node)
  {
    // summary:
    //		Sets the east neighbor node of this node.
    // tags:
    //		private
    
    this._eastNeighbor = node;
  },

  getWestNeighbor : function()
  {
    // summary:
    //		Returns the west neighbor node of this node.
    // tags:
    //		private
    
    return this._westNeighbor; // Object
  },

  setWestNeighbor : function(node)
  {
    // summary:
    //		Sets the west neighbor node of this node.
    // tags:
    //		private
    
    this._westNeighbor = node;
  },

  getAssociateParent : function()
  {
    // summary:
    //		Returns the associate parent of this node.
    // tags:
    //		private
    
    return this._associateParent; // Object
  },

  setAssociateParent : function(node)
  {
    // summary:
    //		Sets the associate parent of this node.
    // tags:
    //		private
    
    this._associateParent = node;
  },

  getAssociates : function()
  {
    // summary:
    //		Returns the associates of this node. 
    // description:
    //		Returns the associates of this node. 
    //		All associates have this node as associate parent.
    // tags:
    //		private
    
    if (this._associateChildren == null) {
      return ibm_ilog.graphlayout.internalutil.LayoutUtil.getVoidEnumeration(); // ibm_ilog.graphlayout.IIterator
    }
    return ( new ibm_ilog.graphlayout.internalutil.ArrayIterator(this._associateChildren)); // ibm_ilog.graphlayout.IIterator
  },

  addAssociateChild : function(node)
  {
    // summary:
    //		Adds an associate to this node.
    // tags:
    //		private
    
    if (this._associateChildren == null) {
      this._associateChildren = new Array();
    }
    this._associateChildren.push(node);
  },

  removeAssociateChild : function(node)
  {
    // summary:
    //		Remove an associate from this node.
    // tags:
    //		private
    
    if (this._associateChildren == null) {
      return;
    }
    ibm_ilog.graphlayout.internalutil.TranslateUtil.removeArrayObject(this._associateChildren, node);
    if (this._associateChildren.length == 0) {
      this._associateChildren = null;
    }
  },

  isSpecRoot : function()
  {
    // summary:
    //		Returns 'true' if the node is a specified root. 
    // description:
    //		Returns <code>true</code> if the node is a specified root. 
    //		In this case, it must be in the specified root vector of the
    //		<code>TreeLayout</code> instance.
    // tags:
    //		private
    
    return this._isSpecRoot; // Boolean
  },

  setSpecRoot : function(flag)
  {
    // summary:
    //		Sets whether the node is a specified root.
    // tags:
    //		private
    
    this._isSpecRoot = flag;
  },

  isCalcRoot : function()
  {
    // summary:
    //		Returns 'true' if the node is a calculated root. 
    // description:
    //		Returns <code>true</code> if the node is a calculated root. 
    //		In this case, it must be in the calculated root vector of the
    //		<code>TreeLayout</code> instance.
    // tags:
    //		private
    
    return this._isCalcRoot; // Boolean
  },

  setCalcRoot : function(flag)
  {
    // summary:
    //		Sets whether the node is a calculated root.
    // tags:
    //		private
    
    this._isCalcRoot = flag;
  },

  getSubtreeBlockMargins : function()
  {
    // summary:
    //		Returns the subtree block margins.
    // tags:
    //		private
    
    return this._subtreeBlockMargin; // Array
  },

  getSubtreeBlockMargin : function(index)
  {
    // summary:
    //		Returns the subtree block margin at a given side.
    // tags:
    //		private
    
    if (this._subtreeBlockMargin == null) {
      return -1; // Number
    }
    return this._subtreeBlockMargin[index]; // Number
  },

  setSubtreeBlockMargin : function(index, margin)
  {
    // summary:
    //		Sets the subtree block margin at a given side. 
    // description:
    //		Sets the subtree block margin at a given side. 
    //		0 = east, 1 = south, 2 = west, 3 = north.
    // tags:
    //		private
    
    if (this._subtreeBlockMargin == null)
    {
      if (margin == -1) {
        return;
      }
      this._subtreeBlockMargin = ibm_ilog.graphlayout.internalutil.TranslateUtil.newArray(4, 0);
      this._subtreeBlockMargin[0] = -1;
      this._subtreeBlockMargin[1] = -1;
      this._subtreeBlockMargin[2] = -1;
      this._subtreeBlockMargin[3] = -1;
    }

    this._subtreeBlockMargin[index] = margin;

    if (margin == -1 && this._subtreeBlockMargin[0] == -1 && this._subtreeBlockMargin[1] == -1 && this._subtreeBlockMargin[2] == -1 && this._subtreeBlockMargin[3] == -1)
    {
      this._subtreeBlockMargin = null;
    }
  }

}
);

dojo.mixin(ibm_ilog.graphlayout.tree.TNodeParameters,
{

  beforeLayout : function(layout, nodeObj, node)
  {
    var prop = ibm_ilog.graphlayout.tree.TNodeParameters.get(layout, nodeObj);
    if (prop != null) {
      node.setSubtreeBlockMargins(prop.getSubtreeBlockMargins());
    }
  },

  getRootPreference : function(layout, node)
  {
    if (false) {
      return -1; // int
    }
    var prop = ibm_ilog.graphlayout.tree.TNodeParameters.get(layout, node);
    if (prop != null) {
      return prop._rootPreference; // int
    }
    return -1; // int
  },

  setRootPreference : function(layout, node, value)
  {
    var prop = ibm_ilog.graphlayout.tree.TNodeParameters.getOrAllocate(layout, node);
    var oldPref;

    oldPref = prop._rootPreference;

    prop._rootPreference = value;

    if (!prop.isNeeded()) {
      prop.dispose(layout, node);
    }
    if (oldPref != value) {
      layout.onObjectParameterChanged(node, "RootPreference");
    }
  },

  getAlignment : function(layout, node)
  {
    if (false) {
      return ibm_ilog.graphlayout.tree.TreeLayout._defaultAlignment; // int
    }
    var prop = ibm_ilog.graphlayout.tree.TNodeParameters.get(layout, node);
    if (prop != null) {
      return prop._alignment; // int
    }
    return ibm_ilog.graphlayout.tree.TreeLayout._defaultAlignment; // int
  },

  setAlignment : function(layout, node, value)
  {
    var prop = ibm_ilog.graphlayout.tree.TNodeParameters.getOrAllocate(layout, node);

    var oldAlignment;

    oldAlignment = prop._alignment;

    prop._alignment = value;

    if (!prop.isNeeded()) {
      prop.dispose(layout, node);
    }
    if (oldAlignment != value) {
      layout.onObjectParameterChanged(node, "Alignment");
    }
  },

  getChildAlignment : function(layout, node)
  {
    if (false) {
      return ibm_ilog.graphlayout.tree.TreeLayout.UNSPECIFIED; // int
    }
    var prop = ibm_ilog.graphlayout.tree.TNodeParameters.get(layout, node);
    if (prop != null) {
      return prop._childAlignment; // int
    }
    return ibm_ilog.graphlayout.tree.TreeLayout.UNSPECIFIED; // int
  },

  setChildAlignment : function(layout, node, value)
  {
    var prop = ibm_ilog.graphlayout.tree.TNodeParameters.getOrAllocate(layout, node);

    var oldAlignment;

    oldAlignment = prop._childAlignment;

    prop._childAlignment = value;

    if (!prop.isNeeded()) {
      prop.dispose(layout, node);
    }
    if (oldAlignment != value) {
      layout.onObjectParameterChanged(node, "ChildAlignment");
    }
  },

  getSubtreeBlockMargin : function(layout, node, index)
  {
    if (false) {
      return -1; // Number
    }
    var prop = ibm_ilog.graphlayout.tree.TNodeParameters.get(layout, node);
    if (prop != null) {
      return prop.getSubtreeBlockMargin(index); // Number
    }
    return -1; // Number
  },

  setSubtreeBlockMargin : function(layout, node, index, value)
  {
    var prop = ibm_ilog.graphlayout.tree.TNodeParameters.getOrAllocate(layout, node);
    var oldMargin;

    oldMargin = prop.getSubtreeBlockMargin(index);

    prop.setSubtreeBlockMargin(index, value);

    if (!prop.isNeeded()) {
      prop.dispose(layout, node);
    }
    if (oldMargin != value)
    {
      var side = "";

      switch (index)
      {
        case 0:
          side = "East";
          break;
        case 1:
          side = "South";
          break;
        case 2:
          side = "West";
          break;
        case 3:
          side = "North";
          break;
      }
      layout.onObjectParameterChanged(node, side + "SubtreeBlockMargin");
    }
  },

  get : function(layout, node)
  {
    var model = layout.getGraphModel();

    if (model == null) {
      return null; // ibm_ilog.graphlayout.tree.TNodeParameters
    }
    else
    {
      layout = ibm_ilog.graphlayout.tree.TNodeParameters.adjust(layout, model, node);

      return model.getParameter(node, layout._NODE_PROPERTY); // ibm_ilog.graphlayout.tree.TNodeParameters
    }
  },

  getOrAllocate : function(layout, node)
  {
    var nodeParameters = ibm_ilog.graphlayout.tree.TNodeParameters.get(layout, node);
    if (nodeParameters == null) {
      nodeParameters = new ibm_ilog.graphlayout.tree.TNodeParameters(layout, node);
    }
    return nodeParameters; // ibm_ilog.graphlayout.tree.TNodeParameters
  },

  dispose : function(layout, node)
  {
    var prop = ibm_ilog.graphlayout.tree.TNodeParameters.get(layout, node);
    if (prop != null) {
      prop.dispose(layout, node);
    }
  },

  adjust : function(layout, model, node)
  {
    if (!layout.isRootLayoutInsideRecursiveLayoutTraversal()) {
      return layout; // ibm_ilog.graphlayout.tree.TreeLayout
    }
    if (!(model instanceof ibm_ilog.graphlayout.internalutil.BaseSubgraphData)) {
      return layout; // ibm_ilog.graphlayout.tree.TreeLayout
    }

    var nestedModel = model;
    var omodel = nestedModel.getOriginalGraphModel(node);

    if (omodel == nestedModel.getOriginalGraphModel()) {
      return layout; // ibm_ilog.graphlayout.tree.TreeLayout
    }
    return layout.getTreatedSubgraphLayout(omodel, true); // ibm_ilog.graphlayout.tree.TreeLayout
  }

}
);

