/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.dsv.editor.domain.ui.APIModelingPage");

dojo.require("rmpw.jazz.ModelingPage");
dojo.require("rmpw.jazz.ui.Controls");
dojo.require("rmpw.dsv.editor.domain.ui.APIConfiguration");
dojo.require("rmpw.jazz.ui.Layout");

(function(){
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var controls = rmpw.jazz.ui.Controls.items;

    dojo.declare("rmpw.dsv.editor.domain.ui.APIModelingPage", [rmpw.jazz.ModelingPage], {

    	configuration: new rmpw.dsv.editor.domain.ui.APIConfiguration(),
    	
    	tools: [ { name: controls.FILEPICKER, display: true, enabled: true, query: { domain: "ecore", subdomain: "API" } }, 
                 { name: controls.RELOAD_DIAGRAM_CONTENT, display: true, enabled: true },
                 { name: controls.ZOOM, display: true, enabled: true },
                 { name: controls.UNDO, display: false, enabled: true },
                 { name: controls.REDO, display: false, enabled: true },
                 { name: controls.LAYOUT, display: false, enabled: true },
                 { name: controls.SETTINGS, display: false, subcontrols: this.settings },
        ],
        
    	prefix: "rmpw.dsv.editor.api",
    	
    	postCreate: function(){
           var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
           ActionRegistry.registerAction("rmpw.dsv.editor.api.ui.startup", this, "startup"); 
                   
           this.resizer = jazz.util.ResizeNotifier.register({
			  context: this,
	          callback: this.resize,
	          force: true    	        
	       }); 
        },
    
	    startup : function() {
			this.resize();
		},
	    
	    resize : function() {
			var s = dojo
			.marginBox("jazz_app_internal_Navbar_0");
			if (this.layout == null) {
				var options = {
						size : s,
						configuration : this.configuration,
						tools : this.tools,
						settings : this.settings,
						prefix : this.prefix
				};
	
				this.layout = new rmpw.jazz.ui.Layout(options);
	
				if (this.load) {
					this.layout.loadDiagram = this.load;
				}
	
				if (this.save) {
					this.layout.saveDiagram = this.save;
				}
	
				this.hiJazzAttachPoint
				.appendChild(this.layout.domNode);
				this.layout.layout();
				this.layout.resize(s);
				this.extend();
			} else {
				var s = dojo
				.marginBox(this.hiJazzAttachPoint.parentNode);
				var navBar = dojo.coords(dojo
						.byId("jazz_app_internal_Navbar_0"));
				var scc = dojo.marginBox(dojo
						.byId("content-cell"));
				s.h = scc.h - navBar.h;
				s.w = navBar.w;
				this.layout.resize(s);
			}
		}
    });
    
})();