/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.dsv.editor.behavior.ui.BundleEditor");

dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.ContentPane");

dojo.require("rmpw.dsv.editor.behavior.ui.ControllerEditor");

/**
 * Widget for editing the root of a behavior model that extends a
 * render mapping with interactive components.
 * 
 * @author Marc Gobeil
 */
dojo.declare("rmpw.dsv.editor.behavior.ui.BundleEditor", dijit.layout.TabContainer, {
	tabPosition: "left-h",
	
	postCreate: function() {
		this.inherited(arguments);
		
		var controllers = this.bundle.controllers;
		for(var i = 0, controller; controller = controllers[i]; i++) {
			var pane = new dijit.layout.ContentPane({
				title: controller.shape.name
			});
			this.addChild(pane);
			
			var editor = new rmpw.dsv.editor.behavior.ui.ControllerEditor({
				controller: controller,
				metamodel: this.metamodel
			});
			pane.attr("content", editor);
		}
	}	
});