/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.dsv.editor.behavior.ui.ControllerEditor");

dojo.require("dijit.Menu");
dojo.require("dijit.MenuItem");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.DropDownButton");

dojo.require("rmpw.dsv.editor.behavior.ui.ToolListEditor");


/**
 * Widget for editing the behavior model of a QVT relation equivalent to a shape.
 * 
 * @author Marc Gobeil
 */
dojo.declare("rmpw.dsv.editor.behavior.ui.ControllerEditor", dijit.layout.TabContainer, {

	postCreate: function() {
		this.inherited(arguments);
		
		// build Tools tab
		var toolsTab = new rmpw.dsv.editor.behavior.ui.ToolListEditor({
			title: "Tools",
			controller: this.controller,
			tools: this.metamodel.tools
		});
		this.addChild(toolsTab);

		// build Actions tab
		var actionsTab = new dijit.layout.ContentPane({
			title: "Actions"
		});
		this.addChild(actionsTab);
	}
});