/*******************************************************************************
 * Licensed Materials - Property of IBM Copyright IBM Corp. 2011. All
 * Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
(function() {
dojo.provide("rmpw.dsv.editor.form.ui.CreateDataType");

dojo.require("jazz.ui.Dialog");
dojo.require("rmpw.dsv.editor.form.ui.ChangeMixin");
dojo.require("rmps.ui.Footer");

/**
 * 
 * //FIXME: Must extend an instance of _Widget
 * 
 * Create DataTypeProperty using a form dialog.
 * 
 * @author Sameh Ayoub
 */
dojo.declare("rmpw.dsv.editor.form.ui.CreateDataType", null, {

	listeners: null,
	constructor: function() {
		this._sources = {};
		this.listeners = [];
	},
	
	CreateDataType: function(typeName, widget, typeForm, defaultUri, defaultLabel, parent){
		this.typeName = typeName;
		this.widget = widget;
		this._form = new rmpw.dsf.codegen.properties.forms[typeForm]();
		var method = this._form.setterNames[typeForm];
		this._form[method]({rdf_about:defaultUri/*, rdfs_label: defaultLabel*/});
		
		this._form._setRoot(parent);
		this._form.template.form.startup();
		this._show();
	},

	_show: function() {
        var form = this._form;
        this.selectTypeDialog = new jazz.ui.Dialog({
    		primaryTitle: "Create",
            secondaryTitle: this.typeName,
            width: "650px",
            onClose: dojo.hitch(this, this.onClose),
            contentNode: form.domNode
        });
        this._form.domNode.style.padding= "6px";
		this.listeners.push(dojo.connect(this._form, "onSubmit", this.selectTypeDialog, "close"));
		this.listeners.push(dojo.connect(this._form, "onCancel", this.selectTypeDialog, "close"));
	},
	
	add: function() {
		this.widget.addTreeItem({rdf_about : about, rdfs_label : label});
		this.widget.onChange();
	},
	
	onClose: function() {
		dojo.forEach(this.listeners, dojo.disconnect);
		this.listeners = [];
	}
});

//--------------- CreateDataTypeProperty ---------------

dojo.provide("rmpw.dsf.codegen.properties.forms.CreateDataTypeProperty");

dojo.require("dijit.form.Form");
dojo.require("dijit.layout._LayoutWidget");
dojo.require("dojox.layout.TableContainer");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.NumberTextBox");
dojo.require("dijit.form.DateTextBox");

dojo.declare("rmpw.dsf.codegen.properties.forms.CreateDataTypeProperty",[dijit.layout._LayoutWidget, rmpw.dsv.editor.form.ui.ChangeMixin], {
	sources: null,	
	template: null,
	
	setterNames: {
		CreateDataTypeProperty: "setDataTypeProperty"
	},
	
	constructor: function(objectTypes) {
		this.sources = {};
		this.template = {};
		this.objectType = dojo.isArray(objectTypes)? objectTypes[0] : null;
	},
	
	/*
	 * @param {null} root
	 * 
	 */
	_setRoot: function(root) {
		this._root = root;
	},
	
	/*
	 * @param {Restriction} DataTypeProperty
	 * 
	 */
	setDataTypeProperty: function(DataTypeProperty) {
		this.template._unique5.set("value", DataTypeProperty.value);
		this.sources.DataTypeProperty = DataTypeProperty;
	},
	
	postCreate: function() {
		var _unique1,
		    _unique2,
		    _unique3,
		    _unique4,
		    _unique5,
		    args = { region: "center", 
					 intermediateChanges: true, 
					 required: true, 
					 label: "Value:<span class='RequiredMarker' title='The value is required.'>*&nbsp;</span>", 
					 style: "height:20px;width: 99.9%;"
				   };
		
		this.inherited(arguments);
		
		_unique1 = new dojox.layout.TableContainer({
			region: "center", 
			style: "overflow-y: auto;width: 99%; border:0px;"
		});
		this.template._unique1 = _unique1;
		this.addChild(_unique1);
		
		_unique5 = this.objectType === "http://www.w3.org/2001/XMLSchema#integer"? new dijit.form.NumberTextBox(args):
				   this.objectType === "http://www.w3.org/2001/XMLSchema#dateTime"? new dijit.form.DateTextBox(args):
				   new dijit.form.ValidationTextBox(args);
		this.template._unique5 = _unique5;
		
		this.connect(this.template._unique5, "onChange", dojo.hitch(this, function(){
			this.createChange(this.featureId, this.template._unique5.get('value'))
		}));
					
		_unique1.addChild(_unique5);
		
		this.footer= new rmps.ui.Footer({
			onOK: dojo.hitch(this, this._handleOK),
			onCancel: dojo.hitch(this, this._handleCancel),
		});
		this.addChild(this.footer);
		
		//Optimistic Enablement
		this.footer.setOKEnablement(true);
	},
	
	_handleOK: function(event){
		this.onSubmit();
	},
	
	_handleCancel: function(event){
		this.onCancel();
	},
	
	onCancel: function(event){
		//Eventing
	}
});

})();