/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.dsv.editor.behavior.ui.ExistingModelPane");

dojo.require("dijit.form.Form");
dojo.require("dijit.form.ComboBox");
dojo.require("jazz.app.auth");
dojo.require("dojo.data.ItemFileReadStore");
dojo.require("dojox.json.ref");

dojo.require("rmpw.dsv.editor.behavior.ui.ControllerEditor");

/**
 * Panel for loading an existing behavior model.
 * 
 * @author Marc Gobeil
 */
dojo.declare("rmpw.dsv.editor.behavior.ui.ExistingModelPane", dijit.form.Form, {
	widgetsInTemplate: true,
	templateString:
		"<div dojoAttachPoint='containerNode'>" +
			"<table>" +
				"<tr>" +
					"<td>Behavior</td>" +
					"<td><input dojoAttachPoint='behaviorSelector'/></td>" +
				"</tr>" +
				"<tr>" +
					"<td>&nbsp;</td>" +
					"<td><button dojotype='dijit.form.Button' type='submit'>Load</button></td>" +
				"</tr>" +
			"</table>" +
		"</div>",
	
	postCreate: function() {
		var behaviorBundleStore = new dojo.data.ItemFileReadStore({
			url: "resource/itemCol/Model?domain=behavior",
			clearOnClose: true,
			urlPreventCache: true
		});
		 
		var renderSelector = new dijit.form.ComboBox({
			store: behaviorBundleStore,
	        searchAttr: "path",
	        name: "behaviorBundlePath"
		}, this.behaviorSelector);
	},
		
	onSubmit: function(e) {
		this.onRequest();
		
		var form = this.attr("value");
		
		dojo.xhrGet({
			url: net.jazz.ajax._contextRoot + "/resource/itemPath/Model" + form.behaviorBundlePath,
			handleAs: "text",
			load: dojo.hitch(this, function(data) {
				this.onLoad(dojox.json.ref.fromJson(data)[0], form.behaviorBundlePath);
			})
		});
		//for RDF support use this one 
//		var mySplitResult = form.behaviorBundlePath.split('/'); //get rid of path
//		resourceName = mySplitResult[mySplitResult.length-1];
//
//		var args = {
//				//url : escape(net.jazz.ajax._contextRoot+"/dsvfrontservice/sparql?query=FindSubTypes&import="+resourceName+".xmi&eSuperTypes=http://www.ibm.com/rational/graphics/behavior#//Tool&http://www.eclipse.org/emf/2002/Ecore#EClass.abstract=false"),
//				url : escape(net.jazz.ajax._contextRoot+"/dsvfrontservice/sparql?query=MatchProperties&import="+resourceName+".xmi&ecoreType=http://www.eclipse.org/qvt/1.0/QVTRelation#Relation.variable,http://www.ibm.com/rational/graphics#//Group"),
//				headers: {
//				"Accept": "application/rdf+json",
//					"X-ibm-rmps-internal": "true"
//				},
//				handleAs: "text",
//				load: function(data) {
//					this.onLoad(dojox.json.ref.fromJson(data)[0], form.behaviorBundlePath);
//				},
//				error: function(error, ioargs){
//					dojo.require("dijit.Dialog");
//					var errorDlg = new dijit.Dialog({
//			            title: "SERVER ERROR",
//			            style: "width: 300px"
//			        });					
//					errorDlg.attr("content",error.message);
//					errorDlg.show();
//		        }				
//
//		};
//		jazz.client.xhrGet(args);
		
	},
	
	resize: function() {
		// dummy to satisfy parent
	}
});