/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.dsv.editor.preview.ui.ModelingPage");

dojo.require("rmpw.jazz.ModelingPage");
dojo.require("rmpw.jazz.ui.Controls");
dojo.require("rmpw.dsv.editor.preview.ui.Configuration");
dojo.require("rmpw.jazz.ui.Layout");

(function(){
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var controls = rmpw.jazz.ui.Controls.items;

    dojo.declare("rmpw.dsv.editor.preview.ui.ModelingPage", [rmpw.jazz.ModelingPage], {

    	configuration: new rmpw.dsv.editor.preview.ui.Configuration(),
    	
    	settings: [ { name: controls.GRID, display: true, enabled: false, id: "rmpw.diagrams.GridToggle" },
    	            { name: controls.ANIMATION, display: true, enabled: true, id: "rmpw.diagrams.AnimationToggle" },
                    { name: controls.OUTLINE, display: true, enabled: true, id: "rmpw.diagrams.OutlineToggle" },
                    { name: controls.OBSTRUCTIONS, display: true, enabled: true, id: "rmpw.diagrams.AvoidObstructionsToggle" }],

        tools: [ { name: controls.ZOOM, display: true, enabled: true },
    	         { name: controls.FILEPICKER, display: true, enabled: true }, 
                 { name: controls.RELOAD_DIAGRAM_CONTENT, display: true, enabled: true },
    	         { name: controls.INTERPRETATION_PICKER, display: true, enabled: true },
                 { name: controls.RELOAD_DIAGRAM_CODE, display: true, enabled: true },
                 { name: controls.UNDO, display: true, enabled: true },
                 { name: controls.REDO, display: true, enabled: true },
                 { name: controls.LAYOUT, display: true, enabled: true },
                 { name: controls.SETTINGS, display: true, subcontrols: this.settings }],
        
    	prefix: "rmpw.dsv.editor.preview",
    	
    	postCreate: function(){
           var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
           ActionRegistry.registerAction("rmpw.dsv.editor.preview.ui.startup", this, "startup"); 
                   
           this.resizer = jazz.util.ResizeNotifier.register({
			  context: this,
	          callback: this.resize,
	          force: true    	        
	       }); 
        },
        
        startup : function() {
			this.resize();
		},
        
        resize : function() {
			var s = dojo
			.marginBox("jazz_app_internal_Navbar_0");
			if (this.layout == null) {
				var options = {
						size : s,
						configuration : this.configuration,
						tools : this.tools,
						settings : this.settings,
						prefix : this.prefix
				};

				this.layout = new rmpw.jazz.ui.Layout(options);

				if (this.load) {
					this.layout.loadDiagram = this.load;
				}

				if (this.save) {
					this.layout.saveDiagram = this.save;
				}

				this.hiJazzAttachPoint
				.appendChild(this.layout.domNode);
				this.layout.layout();
				this.layout.resize(s);
				this.extend();
			} else {
				var s = dojo
				.marginBox(this.hiJazzAttachPoint.parentNode);
				var navBar = dojo.coords(dojo
						.byId("jazz_app_internal_Navbar_0"));
				var scc = dojo.marginBox(dojo
						.byId("content-cell"));
				s.h = scc.h - navBar.h;
				s.w = navBar.w;
				this.layout.resize(s);
			}
		}
    });
    
})();