/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.dsv.editor.behavior.ui.ToolListEditor");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");
dojo.require("dijit._Contained");

dojo.require("rmpw.dsv.editor.behavior.ui.ToolEditor");

dojo.declare("rmpw.dsv.editor.behavior.ui.ToolListEditor", [dijit._Widget, dijit._Templated, dijit._Container, dijit._Contained], {
	templateString:
		"<div>" +
			"<div dojoAttachPoint='containerNode'></div>" +
			"<input dojoAttachPoint='addButtonNode'>" +
		"</div>",
	
	postCreate: function() {
		var createPolicyButton = new dijit.form.DropDownButton({
			iconClass: "plusIcon",	// TODO (MG): make this work
			label: "Add Tool",
			dropDown: this._createPolicyMenu()
		}, this.addButtonNode);
		
		if(this.controller.tools) {
			var tools = this.controller.tools;
			for(var i = 0, tool; tool = tools[i]; i++) {
				this._createToolEditor(tool);
			}
		}
	},
	
	_createPolicyMenu: function() {
		var tools = dojo.filter(this.tools.getSubClassesOf("Tool"), function(eClassifier) {
			return !eClassifier["abstract"]; // abstract is a reserved word
		});
		
		// build menu
		var menu = new dijit.Menu();
		for(var i = 0, tool; tool = tools[i]; i++) {
			var item = new dijit.MenuItem({
				label: tool.name,
				title: tool.description,
				data: tool,
				onClick: dojo.hitch(this, function(e) {
					this._createTool(dijit.byId(e.currentTarget.id).data);
				})
			});
			menu.addChild(item);
		}
		return menu;
	},
	
	_createTool: function(toolClass) {
		var tool = { eClass: toolClass };
		if(!this.controller.tools) {
			this.controller.tools = [];
		}
		this.controller.tools.push(tool);
		this._createToolEditor(tool);
	},
	
	_createToolEditor: function(tool) {
		var toolEditor = new rmpw.dsv.editor.behavior.ui.ToolEditor({
			tool: tool
		});
		this.addChild(toolEditor);
	}
});
