/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.ProjectLinkingEditorInput");

dojo.require("rmps.ui.editor.EditorInput");
dojo.require("dojox.encoding.digests.MD5");

dojo.require("rmps.core.process.SecurityClient");
dojo.require("rmps.app.ui.ProjectLinkingEditorUtil");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmps.app.ui.internal", "ProjectLinkingEditorInputMessages");
var messages= dojo.i18n.getLocalization("rmps.app.ui.internal", "ProjectLinkingEditorInputMessages");

var ProcessConstants = rmps.app.ui.ProjectLinkingEditorUtil.process;
var SecurityClient = rmps.core.process.SecurityClient;
var ProjectLinkingEditorUtil= rmps.app.ui.ProjectLinkingEditorUtil;

dojo.declare("rmps.app.ui.internal.ProjectLinkingEditorInput", rmps.ui.editor.EditorInput, {

	projectId: null,

	constructor: function(projectId, mediator) {
		this.projectId = projectId;
		this.mediator= mediator;
	},

	load: function() {
		var deferred = SecurityClient.isActionAllowed(
			ProcessConstants.Operations.LINK_TYPE,
			dojo.getObject("jazz.app.currentApplication").context,
			[
				ProcessConstants.Actions.CREATE,
				ProcessConstants.Actions.MODIFY,
				ProcessConstants.Actions.DELETE
			]);
		deferred.addCallback(this, function(report) {
			this.operationReport = report;
			return this;
		});
		return deferred;
	},

	isLoaded: function() {
		return this.operationReport != null;
	},

	unload: function() {
		delete this.operationReport;
	},

	getId: function() {
		return dojox.encoding.digests.MD5(this.declaredClass + ',' + this.projectId);
	},

	getName: function() {
		return messages.editor_name;
	},

	getBasePresentationUri: function()  {
		return ProjectLinkingEditorUtil.baseUrl;
	}
});

})();
