/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("dm.review.app.ui.internal.dialogs.ChangeParticipantsForm");
dojo.require("dojo.i18n");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.Form");

dojo.require("jazz.ui.Dialog");

dojo.require("rmps.ui.DialogForm");
dojo.require("rmps.core.review.util.ReviewTypes");

var ReviewTypes = rmps.core.review.util.ReviewTypes;

dojo.requireLocalization("dm.review.app.ui.internal.dialogs", "ChangeParticipantsFormMessages");


dojo.declare("dm.review.app.ui.internal.dialogs.ChangeParticipantsForm",rmps.ui.DialogForm, {
	
	templateString: dojo.cache("dm.review.app", "ui/internal/dialogs/templates/ChangeParticipantsForm.html"),
	
	widgetsInTemplate: true,
	
	selectedParticipantRoleType: null,
	_changeParticipantsForm: null,
	_approverRadioButton: null,
	_optionalReviewerRadioButton: null,
	_okButtonNode: null,
	_cancelButtonNode: null,
	_messages: null, 

	postCreate: function() {
		this.inherited("postCreate", arguments);
/*		this.connect(this._reviewerRadioButton, "onClick",
			function() {
				this.selectedParticipantRoleType =
					rmps.core.review.util.ReviewTypes.PARTICIPANT_ROLE_TYPES.RequiredReviewer
		});*/
		this.connect(this._approverRadioButton, "onClick",
			function() {
				this.selectedParticipantRoleType =
					rmps.core.review.util.ReviewTypes.PARTICIPANT_ROLE_TYPES.Approver;
		});
		this.connect(this._optionalReviewerRadioButton, "onClick",
			function() {
				this.selectedParticipantRoleType =
					rmps.core.review.util.ReviewTypes.PARTICIPANT_ROLE_TYPES.OptionalReviewer;
		});
		this._approverRadioButton.attr("checked", true);
		this.selectedParticipantRoleType =
			rmps.core.review.util.ReviewTypes.PARTICIPANT_ROLE_TYPES.Approver;
	},
	
	postMixInProperties: function() {			
		this._messages = dojo.i18n.getLocalization("dm.review.app.ui.internal.dialogs",
					"ChangeParticipantsFormMessages");
	},

	show: function() {	
		this.inherited(arguments);				
		this._approverRadioButton.focus();
	},
	
	getDialogArguments: function(){
		return {
			contentNode: this._changeParticipantsForm,
			primaryTitle: this._messages.changeParticipantsTitle,
			destroyContents: true,
			width: "270px"
		};
	}
});

})();
