/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.xtools.rmps.web.reports                                        |
 *|                                                                        |
 *| Copyright IBM Corporation 2011, 2012.  All Rights Reserved.            |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
// NLS_CHARSET=UTF-8
// NLS_MESSAGEFORMAT_VAR
({
	// Error messages
	errorCreatingReport:	"The new report could not be created.",
	errorDeletingFolder:	"Could not delete the folder '${0}'.",
	errorDeletingReport:	"Could not delete the report '${0}'.",
	errorDeletingTemplate:	"Could not delete the report template '${0}'.",
	errorInvalidTemplate:	"A Rational Publishing Engine template design file has an\r\n" +
							"extension .dta but the selected template file does not.\r\n" +
							"The report generation engine may not support this template.\r\n\r\n" +
							"Are you sure you want to use the template file '${0}'?",
	errorLoadingFolders:	"One or more report folders could not be loaded.",
	errorLoadingParameters:	"The parameters for the current report could not be loaded.",
	errorLoadingParamValue:	"The parameter values for ${0} could not be loaded.",
	errorLoadingReports:	"One or more reports could not be loaded.",
	errorLoadingTemplates:	"One or more report templates could not be loaded.",
    errorNoReportID:		"The Report Editor was not initialized properly.",
    errorNoReportIDDetails: "The Report Editor URL did not contain the 'queryUUID' parameter which specifies the report to edit.",
	errorNoSystemFolders:	"Neither the private or shared system folders could be loaded.",
	errorParsingUploadData:	"The file upload response could not be parsed.",
	errorRestoringContent:	"The contents (template) of the report template could not be restored.",
	errorRestoringInvalid:	"You cannot restore contents for a new report template or a user created report template.",
	errorRunningReport:		"The running of the report could not be completed.",
	errorSavingFolder:		"The folder could not be saved.",
	errorSavingReport:		"The report could not be saved.",
	errorSavingTemplate:	"The report template could not be saved.",
	errorUploadingFile:		"Error uploading file: ${0}",
	
	// Strings common to multiple report pages.
	actions: "Actions", 
	cancel:  "Cancel",
	close:   "Close",
	create:  "Create",
	deleteMsg: "Delete", // Note: do NOT use 'delete' as it is a reserved word
	edit: "Edit",
	name: "Name: ",
	ok:   "OK",
	run:  "Run",
	save: "Save",
	saveSuccessful: "Saved Successfully",
	
	
	// DM Reports menu
	browseTemplates:	"Report Templates",
	browseReports:		"Reports",
    createTemplate:		"Report Template",
    createReport:		"Report",
	
	// Welcome page
	viewReportsTitle:	"Browse reports",
	viewReportsText:	"Browse the list of reports that are available for the project. " +
						"Select a report and view its details or run the report. You can " +
						"also create reports.",
	viewTemplatesTitle: "Browse report templates",
	viewTemplatesText:  "Browse the list of available report templates. A report template defines " +
						"the layout that is required to run a report. You can also create " +
						"report templates or deploy predefined templates.",
	
	// TemplateBrowser page
	templateBrowserName: "Report Templates",
	confirmDeleteTemplate:	"Deleting a report template will also delete all reports based on that template.\r\n\r\n" +
							"Are you sure you want to delete the report template '${0}'?",
	createNewTemplate: "Create Report Template",
	deleteTemplateSuccess: "Successfully deleted the report template '${0}'.",
	noTemplatesFound: "No report templates were found.",
	searchingReportTemplates: "Searching for report templates ...",
	templateName: "Report Template",
	templateDescription: "Description",
	templateComboPrivate: "Show my private templates",
	templateComboShared:  "Show only shared templates",
	templateComboAll:     "Show all available templates",
	
	// DeployTemplates editor
	deployPredefinedTemplates: "Deploy predefined Report Templates",
	deployTemplatesInfo: "The table below lists the available predefined report templates that can be deployed into the project area. " +
						 "Select the templates you want to deploy and click Save. They will be added as shared templates in the Report Templates browser.",
	deployTemplateName:	"Template Name",
	
	// TemplateEditor page
	confirmDeleteResource: "Are you sure you want to delete the file '${0}'?",
	contentsHeading: "Contents",
	contentsInfo:	"Select a Rational Publishing Engine template file (*.dta) to set as the contents of this report template, " +
					"which can be used to generate document-style reports.",
	contentsRestoreInfo: "If this is a predefined report template, you can restore its original template contents.",
	contentsRestoreInitial: "Restore Initial Contents",
	contentsRestored: "The report template has been restored to its initial contents.",
	generalHeading: "General",
	generalDescription: "Description:",
	generalIdentifier: "Identifier:",
	generalIdentifierInfo: "Specify a unique identifier for this report template.",
    newTemplateName: "(new report template)",
	templateDescriptionText: "${0} Report Template",
	resourceHeading: "File",
	resourceAdd: "Add File",
	resourcesHeading: "Additional Files",
	resourcesInfo: "Associate additional files to be used by this report template. Select a local file to upload.",
	resourceClickToEdit: "Click to edit file name",
	resourceStatus: "Modified",
	resourceStatusModified: "*",
	selectAResource:	"Select a local file to upload and associate with the report template.",
	successUploadingFile: "Successfully uploaded file: ${0}",
	templateShared: " Share report template with other users",
	templateSaving: "Saving report template ...",
	uploadNewContent: "Upload New Content",
	
	
	// ReportBrowser page
	reportBrowserName:	"Reports",
	collapseAll:		"Collapse All",
	confirmDeleteFolder:	"Deleting a folder will also delete all nested folders and reports.\r\n\r\n" +
							"Are you sure you want to delete the folder '${0}'?",
	confirmDeleteReport: "Are you sure you want to delete the report '${0}'?",
	createNewReport: "Create Report",
	createNewFolder: "Create Folder",
	deleteFolderSuccess: "Successfully deleted the folder '${0}'.",
	deleteReportSuccess: "Successfully deleted the report '${0}'.",
	expandAll:			"Expand All",
	reportComboPrivate: "Show my private reports",
	reportComboShared:  "Show only shared reports",
	reportComboAll:     "Show all available reports",
	searchingReports:   "Searching for reports ...",
	
	// FolderDialog page
	folderDialogName: "Folder",
	folderName: "Name:",
	folderDescription: "Description:",
	
	//CreateReport page
	createReportName:	"Create a Report",
	foldersHeading:		"Select a folder:",
	foldersInfo:		"Create and select a nested folder of either 'My Reports', for private reports, or 'Shared Reports'.",
	reportName:			"Name:",
	reportDescription:	"Description:",
	templateFolderConflict: "You cannot create a shared report using a private report template.\r\n\r\n" +
							"Choose a private folder from the 'My Reports' hierarchy.",
    templatesHeading:	"Select a report template:",
	templatesInfo:		"If a nested folder of 'Shared Reports' is selected, you must select a shared report template.",
    
    // ReportEditor
    loadingReport:	"Loading the report ...",
    
	// Report editor overview tab
    // defined by CreateReport: reportDescription, templateFolderConflict
	folderInfoSectionTitle:	"Parent folder",
	reportTabOverview:	"Overview",
	resetFolder:		"Undo folder selection",
	resourcePrivate: 	"(private)",
	resourceShared: 	"(shared)",
	templateAlreadyShared:	"You cannot change a shared report into a private report.\r\n\r\n" +
							"Choose a shared folder from the 'Shared Reports' hierarchy.",
	templateInfoSectionTitle:	"Associated report template",

	// Report editor output tab
	exportLabel:		"Export ...",
	reportTabOutput:	"Output",
	reportRunStart:		"Click the Run button to start the report generation.",
	reportRunning:		"Running the report. Please wait ...",
	viewPrintablePage:	"View Report in Printable Page",
	warnExportNotNow:	"An export cannot be performed now. Please run a report first.",
	warnExportSaveNow:	"Before you can export the report, you must save the parameters.",
		

	// Report editor parameters tab
	reportTabParams:		"Parameters",
    loadingReportParams:	"Loading the report parameters ...",
	paramNameHeading:		"Parameter",
	paramValueHeading:		"Value",
	useTemplateMetadata:	"Edit parameters using search and browse",

	
	// ExportDialog page
	exportDialogName: "Select the report format to export",
	
	end_of_file_message: "dummy message"

})