dojo.provide('ibm_ilog.diagram.util.Assert');

dojo.require('ibm_ilog.diagram.util.ErrorReporter');

(function(){
	
	var a = ibm_ilog.diagram.util.Assert;

	// TODO comment.
	//
	//	Check Viewport.js for example.
	//
	//	The check and assert functions must be replaced but null functions for release deployments
	//
	//	Note: can't reference local vars, only vars through "this".
	
	if(typeof(djConfig) !== 'undefined' && djConfig.isDebug && dojo.isMozilla) {
	
		//
		// Tested Ok on Mozilla.
		//
		// Does not work on Chrome due to this chrome behavior:
		//
		//	 eval("this") -> this
		//	 check = eval;
		//	 check("this") -> window
		//

		a.check = eval;
		
		a.buildPredicate = function( methodName, e, args ) {
			var r = ""+ 
				"(dojo.hitch(this, function(r){" + 
					"if (!r) {" +
					"var R = ibm_ilog.diagram.util.ErrorReporter;" + 
						"R."+methodName+".apply(R,Array.prototype.slice.call(arguments,1));"+
					"}" +
					"return r;" +
				"}, ("+e+")";
			
			for(var i=1;i<args.length;i++) {
				r+= ", \"" + args[i].replace(/"/g, "\\\"") + "\"";
			}
	
			r+="))();";
	 
			return r;
		}
		
		a.assert = function(e) {
			return a.buildPredicate("error",e,arguments);
		};

		a.verify = function(e) {
			return a.buildPredicate("warn",e,arguments);
		};
		
	} else {
		//
		// Disable everything on debug
		//
		a.check = a.assert = function(){};
	}
})();