dojo.provide('ibm_ilog.diagram.widget.ScrollbarInteractor');

dojo.require('ibm_ilog.diagram.interactors.DragInteractor');
dojo.require('ibm_ilog.diagram.util.Geometry');
dojo.require('ibm_ilog.diagram.util.ErrorReporter');
dojo.require('ibm_ilog.diagram.util.GraphUtil');

(function() {
	var R = ibm_ilog.diagram.util.ErrorReporter;
	var g = ibm_ilog.diagram.util.Geometry,	 Rect = g.Rect, EmptyRect = g.EmptyRect, Size = g.Size, PointZero = g.PointZero, Point = g.Point;
	var gu = ibm_ilog.diagram.util.GraphUtil;
	
dojo.declare("ibm_ilog.diagram.widget.ScrollbarInteractor",[ibm_ilog.diagram.interactors.DragInteractor], {

	initialize: function( /*ibm_ilog.diagram.widget.Viewport*/viewport, /*ibm_ilog.diagram.widget.ScrollbarHudComponent*/ scrollbar ) {
		this._viewport = viewport;
		this._scrollbar = scrollbar;
		this._initialize();
		
		return this;
	},
	
	_declareStates: function () {
		this._declareState("idle", ["fit","start"]);
		this._declareState("active", ["first", "move", "end", "cancelOnDragStart", "cancelOnSelectStart"]);
	},
	
	getDefaultConnections: function() {
		var cs = this.inherited(arguments);
		cs.fit = {
				src: this._getInitialEventSource(),
				srcEvt: "onmousedown",
				connectTo: "_fitContents",
				filter: this._buildInputFilter({shift:true,button:0}),
				gfxConnect:true
			};
		return cs;
	},

	_getInitialEventSource: function() {
		return this._scrollbar._handle; 
	},
	
	_fitContents: function(e) {
		this._viewport.setViewRect(this._viewport.getContentRect());
	},

	_dragPreStart: function(e) {
		var v = this._viewport;
		this.inherited(arguments);
		this._firstViewRect = v.getViewRect();
	},
    
	_dragMove: function(e) {
    this.inherited(arguments);

    var P = this._scrollbar._posName;
    // scale delta to zoom level to get delta in model coords
    var delta = {};
    delta[P] = this._totalDelta[P];
    var panDelta = g.mulPoint(delta,this._scrollbar.getRatio());
		
    this._viewport.setViewRect( g.moveRect(this._firstViewRect,panDelta), {instant:true} );
  },
	
	_dragEnd: function(e) {
		//
		//	summary:
		//		Terminates the current panning process.
		//
		var v = this._viewport;
		var dragged = this.hasDragged; // inherited will clear this;
		this.inherited(arguments); // clears hadDragged
		if(!dragged) {
			this._viewport.centerAt(this.eventViewportLocation(e));
		}
	}
    
});

})();